#ifndef BOT_H
#define BOT_H
#ifdef ROBOT_MODE

extern int borgAutoTorpDist;
extern int botTempVariable;
extern int borgAutoPhaserDist;
extern int botAutoQuit;
extern int botPlanetTaker;
extern int botBomber;
extern int botPlaySB;
extern int botAvoidTorpDistance;
extern int botDebug;
extern int botEjectable;

#define PI		3.141592654
#define PHASEDIST 6000   /* taken from server code */
#define PFIREDIST 1500	/* At this range a planet will shoot at a player */
#define EXPDIST 350      /* taken from server code */
#define BOTDETDIST 1700  /* taken from server code */
#define ENTORBDIST 900	/* At this range a player can orbit a planet */
#define DAMDIST 2000     /* taken from server code */
#define TRACTDIST   6000 /* taken from server code */
#define SHIPDAMDIST 3000 /* taken from server code */
#define PIGCALL "     "
#define NORMALIZE(d)	 ( ( ((int) (d)) + 2560) % 256)
#define pointWithinSquare(point,center,sqSize) ( (ABS((point)->x - (center)->x) < (sqSize)) && (ABS((point)->y - (center)->y) < (sqSize)) && (point)->x >= 0 && (point)->y >= 0 && (center)->x >= 0 && (center)->y >= 0)
#define set_bot_speed(s) botDesiredSpeed=(s); set_speed( (s) )
#define botMaxTurn(s) ( (s) > 0 ? (me->p_ship.s_turns / (1 << (s)) / 1000.0) : 128 )
#define MIN(a,b)		((a) < (b) ? (a) : (b))
#define shipCloaked( p )  ((p)->p_flags & PFCLOAK )
#define shipOrbitting( p )  ((p)->p_flags & PFORBIT )
#define corePlanet( p )  ( pointWithinSquare( &botUniverse[0].planets[(p)->pl_no].point, &botUniverse[0].planets[(p)->pl_no - ((p)->pl_no % 10)].point, 15000.0) )
#define myCorePlanet( p )  ( corePlanet( p ) && 1 + (p)->pl_no / 10 == remap[me->p_team] )
#define liveTorp( t ) ( ((t)->t_status == TMOVE || (t)->t_status == TSTRAIGHT) && (t)->t_x >= 0 && (t)->t_y >=0 )
#define totalRating( p ) ( bombingRating(p) + offenseRating(p) + planetRating(p) )

/* stuff for strategy */
#define ST_BOMB 1
#define ST_GUARD 2
#define ST_OGG 3
#define ST_ESCORT 4
#define ST_TAKE 5
#define ST_GET 6
#define ST_REPLENISH 7
#define ST_REFIT 8
#define ST_WAIT 9

typedef struct {
    int x;
    int y;
    int interpolated;
    int time;
    double distance;
    unsigned char angle;
} BOT_POINT;

typedef struct {
    BOT_POINT point;
    unsigned char direction;
    int armies_known;
    int armies_suspected;
    int speed;
    int dir;
    int tractorEnemy;
    int pressorEnemy;
} BOT_PLAYER_STATUS;

typedef struct {
    BOT_POINT point;
} BOT_TORP_STATUS;

typedef struct {
    BOT_POINT point;
} BOT_PLASMA_STATUS;

typedef struct {
    BOT_POINT point;
    int armies;
    int planetType;
    int team;
} BOT_PLANET_STATUS;

typedef struct {
    BOT_PLAYER_STATUS players[MAXPLAYER];
    BOT_TORP_STATUS torps[MAXPLAYER*MAXTORP];
    BOT_PLASMA_STATUS plasmas[MAXPLAYER*MAXPLASMA];
    BOT_PLANET_STATUS planets[MAXPLANETS];
} BOT_UNIVERSE;

typedef struct {
    unsigned char angle;
    int index;
    int pressorEnemy;
    int tractorEnemy;
    int speed;
    double deltaDir;
    int damage;
    int dodgeDamage;
} BOT_DIRECTION;

typedef struct {
    unsigned char angle;
    int escortPlayer;
    int player;
    int planet;
    int x;
    int y;
    int engageEnemy;
    int plan;
    double rating;
} BOT_STRATEGY;

void botDumpUniverse( FILE * );
int botRecordUniverse();
void botInitializeUniverse();
int botTorpOrbittingEnemy(struct player *, int, int);
int botTorpEnemy(struct player *, int, int);
int botPhaserEnemy( struct player * );
double botDistanceFromMe( BOT_POINT * );

#endif
#endif
