#ifdef ROBOT_MODE
/* bot.c */

#include "copyright.h"

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>
#include "netrek.h"
#include "bot.h"
#include <sys/resource.h>
#include <sys/stat.h>

void botHandleTractorPressor( int *, int * );


#define LOGIN_AS_GUEST
#undef TORPDEBUG

#define SENDPIG
/* #define PRINTMESSAGES */

#define EJECTNUMBER 4

/* variables that are set by user - plus the best default settings (IMHO) */
int borgAutoTorpDist = 14;
int borgAutoPhaserDist = 25;
int botAutoQuit = 0;
int botBomber = 1;
int botPlanetTaker = 1;
int botPlaySB = 0;
int botAvoidTorpDistance = 50;
int botEjectable = 1;
int botDebug = 0;
int botTempVariable = 150;

/* variables that are set inside of this code */
int borgVectorTorpSpeed = 0;
int borgDelay = 0;
int botWaitQueue = 0;
int botTeam = 0;
int botWaitForSBTime = 0;

int botDesiredSpeed = 0;
int botDesiredCourse = -1;
int botSubSpeed = 0;

static int botEjectList[MAXPLAYER];
static char botEjectNames[MAXPLAYER][33];

unsigned int botTimeCounter = 0;
int botPacketReceived = 0;
BOT_UNIVERSE botUniverse[3];
/* 0 = current position and status */
/* 1 = previous position and status */
/* 2 = oldest - this is needed for cloakers */

struct rusage botRUsage;

botTime( char *timebuf )
{
  struct tm *tm;
  time_t curtime;
  
  curtime = time(NULL);

  tm = localtime(&curtime);
  timebuf[0] = tm->tm_hour / 10 + '0';
  timebuf[1] = (tm->tm_hour % 10) + '0';
  timebuf[2] = ':';
  timebuf[3] = tm->tm_min / 10 + '0';
  timebuf[4] = (tm->tm_min % 10) + '0';
  timebuf[5] = ':';
  timebuf[6] = tm->tm_sec / 10 + '0';
  timebuf[7] = (tm->tm_sec % 10) + '0';
  timebuf[8] = '\0';
}


void botPrintStatus(int flag)
{
  static char buf1[80];
  static char buf2[80];
  static char whichbuf = 0;
  char *buf, *oldbuf;
  char *s;
  int i, j;
  struct  player *plr;

#ifndef PRINTMESSAGES
  return;
#endif

  printf( "Flags        Warp Dam Shd Torps  Kills Armies   Fuel  Wtemp Etemp  Time\n");
  if ((me->p_flags & (PFPLOCK | PFOBSERV)) == (PFPLOCK | PFOBSERV))
    plr = players + me->p_playerl;
  else
    plr = me;


  /* Instead of one sprintf, we do all this by hand for optimization */

  if (flag)
    whichbuf = 0;				 /* We must completely
						  * refresh */

  if (whichbuf != 2)
    {
      buf = buf1;
      oldbuf = buf2;
    }
  else
    {
      buf = buf2;
      oldbuf = buf1;
    }
  buf[0] = (me->p_flags & PFSHIELD ? 'S' : ' ');
  if (me->p_flags & PFGREEN)
    buf[1] = 'G';
  else if (me->p_flags & PFYELLOW)
    buf[1] = 'Y';
  else if (me->p_flags & PFRED)
    buf[1] = 'R';
  buf[2] = (me->p_flags & (PFPLLOCK | PFPLOCK) ? 'L' : ' ');
  buf[3] = (me->p_flags & PFREPAIR ? 'R' : ' ');
  buf[4] = (me->p_flags & PFBOMB ? 'B' : ' ');
  buf[5] = (me->p_flags & PFORBIT ? 'O' : ' ');
  if (me->p_ship.s_type == STARBASE)
    buf[6] = (me->p_flags & PFDOCKOK ? 'D' : ' ');
  else
    buf[6] = (me->p_flags & PFDOCK ? 'D' : ' ');
  buf[7] = (me->p_flags & PFCLOAK ? 'C' : ' ');
  buf[8] = (me->p_flags & PFWEP ? 'W' : ' ');
  buf[9] = (me->p_flags & PFENG ? 'E' : ' ');
  if (me->p_flags & PFPRESS)
    buf[10] = 'P';
  else if (me->p_flags & PFTRACT)
    buf[10] = 'T';
  else
    buf[10] = ' ';
  if (me->p_flags & PFBEAMUP)
    buf[11] = 'u';
  else if (me->p_flags & PFBEAMDOWN)
    buf[11] = 'd';
  else
    buf[11] = ' ';
  buf[12] = (status->tourn) ? 't' : ' ';
  buf[13] = ' ';
  buf[14] = '0' + ((me->p_speed % 100) / 10);
  if (buf[14] == '0')
    buf[14] = ' ';
  buf[15] = '0' + (me->p_speed % 10);		 /* speed */
  buf[16] = ' ';
  buf[17] = ' ';
  buf[18] = '0' + (me->p_damage / 100);
  if (buf[18] == '0')
    buf[18] = ' ';
  buf[19] = '0' + ((me->p_damage % 100) / 10);
  if ((buf[19] == '0') && (me->p_damage < 100))
    buf[19] = ' ';
  buf[20] = '0' + (me->p_damage % 10);
  buf[21] = ' ';
  buf[22] = '0' + (me->p_shield / 100);
  if (buf[22] == '0')
    buf[22] = ' ';
  buf[23] = '0' + ((me->p_shield % 100) / 10);
  if ((buf[23] == '0') && (me->p_shield < 100))
    buf[23] = ' ';
  buf[24] = '0' + (me->p_shield % 10);
  buf[25] = ' ';
  buf[26] = ' ';
  buf[27] = '0' + ((plr->p_ntorp % 100) / 10);
  if (buf[27] == '0')
    buf[27] = ' ';
  buf[28] = '0' + (plr->p_ntorp % 10);
  buf[29] = ' ';
  buf[30] = ' ';
  buf[31] = ' ';
  buf[32] = ' ';
  buf[33] = '0' + ((int) (plr->p_kills / 10));
  if (buf[33] == '0')
    buf[33] = ' ';
  buf[34] = '0' + (((int) plr->p_kills) % 10);
  buf[35] = '.';
  buf[36] = '0' + (((int) (plr->p_kills * 10)) % 10);
  buf[37] = '0' + (((int) (plr->p_kills * 100)) % 10);
  buf[38] = ' ';
  buf[39] = ' ';
  buf[40] = ' ';
  buf[41] = ' ';
  buf[42] = '0' + ((me->p_armies % 100) / 10);
  if (buf[42] == '0')
    buf[42] = ' ';
  buf[43] = '0' + (me->p_armies % 10);
  buf[44] = ' ';
  buf[45] = ' ';

  buf[46] = '0' + (me->p_fuel / 100000);
  if (buf[46] == '0')
    buf[46] = ' ';
  buf[47] = '0' + ((me->p_fuel % 100000) / 10000);
  if ((buf[47] == '0') && (me->p_fuel < 100000))
    buf[47] = ' ';
  buf[48] = '0' + ((me->p_fuel % 10000) / 1000);
  if ((buf[48] == '0') && (me->p_fuel < 10000))
    buf[48] = ' ';
  buf[49] = '0' + ((me->p_fuel % 1000) / 100);
  if ((buf[49] == '0') && (me->p_fuel < 1000))
    buf[49] = ' ';
  buf[50] = '0' + ((me->p_fuel % 100) / 10);
  if ((buf[50] == '0') && (me->p_fuel < 100))
    buf[50] = ' ';
  buf[51] = '0' + (me->p_fuel % 10);
  buf[52] = ' ';
  buf[53] = ' ';
  buf[54] = ' ';

  buf[55] = '0' + ((me->p_wtemp / 10) / 100);
  if (buf[55] == '0')
    buf[55] = ' ';
  buf[56] = '0' + (((me->p_wtemp / 10) % 100) / 10);
  if ((buf[56] == '0') && (me->p_wtemp < 1000))
    buf[56] = ' ';
  buf[57] = '0' + ((me->p_wtemp / 10) % 10);

  buf[58] = ' ';
  buf[59] = ' ';
  buf[60] = ' ';

  buf[61] = '0' + ((me->p_etemp / 10) / 100);
  if (buf[61] == '0')
    buf[61] = ' ';
  buf[62] = '0' + (((me->p_etemp / 10) % 100) / 10);
  if ((buf[62] == '0') && (me->p_etemp < 1000))
    buf[62] = ' ';
  buf[63] = '0' + ((me->p_etemp / 10) % 10);

  if (whichbuf == 0)
    {
      /* Draw status line */
	printf("%s\n", buf);
    }
  else
    {						 /* Hacks to make it print
						  * only what is necessary */
      whichbuf = 3 - whichbuf;
      j = -1;
      for (i = 0; i < 64; i++)
	{
	  if (*(buf++) != *(oldbuf++))
	    {
	      /* Different string */
	      if (j == -1)
		{
		  s = buf - 1;
		}
	      j = 0;
	    }
	  else
	    {
	      /* Same string */
	      if (j == -1)
		continue;
	      j++;
	      if (j == 20)
		{				 /* Random number */
		    printf("%s\n", s);
		  j = -1;
		}
	    }
	}
      if (j != -1)
	{
	  printf("%s\n", s );
	}
    }
}

/* this loads all sorts of useful data into a distress struct. */
struct distress *
        botLoadDistress(enum dist_type i, BOT_STRATEGY *strategy)
{
  struct distress *dist;
  struct obtype *target;

  dist = (struct distress *) malloc(sizeof(struct distress));

  dist->sender = me->p_no;
  dist->dam = (100 * me->p_damage) / me->p_ship.s_maxdamage;
  dist->shld = (100 * me->p_shield) / me->p_ship.s_maxshield;
  dist->arms = me->p_armies;
  dist->fuelp = (100 * me->p_fuel) / me->p_ship.s_maxfuel;
  dist->wtmp = (100 * me->p_wtemp) / me->p_ship.s_maxwpntemp;
  /* wtmp can be more than 100% - dont let it wrap */
  if (dist->wtmp > 0x7f)
    {
      dist->wtmp = 0x7f;
    }
  dist->etmp = (100 * me->p_etemp) / me->p_ship.s_maxegntemp;
  /* so.. call me paranoid -jmn */
  dist->sts = (me->p_flags & 0xff) | 0x80;
  dist->wtmpflag = (me->p_flags & PFWEP) ? 1 : 0;
  dist->etempflag = (me->p_flags & PFENG) ? 1 : 0;
  dist->cloakflag = (me->p_flags & PFCLOAK) ? 1 : 0;

  dist->distype = i;
  if (dist->distype > generic || dist->distype < take)
    dist->distype = generic;

  target = gettarget2(me->p_x, me->p_y, TARG_PLANET);
  dist->close_pl = target->o_num;

  if ( strategy->planet >= 0 )
      dist->tclose_pl = strategy->planet;
  else
      dist->tclose_pl = dist->close_pl;
      
  target = gettarget2(me->p_x, me->p_y, TARG_ENEMY);
  dist->close_en = target->o_num;

  if ( strategy->player >= 0 && !friendlyPlayer( &players[strategy->player] ))
      dist->tclose_en = strategy->player;
  else
      dist->tclose_en = dist->close_en;
      
  target = gettarget2(me->p_x, me->p_y, TARG_FRIEND);
  dist->close_fr = target->o_num;

  if ( strategy->player >= 0 && friendlyPlayer( &players[strategy->player] ))
      dist->tclose_fr = strategy->player;
  else
      dist->tclose_fr = dist->close_fr;

  if ( strategy->plan == ST_ESCORT )
      dist->tclose_fr = strategy->escortPlayer;
      
  target = gettarget2(me->p_x, me->p_y, TARG_PLAYER);
  dist->close_j = target->o_num;

  if ( strategy->player >= 0 )
      dist->tclose_j = strategy->player;
  else
      dist->tclose_j = dist->close_j;

  /* lets make sure these aren't something stupid */
  dist->cclist[0] = 0x80;
  dist->preappend[0] = '\0';
  dist->macroflag = 0;

  return (dist);
}

botEmergency(enum dist_type i, BOT_STRATEGY *strategy)
{
  char    ebuf[200];
  struct distress *dist;
  char    cry[MSG_LEN];
  char   *info;
  int     len;
  int     recip;
  int     group;

  group = MTEAM;
  recip = me->p_team;

  dist = botLoadDistress(i, strategy);

  if (F_gen_distress)
    {
      /* send a generic distress message */
      Dist2Mesg(dist, ebuf);
      pmessage(ebuf, recip, group | MDISTR);
    }
  else
    {
      len = makedistress(dist, cry, distmacro[dist->distype].macro);

      if (len > 0)
	{

	  /* klude alert */
	  info = cry;

	  if (strncmp((char *) getaddr2(MTEAM, recip), cry, 8) == 0)
	    {
	      /* this means we should _strip_ the leading bit because it's
	       * redundant */
	      info = cry + 9;
	    }

	  pmessage(info, recip, group);
	}
    }

  free(dist);
}

double botMinimumDistance( int player, int speed, int finalSpeed, int turnRadius )
{
  /* assuming that the player stays still, what is the minimum
     distance that I should be from him assuming that I want to 
     avoid his torps.  Also, let's assume that I start at one speed
     and decelerate to finalSpeed
  */
  int tmpSpeed;
  int turnRate;
  int torpSpeed;
  int distance = 0;
  int distance2 = 0;
  int time;
  int enemySpeed;
  int enemyDogfightSpeed;
  int turns;
    
  time = 0;
  speed = speed * 1000 + 999;
  enemySpeed = Sin[ NORMALIZE( players[player].p_dir - me->p_dir ) ] * players[player].p_speed;

  turns = players[player].p_ship.s_turns / 8500;
  enemyDogfightSpeed = 0;
  
  while (turns > 1) {
    enemyDogfightSpeed++;
    turns = turns >> 1;
  }

  if ( enemyDogfightSpeed > players[player].p_ship.s_maxspeed ) {
    enemyDogfightSpeed = players[player].p_ship.s_maxspeed;
  }

  enemySpeed = enemySpeed * 1000 + 999;

  while ( turnRadius > 0 ) {
    time++;
    distance += players[player].p_ship.s_torpspeed + speed / 1000 + enemySpeed / 1000;
    distance2 += players[player].p_ship.s_torpspeed + speed / 1000;
    turnRadius -= botMaxTurn( speed / 1000 );
    if ( speed / 1000 > finalSpeed ) {
      speed -= me->p_ship.s_decint;
    }

    if ( enemySpeed / 1000 > enemyDogfightSpeed ) {
      enemySpeed -= players[player].p_ship.s_decint;
    }

    if (time > players[player].p_ship.s_torpfuse + 20)
      break;
  }

  if ( distance2 > distance )
    distance = distance2;

  return distance * WARP1;
}
  

void botPrintStrategy( BOT_STRATEGY *strategy )
{
    static BOT_STRATEGY previous_strategy;
    static BOT_STRATEGY previous_sent_strategy;
    char buf[1000];
    int whoTo = MINDIV;
    int dist = -1;
    int newStrategy = 0;
    
#ifndef PRINTMESSAGES
  return;
#endif

    if ( previous_strategy.planet == strategy->planet &&
	previous_strategy.player == strategy->player &&
	previous_strategy.plan == strategy->plan )
	return;

    previous_strategy = *strategy;
    
    if (botDebug) {
	botPrintStatus( 0 );
	printf("%c%c rating = %f\n",
	       teamlet[me->p_team], shipnos[me->p_no],
	       strategy->rating );
    }
    switch ( strategy->plan ) {
    case ST_REPLENISH:
	whoTo = MINDIV;
	if ( strategy->planet >= 0 && strategy->planet < MAXPLANETS)
	    sprintf(buf, "REPAIRING/REFUELING at %s - %f",
		    planets[strategy->planet].pl_name,
		    strategy->rating );
	else if (strategy->player >=0  && strategy->player < MAXPLAYER)
	    sprintf(buf, "REPAIRING/REFUELING at SB - %f",
		    strategy->rating);
	else
	    sprintf(buf, "REPAIRING/REFUELING in place - %f",
		    strategy->rating);
	break;
    case ST_BOMB:
	whoTo = MINDIV;
	if ( strategy->planet >= 0 && strategy->planet < MAXPLANETS &&
	    botDistanceFromMe( &botUniverse[0].planets[strategy->planet].point ) <
	    9000 ) {
	    dist = bombing;
	}
	sprintf(buf, "BOMBING %s - %f", planets[strategy->planet].pl_name,
		strategy->rating);
	break;
    case ST_TAKE:
	whoTo = MINDIV;
	dist = take;
	
	if ( strategy->planet >= 0 && strategy->planet < MAXPLANETS) {
	    sprintf(buf, "TAKING %s - %f", planets[strategy->planet].pl_name,
		    strategy->rating);
#if 0
	    if ( botDistanceFromMe( &botUniverse[0].planets[strategy->planet].point ) > 15000 ) {
		dist = carrying;
	    }
#endif
	}
	else
	    sprintf(buf, "TAKING unknown planet");
	break;
    case ST_GUARD:
	whoTo = MINDIV;
	if ( strategy->planet >= 0 && strategy->planet < MAXPLANETS) {
	    if (strategy->player >= 0 && strategy->player < MAXPLAYER) {
		sprintf(buf, "GUARDING %s against %c%c - %f",
			planets[strategy->planet].pl_name,
			teamlet[players[strategy->player].p_team],
			shipnos[strategy->player],
			strategy->rating);
	    }
	    else {
		sprintf(buf, "GUARDING %s - %f",
			planets[strategy->planet].pl_name,
			strategy->rating);
	    }
	}
	else
	    sprintf(buf, "GUARDING unknown planet");
	break;
    case ST_GET:
	whoTo = MINDIV;
	if ( strategy->planet >= 0 && strategy->planet < MAXPLANETS)
	    sprintf(buf, "GETTING armies from %s - %f",
		    planets[strategy->planet].pl_name,
		    strategy->rating);
	else
	    sprintf(buf, "GETTING armies from SB - %f",
		    strategy->rating);
	break;
    case ST_OGG:
	dist = ogging;
	if ( strategy->player >= 0 && strategy->player < MAXPLAYER ) {
	    sprintf(buf, "ATTACKING player %c%c - %f",
		   teamlet[players[strategy->player].p_team],
		   shipnos[strategy->player],
		    strategy->rating);
	    if (botUniverse[0].players[strategy->player].armies_suspected)
		whoTo = MTEAM;
	}
	else
	    sprintf(buf, "ATTACKING unknown player" );
	whoTo = MINDIV;
	break;
    case ST_ESCORT:
	whoTo = MINDIV;
	dist = escorting;
	if ( strategy->player >= 0 && strategy->player < MAXPLAYER )
	    sprintf(buf, "ESCORTING player %c%c - %f",
		   teamlet[players[strategy->escortPlayer].p_team],
		   shipnos[strategy->escortPlayer],
		    strategy->rating);
	else
	    sprintf(buf, "ESCORTING unknown player" );
	break;
    case ST_WAIT:
	whoTo = MINDIV;
	sprintf(buf, "WAITING for enemy planets to pop");
	
	break;
	
    default:
	sprintf(buf, "NO PLAN\n");
    break;
    }

    newStrategy = 0;
    if ( strategy->plan != previous_sent_strategy.plan )
	newStrategy = 1;
    else if ( strategy->plan == ST_TAKE ) {
	if ( dist == take )
	    newStrategy = 1;
    }
    else if ( strategy->plan == ST_GUARD ) {
	if (previous_sent_strategy.planet != strategy->planet )
	    newStrategy = 1;
    }
    else if ( strategy->plan == ST_ESCORT ) {
	if ( previous_sent_strategy.escortPlayer != strategy->escortPlayer )
	    newStrategy = 1;
    }
    else if ( previous_sent_strategy.planet != strategy->planet ||
	previous_sent_strategy.player != strategy->player )
	newStrategy = 1;
    
    if ( whoTo == MTEAM ) {
	if (newStrategy ) {
	    if (dist < 0)
		pmessage( buf, me->p_team, MTEAM );
	    else
		botEmergency( dist, strategy );
	    previous_sent_strategy = *strategy;
	}
    }
	
    if (botDebug) {
	if ( whoTo == MINDIV )
	    pmessage( buf, me->p_no, MINDIV );

	if ( dist < 0 )
	    printf( "%s\n", buf);
    }
}

int botEnemyTeam()
{
    int enemyTeam = -1;
    int numberOfEnemy;
    int i, j;
    
    numberOfEnemy = -1;
    for (i=0; i<NUMTEAM; i++) {
	if ( (1 << i) != me->p_team ) {
	    j = numShips( 1 << i );

	    if ( j > numberOfEnemy ) {
		numberOfEnemy = j;
		enemyTeam = i;
	    }
	    
	}
    }

    if ( enemyTeam >= 0 )
	return ( 1 << enemyTeam );
    else
	return 0;
}

int botEnemyThirdSpace()
{
    int enemyTeam;
    int i;
    int thirdSpace = -1;
    double distance;
    double distance2;
    
    enemyTeam = botEnemyTeam();
    distance = 1000000.0;
    for ( i=NUMTEAM-1; i>=0; --i ) {
	if ( remap[enemyTeam] - 1 == i )
	    continue;
	if ( remap[me->p_team] - 1 == me->p_team )
	    continue;

	distance2 =
	    hypot( (double) planets[(remap[enemyTeam]-1) * 10].pl_x -
		  planets[i * 10].pl_x,
		  (double) planets[(remap[enemyTeam]-1) * 10].pl_y -
		  planets[i * 10].pl_y );

	if (distance2 < distance) {
	    distance = distance2;
	    thirdSpace = i;
	}
    }

    if ( thirdSpace >= 0 )
	return ( 1 << thirdSpace );
    else
	return 0;
}

/* Compute the maximum number of armies this player can carry */
int botMaxArmies( struct player *player )
{
    int armies;
    
    if ( !player || !isAlive( player ) )
	return 0;
    
    if ( player->p_ship.s_type == STARBASE)
	armies = player->p_ship.s_maxarmies;
    else if ( player->p_ship.s_type == ASSAULT)
	armies = 3.0 * player->p_kills;
    else
	armies = 2.0 * player->p_kills;
    
    armies = MIN( armies, player->p_ship.s_maxarmies );
    
    return armies;
}

int botMaxSpeed()
{
    int maxspeed;
    int maxfuelSpeed;

    if (me->p_fuel < 2 * me->p_ship.s_warpcost * me->p_speed) {
	/* 
	 * Out of fuel ... set speed to one that uses less fuel
	 *  than the ship's reactor generates (if necessary).
	 */
	maxfuelSpeed = me->p_ship.s_recharge/me->p_ship.s_warpcost + 3;
	/* Above incantation is a magic formula ... (hack). */
	if (maxfuelSpeed > me->p_ship.s_maxspeed)
	    maxfuelSpeed = me->p_ship.s_maxspeed - 1;
    }
    else
	maxfuelSpeed = me->p_ship.s_maxspeed;
    
    maxspeed = (me->p_ship.s_maxspeed+2) -
	(me->p_ship.s_maxspeed+1)*
	    ((double)me->p_damage/ (double)(me->p_ship.s_maxdamage));
    maxspeed = MIN( maxspeed, maxfuelSpeed );
    maxspeed = MAX( maxspeed, 1 );
    
    return maxspeed;
}

int enemyTimeInDirection( int angle, int flyingTime, int ignorePlayer )
{
    int i,j;
    int enemyNear;
    int meDeltaX, meDeltaY;
    int enemyDeltaX, enemyDeltaY;
    int maxSpeed;
    BOT_POINT mePoint, enemyPoint;

    maxSpeed = botMaxSpeed();
    enemyNear = 0;
    meDeltaX = maxSpeed * Cos[angle] * WARP1;
    meDeltaY = maxSpeed * Sin[angle] * WARP1;
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !isAlive( &players[i] ) ||
	    friendlyPlayer( &players[i] ) ||
	    i == ignorePlayer )
	    continue;
	
	enemyPoint.x = botUniverse[0].players[i].point.x;
	enemyPoint.y = botUniverse[0].players[i].point.y;
	mePoint.x = botUniverse[0].players[me->p_no].point.x;
	mePoint.y = botUniverse[0].players[me->p_no].point.y;
	enemyDeltaX = botUniverse[0].players[i].speed * WARP1 *
	    Cos[botUniverse[0].players[i].dir];
	enemyDeltaY = botUniverse[0].players[i].speed * WARP1 *
	    Sin[botUniverse[0].players[i].dir];
	
	for (j=flyingTime; j>=0; --j) {
	    if ( pointWithinSquare( &enemyPoint,
				   &mePoint,
				   3000 ) )
		enemyNear += players[i].p_ship.s_phaserdamage / 10.0;
	    mePoint.x += meDeltaX;
	    mePoint.y += meDeltaY;
	    enemyPoint.x += enemyDeltaX;
	    enemyPoint.y += enemyDeltaY;
	}
    }
    return enemyNear;
}

botLogin(int *state, char *defname, char *tempname,
	 char *password1, char *password2 )
{
#ifdef LOGIN_AS_GUEST
    strcpy( defname, "guest" );
    strcpy( tempname, "guest" );
#else
    strcpy( defname, "FreeBot" );
    strcpy( tempname, "FreeBot" );
#endif
    strcpy( password1, "sdfwe" );
    strcpy( password2, "sdfwe" );

    switch (*state ) {
    case 0:
	loaddude();
	displayStartup(defname);
	break;
    case 1:
	checkpassword();
	displayStartup(defname);
	break;
    case 2:
	*state=3;
	displayStartup(defname);
	break;
    case 3:
	makeNewGuy();
	displayStartup(defname);
	break;
    }
}

void botParseWarning( char *text )
{
    int i;
    char *ptr;
    struct obtype *target;
    
#ifdef PRINTMESSAGES
#ifndef INCLUDE_X
    printf( "%s\n", text );
#endif
#endif

    if ( strstr(text, "Starbase") && strstr(text, "Too few armies") ) {
	for (i=MAXPLAYER-1; i>=0; --i ) {
	    if ( isAlive( &players[i] ) &&
		players[i].p_team == me->p_team &&
		players[i].p_ship.s_type == STARBASE) {
		botUniverse[0].players[i].armies_suspected = 0;
		botUniverse[0].players[i].armies_known = 0;
		break;
	    }
	}
    }

#if 0
    if (strstr(text, "Our computers limit us to having ") &&
	(ptr = (char *) strstr(text, " live torpedos at a time captain!"))) {
      --ptr;
      while (*ptr != ' ')
	--ptr;
      ptr++;

      for (i=0; i<MAXTORP; i++)
	printf("status of torp %d = %d\n",
	       i, torps[me->p_no * MAXTORP + i].t_status);

      i = atoi( ptr );
      printf("me->p_ntorp = %d (%d)\n", me->p_ntorp, i);
#if 0
      me->p_ntorp = i;
#endif
    }
#endif

#ifdef PRINTMESSAGES
    if ( strstr(text, "Phasers have not recharged" ) ) {
      printf("my phaser status is %d\n", 
	     phasers[me->p_no].ph_status);
    }
#endif

#ifndef LOGIN_AS_GUEST
    if ( strstr(text, "You destroyed the plasma torpedo!")) {
	pmessage("You were !KCAMS'd by a bot (are you a TWINK?)", 0, MALL );
    }
#endif
    
    if ( strstr(text, "Weapons Officer: Bombing is ineffective.") &&
	 (ptr = (char *) strstr( text, "Only" ) ) ) {
	if ( (ptr = (char *) strchr( ptr, ' ') ) ) {
	    ptr++;
	    i = atoi( ptr );
	    target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			       me->p_y * WINSIDE/GWIDTH,
			       TARG_PLANET);
	    botUniverse[0].planets[target->o_num].armies = i;
	    botUniverse[1].planets[target->o_num].armies = i;
	    planets[target->o_num].pl_armies = i;
	}
    }

    if ( strstr(text, "Not constructed yet.") &&
	strstr(text, "required for completion") &&
	(ptr = (char *) strstr( text, "minute" ) ) ) {
	ptr -= 2;
	while ( *ptr != ' ' )
	    --ptr;
	ptr++;
	i = atoi( ptr );
	botWaitForSBTime = botTimeCounter + i * 600;
    }

    if ( !strstr(text, "Starbase" ) &&
	strstr(text, "Too few armies to beam up") ) {
	target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			   me->p_y * WINSIDE/GWIDTH,
			   TARG_PLANET);
	botUniverse[0].planets[target->o_num].armies = 4;
	botUniverse[1].planets[target->o_num].armies = 4;
	planets[target->o_num].pl_armies = 4;
    }

    if ( strstr( text, "No more room on board for armies" ) )
	me->p_armies = botMaxArmies( me );
    
}


void botParseMessage( char *message, unsigned char flags,
		     unsigned char from,
		     unsigned char to)
{
    char buf[256];
    char *ptr;
    int i,j;
    
#ifdef PRINTMESSAGES
#ifndef INCLUDE_X
    printf( "%s\n", message );
#endif
#endif
    
    switch(flags & (MTEAM|MINDIV|MALL)) {
    case MTEAM:
	if ( from < MAXPLAYER &&
	    players[from].p_team != me->p_team )
	    break;
	    
	for (i=strlen(message); i>=0; --i)
	    buf[i] = toupper( message[i] );

	if (strstr( buf, "CARRYING NO") ) {
	    botUniverse[0].players[from].armies_known = 0;
	    botUniverse[0].players[from].armies_suspected = 0;
	}
	else if ( (ptr = (char *) strstr( buf, "CARRYING" )) &&
		 strstr( buf, "ARM") ) {
	    if ( ( ptr = (char *) strchr(ptr, ' ') )) {
		ptr++;
		i = atoi( ptr );
		botUniverse[0].players[from].armies_known = i;
		botUniverse[0].players[from].armies_suspected = i;
	    }
	}
	else if ( (ptr = (char *) strstr( buf, "ARM" )) &&
		 strstr( buf, "HELP" ) ) {
	    ptr -= 2;
	    while (ptr != buf && *ptr != ' ')
		--ptr;
	    ptr++;
	    i = atoi( ptr );
	    botUniverse[0].players[from].armies_known = i;
	    botUniverse[0].players[from].armies_suspected = i;
	}
	else if ( (ptr = (char *) strstr( buf, "CARRYING" )) &&
		 strstr( buf, "TO") ) {
	    if ( ( ptr = (char *) strchr(ptr, ' ') )) {
		ptr++;
		i = atoi( ptr );
		botUniverse[0].players[from].armies_known = i;
		botUniverse[0].players[from].armies_suspected = i;
	    }
	}
	else if ( !strncmp( buf, "GOD", 3 ) &&
		 strstr( buf, "HAS VOTED TO EJECT" ) &&
		 ( ptr = (char *) strstr( buf, " PLAYER" )) ) {
	    --ptr;
	    while ( *ptr != ' ' )
		--ptr;
	    ptr++;
	    i = atoi( ptr );
	    if ( i > 2 ) {
		if ( (ptr = (char *) strstr( message, "EJECT" ))) {
		    ptr += 6;
		    i =  (char *) strchr( shipnos, tolower( *ptr ) ) -
			(char *) shipnos;
		    if ( i != me->p_no && i >= 0 && i < MAXPLAYER ) {
			sprintf(buf, "EJECT %c", shipnos[i]);
			pmessage(buf, me->p_no, MINDIV);
		    }
		}
	    }
	}
	break;
	
    case MINDIV:
	for (i=strlen(message); i>=0; --i)
	    buf[i] = toupper( message[i] );
	
	if ( from < MAXPLAYER && from != me->p_no &&
	    from < 16 && 
	    players[from].p_team == me->p_team &&
	    strstr( buf, "EJECT" ) &&
	    strstr( serverName, "bigbang" ) )
	{
	    if ( botEjectList[from] &&
		!strcmp(botEjectNames[from], players[from].p_name) ) {
		pmessage("I have already received your EJECT message", from , MINDIV);
	    }
	    else
	    {
#if 0
		if ( totalRating( &players[from] ) < totalRating( me ) ) {
		    pmessage("You're worse than I am - maybe you should quit", from , MINDIV);
		    sprintf(buf, "EJECT %c", shipnos[from] );
		    pmessage( buf, me->p_no, MINDIV );
		}
		else
#endif
		{   
		    botEjectList[from] = botTimeCounter;
		    strcpy( botEjectNames[from], players[from].p_name );
		    
		    for (j=0,i=0; i<MAXPLAYER;i++)
			if (botEjectList[i] && players[i].p_team == me->p_team &&
			    !strcmp(botEjectNames[i], players[i].p_name))
			    j++;

		    if ( botEjectable ) {
			if (j >= EJECTNUMBER)
			    pmessage("I received your EJECT message and will leave on my next death", from , MINDIV);
			else {
			    pmessage("I received your EJECT message and will leave when", from , MINDIV);
			    sprintf(buf, "%d more %s I should go.", EJECTNUMBER-j,
				    (EJECTNUMBER-j == 1)?"teammate thinks" : "teammates think");
			    pmessage(buf, from, MINDIV);
			}
		    }
		}
	    }
	}

	if ( strstr( message, "GOD->" ) &&
	    strstr( message, "There is no one on the pickup queue" ) ) {
	    botWaitQueue = 0;
	}
	
	if ( strstr( message, "GOD->" ) &&
	    strstr( message, "Approximate pickup queue size:" ) &&
	    (ptr = (char *) strchr( message, ':' )) ) {
	    ptr+=2;
	    botWaitQueue = atoi( ptr );
	}

	if (!strncmp( message, "GOD", 3 ) &&
	    strstr( message, "To verify, send the word" ) )
	{
	    ptr = (char *) strchr( message, '\'' );
	    if ( ptr ) {
		ptr++;
		strcpy( buf, ptr );
		ptr = (char *) strchr( buf, '\'' );
		if ( ptr ) {
		    *ptr = '\0';
		    pmessage(buf, me->p_no, MINDIV);
		}
	    }
	}	    

	break;
	
    case MALL:
#ifndef LOGIN_AS_GUEST
	if (!strncmp( message, "GOD", 3 ) &&
	    !strstr( message, "NO CREDIT" ) &&
	    strstr( message, " armies)" ) ) {
	    sprintf( buf, "for %s", me->p_name );
	    if ( ptr = (char *) strstr( message, buf ) ) {
		sprintf(buf, "(%c%c)", teamlet[me->p_team], shipnos[me->p_no]);
		if ( strstr( ptr, buf ) ) {
		    pmessage("DOOSH!!!  (by a bot - maybe you should quit playing)", 0, MALL );
		}
	    }
	}

	if (!strncmp( message, "GOD", 3 ) &&
	    strstr( message, " armies awarded to " ) ) {
	    sprintf( buf, "to %s", me->p_name );
	    if ( ptr = (char *) strstr( message, buf ) ) {
		sprintf(buf, "(%c%c)", teamlet[me->p_team], shipnos[me->p_no]);
		if ( strstr( ptr, buf ) ) {
		    pmessage("DOOSH!!!  (with help of your TWINK human teammates)", 0, MALL );
		}
	    }
	}

#ifdef SENDPIG
	if (!strcmp(message+10, PIGCALL ) && from != me->p_no ) {
	    pmessage("I am FreeBot.  Please send me comments on the individual", from, MINDIV);
	    pmessage("board letting me know what areas need improvement - or ", from, MINDIV);
	    pmessage("e-mail comments to  bpaulsen@panix.com", from, MINDIV);
	}
#endif
#endif
	break;
    }
}

int botChooseTeam( int *team, int *ship,
		  int okayMask, int elapsedTime )
{
    int bestTeam = -1;
    int bestTeamPlanets = MAXPLANETS+1;
    int bestShip;
    int i,j;
    int enemyTeam = -1;
    int numberOfEnemy;
    int numberOfPlanetArmies;
    int numberOfCarriedArmies;
    int numberOfScouts;
    int numberOfMyPlanets;
    int numberOfPlanets;
    int numberOfMyArmies;
    int numberOfBombablePlanets;
    int numberOfTeammates;
    int numberOfEnemyPlanets;
    int unknownPlanets = 0;
    static int lastTeam = -1;
    struct planet *k;
    
    botDesiredSpeed = 0;
    botDesiredCourse = -1;
    
    if (okayMask < 1 || okayMask > ALLTEAM) {
#if 0
	printf("elapsed time = %d\n", elapsedTime );
#endif
	if ( elapsedTime > 3 ) {
	    *team = -1;
#ifdef PRINTMESSAGES
	    printf("Server doesn't allow borgs\n");
#endif
	    return 1;
	}
    }

    for (j=0,i=0; i<MAXPLAYER;i++)
	if (botEjectList[i] && players[i].p_team == me->p_team &&
	    !strcmp(botEjectNames[i], players[i].p_name))
	    j++;

    if (j + botWaitQueue >= EJECTNUMBER && strstr(serverName, "bigbang" ) &&
	botEjectable )
    {
#ifdef PRINTMESSAGES
	printf("Team ejected me\n");
#endif
	return 1;
    }

    if (botAutoQuit)
    {
#ifdef PRINTMESSAGES
	printf("Time to quit\n");
#endif
	return 1;
    }
    
    /* pick the team with the least planets */
    if (status->tourn) {
	for (i=0; i<NUMTEAM; i++) {
	    if (okayMask & (1 << i) ) {
		numberOfPlanets = 0;
		for (j=0; j<MAXPLANETS; j++) {
		    if ( planets[j].pl_owner == (1 << i) )
			numberOfPlanets++;
		}
		if ( numberOfPlanets < bestTeamPlanets ) {
		    bestTeamPlanets = numberOfPlanets;
		    bestTeam = i;
		}
	    }
	}
    }
    else {
	if (lastTeam >= 0 && (okayMask & (1 << lastTeam) ) )
	    bestTeam = lastTeam;
	else {
	    bestTeamPlanets = MAXPLAYER+1;
	    for (i=0; i<NUMTEAM; i++) {
		if (okayMask & (1 << i) ) {
		    j = numShips( 1 << i );
		    if ( j < bestTeamPlanets ) {
			bestTeamPlanets = j;
			bestTeam = i;
		    }
		}
	    }
	}
    }

    numberOfTeammates = numShips( 1 << bestTeam );
    
    /* now pick the ship */
    if ( bestTeam > -1 ) {
	/* Find out who my enemy will be */
	numberOfEnemy = -1;
	for (i=0; i<NUMTEAM; i++) {
	    if ( i != bestTeam ) {
		j = numShips( 1 << i );
		if ( j > numberOfEnemy ) {
		    numberOfEnemy = j;
		    enemyTeam = i;
		}
	    }
	}

	/* first - count how many armies the enemy has on its planets.
	   Planets where I have no info counts as 15 armies */
	numberOfPlanetArmies = 0;
	numberOfBombablePlanets = 0;
	unknownPlanets = 0;
	numberOfEnemyPlanets = 0;
	if (status->tourn) {
	    for (i=0; i<MAXPLANETS; i++) {
		k = &planets[i];
		if ( k->pl_owner == (1 << enemyTeam)) {
		    numberOfEnemyPlanets++;
		    if ( k->pl_armies > 4) {
			numberOfBombablePlanets++;
			numberOfPlanetArmies += k->pl_armies - 4;
		    }
		}
		if ( !(k->pl_info & (1 << bestTeam)) &&
		    ( i / 10 == enemyTeam ||
		     i / 10 == bestTeam ) ) {
		    numberOfEnemyPlanets++;
		    unknownPlanets++;
		    numberOfBombablePlanets++;
		    numberOfPlanetArmies +=
			ABS( botUniverse[0].planets[i].armies );
		}
	    }
	}
	
	/* now count how many armies are carried by the enemy */
	numberOfCarriedArmies = 0;
	for (i=0; i<MAXPLAYER; i++) {
	    if ( players[i].p_team != (1 << bestTeam) &&
		players[i].p_ship.s_type != STARBASE )
		numberOfCarriedArmies +=
		    botUniverse[0].players[i].armies_suspected;
	}

	/* be a scout if 3 or more enemy planets are bombable */
	if ( numberOfBombablePlanets >= numberOfEnemyPlanets / 2 ||
	    unknownPlanets > 5 ||
	    numberOfPlanetArmies > numberOfCarriedArmies )
	    bestShip = SCOUT;
	else
	    bestShip = CRUISER;

	if ( bestShip == SCOUT && numberOfPlanetArmies >= 60 )
	    bestShip = ASSAULT;

	/* We don't want more than 2 scouts per team */
	numberOfScouts = 0;
	if ( bestShip == SCOUT || bestShip == ASSAULT) {
	    for (i=0; i<MAXPLAYER; i++) {
		if ( players[i].p_team == (1 << bestTeam) &&
		    ( players[i].p_ship.s_type == SCOUT ||
		     players[i].p_ship.s_type == ASSAULT ) )
		    numberOfScouts++;
	    }
	}
	if ( numberOfScouts >= 2 )
	    bestShip = CRUISER;

	if ( !botBomber )
	    bestShip = CRUISER;

	numberOfMyPlanets = 0;
	numberOfMyArmies = 0;
	for (i=MAXPLANETS-1; i>=0; --i) {
	    if ( planets[i].pl_owner == (1 << bestTeam) ) {
		numberOfMyPlanets++;
		
		if (planets[i].pl_armies > 4)
		    numberOfMyArmies += planets[i].pl_armies - 4;
	    }
	}
	
#if 0
	if (numberOfMyPlanets <= 4 && bestShip == CRUISER)
	  bestShip = BATTLESHIP;
#endif

	if ( !status->tourn )
	    bestShip = CRUISER;

	if ( botPlaySB ) {
	    for (i=MAXPLAYER; i>=0; --i) {
		if ( players[i].p_team == (1 << bestTeam) &&
		    players[i].p_ship.s_type == STARBASE )
		    break;
	    }
	    if ( elapsedTime < 2 && i < 0 &&
		numberOfTeammates > 3 &&
		(numberOfMyPlanets < 6 ||
		 ( (numberOfMyArmies > 10 && numberOfMyPlanets > 14) ||
		  numberOfMyArmies > 30) ) &&
		numberOfMyPlanets > 4 &&
		botTimeCounter > botWaitForSBTime )
		bestShip = STARBASE;
	}

#if 0
	if ( bestShip == CRUISER )
	    if ( !(RANDOM() % 6 ))
		bestShip = BATTLESHIP;

	if ( bestShip == CRUISER )
	    if ( !(RANDOM() % 7) )
		bestShip = DESTROYER;
#endif
#if 0
	bestShip = SCOUT;
#endif
	
	/* now - see if the server will let me be this ship */
	if (teamRequest( bestTeam, bestShip ) ) {
	    lastTeam = bestTeam;
	    *team = bestTeam;
	    *ship = bestShip;
	    return 1;
	}
    }

    return 0;
}

double botDistanceFromMe( BOT_POINT *point )
{
    if ( point->x < 0 || point->y < 0 ) {
	return 1000000.0;
    }
    
    if ( point->distance <= 0) {
	point->distance = hypot( (double) me->p_x - point->x,
				(double) me->p_y - point->y );
    }

    return point->distance;
}

void botStartTimer()
{
  if (getrusage( RUSAGE_SELF, &botRUsage ))
    printf("error in getrusage\n");
}

void botPrintTimer()
{
    struct rusage timeUsed;
    if (getrusage( RUSAGE_SELF, &timeUsed ))
      printf("error in getrusage 2\n");

    printf("%d seconds used\t%d microseconds used\n",
	   timeUsed.ru_utime.tv_sec - botRUsage.ru_utime.tv_sec,
	   timeUsed.ru_utime.tv_usec - botRUsage.ru_utime.tv_usec );
    
}    

int botCurrentPosition( BOT_POINT *current, BOT_POINT *new, BOT_POINT *old )
{
    double factor;
    
    if (!current || !new || !old || new->x < 0 || new->y < 0 ||
	old->x < 0 || old->y < 0 || new->x > GWIDTH || old->x > GWIDTH ||
	new->y > GWIDTH || old->y > GWIDTH )
	return 0;

    current->time = botTimeCounter;

    if (new->time == old->time) {
	current->x = new->x;
	current->y = new->y;
    }
    else {
	factor = borgDelay / 100.0 / (new->time - old->time);
	current->x = new->x + factor * (new->x - old->x);
	current->y = new->y + factor * (new->y - old->y);
    }

    return 1;
}
    

void botInterpolatePosition( BOT_POINT *current, BOT_POINT *new,
			    BOT_POINT *old )
{
    if ( !current )
	return;

    current->time = botTimeCounter;
    if ( !old || !new || new->x < 0 || new->x > GWIDTH || old->y < 0
	|| old->y > GWIDTH ) {
	current->x = current->y = -200000;
	current->interpolated = 1;
    }
    else if ( new->time == old->time ) {
	current->x = new->x;
	current->y = new->y;
	current->distance = 0;
	current->angle = 0;
	current->interpolated = 1;
	
    }
    else {
	current->x = new->x + (current->time - new->time) *
	    (new->x - old->x) / (new->time - old->time);
	current->y = new->y + (current->time - new->time) *
	    (new->y - old->y) / (new->time - old->time);
	current->distance = 0;
	current->angle = 0;
	current->interpolated = 1;
    }	
}

int teammateAttackingPlayer( struct player *player )
{
    int i;
    int distance;
    int enemyDamage;
    int teamPhaserDamage;
    int x,y;
    
    distance =
	botDistanceFromMe( &botUniverse[0].players[player->p_no].point );
    distance *= distance;
    enemyDamage = 0;
    teamPhaserDamage = 0;
    for ( i=MAXPLAYER-1; i>=0; --i ) {
	if ( !isAlive( &players[i] ) ||
	    myPlayer( &players[i] ) ||
	    !pointWithinSquare( &botUniverse[0].players[player->p_no].point,
			       &botUniverse[0].players[i].point,
				   10000.0 ) )
	    continue;
	
	if ( friendlyPlayer( &players[i] ) ) {
	    if ( !botUniverse[0].players[players->p_no].armies_known ) {
		x =  botUniverse[0].players[players->p_no].point.x -
		    botUniverse[0].players[i].point.x;
		y =  botUniverse[0].players[players->p_no].point.y -
		    botUniverse[0].players[i].point.y;
		if ( x*x + y*y < distance )
		    teamPhaserDamage += players[i].p_ship.s_phaserdamage;
	    }
	}
	else
	    enemyDamage += players[i].p_ship.s_maxdamage;
    }

    return (enemyDamage < teamPhaserDamage);
}

int enemyPlayersNearPlanet( struct planet *planet )
{
    int i;
    int enemyNearPlanet=0;
    
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( isAlive( &players[i] ) && !myPlayer( &players[i] ) &&
	    pointWithinSquare( &botUniverse[0].planets[planet->pl_no].point,
			      &botUniverse[0].players[i].point,
			      8000.0) ) {
	    if ( players[i].p_team == me->p_team ) {
		enemyNearPlanet--;
		if ( players[i].p_ship.s_type == STARBASE )
		    enemyNearPlanet -= 4;
	    }
	    else if ( !friendlyPlayer( &players[i] ) ) {
		enemyNearPlanet++;
		if ( players[i].p_ship.s_type == STARBASE )
		    enemyNearPlanet += 4;
	    }
	}
    }

    return enemyNearPlanet;
}
    
int enemyPlayersNearPlayer( struct player *player )
{
    int i;
    double myDistance;
    int enemyNearPlayer=0;
    
    myDistance = 2000.0 +
	botDistanceFromMe( &botUniverse[0].players[player->p_no].point );
    
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( isAlive( &players[i] ) && !myPlayer( &players[i] ) &&
	    i != player->p_no &&
	    pointWithinSquare( &botUniverse[0].players[player->p_no].point,
			      &botUniverse[0].players[i].point,
			      10000.0)) {
	    if ( players[i].p_team == me->p_team ) {
		enemyNearPlayer--;
		if ( players[i].p_ship.s_type == STARBASE )
		    enemyNearPlayer -= 4;
	    }
	    else if ( !friendlyPlayer( &players[i] ) ) {
		if (hypot( (double) players[i].p_x - player->p_x,
			  (double) players[i].p_y - player->p_y ) <
		    myDistance ) {
		    enemyNearPlayer++;
		    if ( players[i].p_ship.s_type == STARBASE )
			enemyNearPlayer += 4;
		}
	    }
	}
    }

    return enemyNearPlayer;
}

void botInitializeUniverse()
{
    int i, j;

    botTimeCounter = 0;
    botPacketReceived = 0;
    
    for (j=0; j<sizeof(botUniverse)/sizeof(botUniverse[0]); j++) {
	for (i=0; i<MAXPLAYER; i++) {
	    botUniverse[j].players[i].point.x = -1;
	    botUniverse[j].players[i].point.y = -1;
	    botUniverse[j].players[i].point.time = 0;
	    botUniverse[j].players[i].point.distance = 0;
	    botUniverse[j].players[i].point.angle = 0;
	    botUniverse[j].players[i].armies_known = 0;
	    botUniverse[j].players[i].armies_suspected = 0;

	    botEjectList[i] = 0;
	}
	
	for (i=0; i<MAXPLAYER * MAXTORP; i++) {
	    botUniverse[j].torps[i].point.x = -1;
	    botUniverse[j].torps[i].point.y = -1;
	    botUniverse[j].torps[i].point.time = 0;
	    botUniverse[j].torps[i].point.distance = 0;
	    botUniverse[j].torps[i].point.angle = 0;
	}
	
	for (i=0; i<MAXPLAYER * MAXPLASMA; i++) {
	    botUniverse[j].plasmas[i].point.x = -1;
	    botUniverse[j].plasmas[i].point.y = -1;
	    botUniverse[j].plasmas[i].point.time = 0;
	    botUniverse[j].plasmas[i].point.distance = 0;
	    botUniverse[j].plasmas[i].point.angle = 0;
	}
	
	for (i=0; i<MAXPLANETS; i++) {
	    botUniverse[j].planets[i].point.x = -1;
	    botUniverse[j].planets[i].point.y = -1;
	    botUniverse[j].planets[i].point.time = 0;
	    botUniverse[j].planets[i].point.distance = 0;
	    botUniverse[j].planets[i].point.angle = 0;
	    botUniverse[j].planets[i].armies = -15;
	    botUniverse[j].planets[i].planetType = 0;
	    botUniverse[j].planets[i].team = -1;
	}
    }
}

int numberOfPassedTicks()
{
    int defaultTicks;
    static int previousCalculation=0;
    int i,j;
    int calculated = 0;
    double averageUpdateSpeed = 0.0;
    double tmpUpdateSpeed;
    BOT_POINT point;
    double distance;
    int sawTorp;
    int tmpx, tmpy;
    
    /* try to figure out the current update speed, then
       convert that to number of ticks since last update */
    if ( previousCalculation )
	defaultTicks = previousCalculation;
    else if ( me->p_ship.s_type == STARBASE )
	defaultTicks = 1;
    else
	defaultTicks = 2;

    /* first, go through all of the ships */
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !players[i].p_speed ||
	    !botUniverse[0].players[i].speed ||
	    botUniverse[0].players[i].point.interpolated ||
	    botUniverse[0].players[i].speed != players[i].p_speed ||
	    shipCloaked( &players[i] ) ||
	    !isAlive( &players[i] ) ) {
	    continue;
	}
	
	if (players[i].p_x < 0 ||
	    players[i].p_y < 0 ||
	    players[i].p_x >= GWIDTH ||
	    players[i].p_y >= GWIDTH ||
	    botUniverse[0].players[i].point.x < 5000 ||
	    botUniverse[0].players[i].point.y < 5000 ||
	    botUniverse[0].players[i].point.x >= GWIDTH - 5000 ||
	    botUniverse[0].players[i].point.y >= GWIDTH - 5000 ||
	    players[i].p_x == botUniverse[0].players[i].point.x ||
	    players[i].p_y == botUniverse[0].players[i].point.y ) {
	    continue;
	}

	point.x = players[i].p_x;
	point.y = players[i].p_y;
	
	for (j=MAXPLAYER-1; j>=0; --j) {
	    if ( isAlive( &players[j] ) &&
		j != i &&
		pointWithinSquare( &point,
				  &botUniverse[0].players[j].point,
				  8000.0 ) )
		break;
	}
	if ( j >= 0 ) {
	    continue;
	}

	tmpx = point.x - botUniverse[0].players[i].point.x;
	tmpy = point.y - botUniverse[0].players[i].point.y;
	tmpUpdateSpeed = sqrt( (double) (tmpx*tmpx + tmpy*tmpy) ) / WARP1 /
	    botUniverse[0].players[i].speed;

	if ( tmpUpdateSpeed < 10.5 ) {
	    averageUpdateSpeed += tmpUpdateSpeed;
	    calculated++;
	}
    }

    /* if we were able to derive the number of ticks from ship positions,
       then we can also make a crack at trying to compute if we are in a
       vector torp game */
    if ( calculated ) {
	defaultTicks = 0.5 + averageUpdateSpeed / calculated;
	previousCalculation = defaultTicks;

	j = 0;
	sawTorp = 0;
	for (i=MAXPLAYER*MAXTORP-1; i>=0 && !j; --i ) {
	    if ( !isAlive( &players[i/MAXTORP] ) )
		continue;

	    if ( !liveTorp( &torps[i] ) ||
		torps[i].t_x >= GWIDTH ||
		torps[i].t_y >= GWIDTH ||
		botUniverse[0].torps[i].point.x < 0 ||
		botUniverse[0].torps[i].point.y < 0 ||
		botUniverse[0].torps[i].point.x >= GWIDTH ||
		botUniverse[0].torps[i].point.y >= GWIDTH ||
		torps[i].t_x ==	botUniverse[0].torps[i].point.x ||
		torps[i].t_y ==	botUniverse[0].torps[i].point.y )
		continue;

	    sawTorp++;
	    
	    tmpx = torps[i].t_x - botUniverse[0].torps[i].point.x;
	    tmpy = torps[i].t_y - botUniverse[0].torps[i].point.y;
	    distance = sqrt( (double) (tmpx*tmpx + tmpy*tmpy) ) / WARP1;

	    distance -= players[i/MAXTORP].p_ship.s_torpspeed * defaultTicks;
	    
	    if ( ABS(distance) > 2 * defaultTicks ) {
		j = 1;
	    }
	}

	if ( sawTorp ) {
	    if ( j != borgVectorTorpSpeed ) 
	    borgVectorTorpSpeed = j;
	}
    }
    else if ( !borgVectorTorpSpeed ) {
	/* Using ships didn't work, now trying using torps */
	for (i=MAXPLAYER*MAXTORP-1; i>=0; --i) {
	    if ( !isAlive( &players[i/MAXTORP] ) )
		continue;

	    if ( !liveTorp( &torps[i] ) ||
		torps[i].t_x >= GWIDTH ||
		torps[i].t_y >= GWIDTH ||
		botUniverse[0].torps[i].point.x < 0 ||
		botUniverse[0].torps[i].point.y < 0 ||
		botUniverse[0].torps[i].point.x >= GWIDTH ||
		botUniverse[0].torps[i].point.y >= GWIDTH ||
		torps[i].t_x ==	botUniverse[0].torps[i].point.x ||
		torps[i].t_y ==	botUniverse[0].torps[i].point.y )
		continue;

	    tmpx = torps[i].t_x - botUniverse[0].torps[i].point.x;
	    tmpy = torps[i].t_y - botUniverse[0].torps[i].point.y;
	    tmpUpdateSpeed = sqrt( (double) (tmpx*tmpx + tmpy*tmpy) ) /
		WARP1 /	players[i/MAXTORP].p_ship.s_torpspeed;
	    
	    if ( tmpUpdateSpeed < 10.5 ) {
		averageUpdateSpeed += tmpUpdateSpeed;
		calculated++;
	    }
	}

	if ( calculated ) {
	    defaultTicks = 0.5 + averageUpdateSpeed / calculated;
	    previousCalculation = defaultTicks;
	}
    }

    return defaultTicks;
}

/*
   This returns back the angle from me to the point (x,y).  This angle
   is in terms of what netrek likes to use as angles.  Note also that I
   try to attempt for any lag on my end by calculating where I actually
   will be when I plan to use the result of this
   */
unsigned char botGetAngle(int x, int y)
{
    BOT_POINT mePoint;

    if ( botCurrentPosition( &mePoint,
			    &botUniverse[0].players[me->p_no].point,
			    &botUniverse[1].players[me->p_no].point ) ) {
	if ((x == mePoint.x) && (y == mePoint.y) )
	    return 0;
	else
	    return ((unsigned char) (atan2((double) (x - mePoint.x),
					   (double) (mePoint.y - y)) /
				     PI * 128));
    }
    else
	return 0;
}

computeTractorPressors()
{
    BOT_POINT myPoint[MAXPLAYER], tmpPoint;
    int i,j;
    int deltaDir, speed, myCurrentDir, subSpeed, ticksDelay, factor;
    int angle;
    int tractorEnemy[MAXPLAYER];
    int pressorEnemy[MAXPLAYER];
    int beingTractored[MAXPLAYER];
    int tractorRange;
    int tractorStrength;
    int x,y;
    int attemptCalculation[MAXPLAYER];
    double distance;
    double deltaDist[MAXPLAYER];
    double sinTheta, cosTheta;
    
    for (i=MAXPLAYER-1; i>=0; --i) {
	tractorEnemy[i] = -1;
	pressorEnemy[i] = -1;
	beingTractored[i] = 0;
	attemptCalculation[i] = 0;

	if ( !botUniverse[0].players[i].point.time ||
	    !botUniverse[1].players[i].point.time ||
	    botUniverse[1].players[i].point.x < 0 ||
	    botUniverse[1].players[i].point.y < 0 ||
	    botUniverse[0].players[i].point.x < 0 ||
	    botUniverse[0].players[i].point.y < 0 ||
	    !isAlive( &players[i] ) ||
	    !pointWithinSquare( &botUniverse[0].players[i].point,
			       &botUniverse[0].players[me->p_no].point,
			       9000.0 ) )
	    continue;

	if ( myPlayer( &players[i] ) && shipOrbitting( me ) )
	    continue;
	    
	attemptCalculation[i] = 1;
	myPoint[i].x = botUniverse[1].players[i].point.x;
	myPoint[i].y = botUniverse[1].players[i].point.y;
	
	ticksDelay = botUniverse[0].players[i].point.time -
	    botUniverse[1].players[i].point.time;
	speed = botUniverse[1].players[i].speed;
	myCurrentDir = botUniverse[1].players[i].dir;
	if ( botUniverse[1].players[i].speed ==
	    botUniverse[0].players[i].speed )
	    subSpeed = botUniverse[0].players[i].speed * 1000;
	else if ( botUniverse[1].players[i].speed <
		 botUniverse[0].players[i].speed )
	    subSpeed = botUniverse[0].players[i].speed * 1000 -
		- players[i].p_ship.s_accint;
	else 
	    subSpeed = botUniverse[1].players[i].speed * 1000;
	
	/* this will be code to handle the fact that I'm experiencing lag -
	   basically, this means that if I have 200ms lag, I'm really 2 ticks
	   behind what I'm seeing now - so... we do the following...
	   a) I know what speed and direction I last requested to go in
	   (botDesiredSpeed and botDesiredCourse)
	   b) Using this, we project out the ticks required by my lag
	   */
	for (j=ticksDelay; j>0; --j) {
	    if (speed < 0)
		speed = 0;
	    if (speed > players[i].p_ship.s_maxspeed)
		speed = players[i].p_ship.s_maxspeed;
	    factor = (speed > 0 ? (players[i].p_ship.s_turns /
				   (1 << speed) / 1000.0) : 128 );
	    
	    deltaDir = angdist( (unsigned char) myCurrentDir,
			       (unsigned char) botUniverse[0].players[i].dir );
	    if ( deltaDir > factor ) {
		if ( NORMALIZE( deltaDir + myCurrentDir ) ==
		    botUniverse[0].players[i].dir )
		    myCurrentDir = NORMALIZE( myCurrentDir + factor );
		else
		    myCurrentDir = NORMALIZE( myCurrentDir - factor );
	    }
	    else
		myCurrentDir = botUniverse[0].players[i].dir;
	    
	    if ( botUniverse[0].players[i].speed > speed )
		subSpeed += players[i].p_ship.s_accint;
	    if ( botUniverse[0].players[i].speed < speed )
		subSpeed -= players[i].p_ship.s_decint;
	    
	    speed = subSpeed / 1000;
	    
	    myPoint[i].x += WARP1 * speed * Cos[myCurrentDir];
	    myPoint[i].y += WARP1 * speed * Sin[myCurrentDir];
	}
    }

    if ( me->p_flags & PFTRACT &&
	me->p_tractor >= 0 && me->p_tractor < MAXPLAYER &&
	isAlive( &players[me->p_tractor] ) ) {
	tractorEnemy[me->p_no] = me->p_tractor;

	angle = botGetAngle( botUniverse[0].players[me->p_tractor].point.x,
			    botUniverse[0].players[me->p_tractor].point.y );
	tractorStrength = WARP1 * me->p_ship.s_tractstr;

	myPoint[me->p_no].x += tractorStrength * Cos[angle] *
	    (botUniverse[0].players[me->p_no].point.time -
	     botUniverse[1].players[me->p_no].point.time) /
		 me->p_ship.s_mass;
	myPoint[me->p_no].y += tractorStrength * Sin[angle] *
	    (botUniverse[0].players[me->p_no].point.time -
	     botUniverse[1].players[me->p_no].point.time) /
		 me->p_ship.s_mass;

	angle = NORMALIZE( 128 + angle );
	myPoint[me->p_tractor].x += tractorStrength * Cos[angle] *
	    (botUniverse[0].players[me->p_tractor].point.time -
	     botUniverse[1].players[me->p_tractor].point.time) /
		 players[me->p_tractor].p_ship.s_mass;
	myPoint[me->p_tractor].y += tractorStrength * Sin[angle] *
	    (botUniverse[0].players[me->p_tractor].point.time -
	     botUniverse[1].players[me->p_tractor].point.time) /
		 players[me->p_tractor].p_ship.s_mass;
    }
    else if ( me->p_flags & PFPRESS &&
	     me->p_tractor >= 0 && me->p_tractor < MAXPLAYER &&
	     isAlive( &players[me->p_tractor] ) ) {
	pressorEnemy[me->p_no] = me->p_tractor;
	
	angle = botGetAngle( botUniverse[0].players[me->p_tractor].point.x,
			    botUniverse[0].players[me->p_tractor].point.y );
	angle = NORMALIZE( 128 + angle );
	tractorStrength = WARP1 * me->p_ship.s_tractstr;
	myPoint[me->p_no].x += tractorStrength * Cos[angle] *
	    (botUniverse[0].players[me->p_no].point.time -
	     botUniverse[1].players[me->p_no].point.time) /
		 me->p_ship.s_mass;
	myPoint[me->p_no].y += tractorStrength * Sin[angle] *
	    (botUniverse[0].players[me->p_no].point.time -
	     botUniverse[1].players[me->p_no].point.time) /
		 me->p_ship.s_mass;

	angle = NORMALIZE( 128 + angle );
	myPoint[me->p_tractor].x += tractorStrength * Cos[angle] *
	    (botUniverse[0].players[me->p_tractor].point.time -
	     botUniverse[1].players[me->p_tractor].point.time) /
		 players[me->p_tractor].p_ship.s_mass;
	myPoint[me->p_tractor].y += tractorStrength * Sin[angle] *
	    (botUniverse[0].players[me->p_tractor].point.time -
	     botUniverse[1].players[me->p_tractor].point.time) /
		 players[me->p_tractor].p_ship.s_mass;
    }

    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !attemptCalculation[i] )
	    continue;

	x = botUniverse[0].players[i].point.x - myPoint[i].x;
	y = botUniverse[0].players[i].point.y - myPoint[i].y;
	deltaDist[i] = sqrt( (double) (x*x + y*y) );
	
	if ( deltaDist[i] > 10 *
	    (botUniverse[0].players[i].point.time -
	     botUniverse[1].players[i].point.time) ) {
	    beingTractored[i] = 1;
	}
	else
	    beingTractored[i] = 0;
    }

    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( myPlayer( &players[i] ) )
	    continue;

	if ( !attemptCalculation[i] ) 
	    continue;

	if ( pressorEnemy[i] >= 0 || tractorEnemy[i] >= 0 )
	    continue;
	
	if ( !beingTractored[i] )
	    continue;

	tractorRange = players[i].p_ship.s_tractrng * TRACTDIST;
	tractorStrength = WARP1 * players[i].p_ship.s_tractstr;

	for (j=MAXPLAYER-1; j>=0; --j) {
	    if ( j==i )
		continue;
	    if ( !attemptCalculation[j] ) 
		continue;
	    if (!beingTractored[j])
		continue;

	    if ( !isAlive( &players[j] ) ||
		!pointWithinSquare( &botUniverse[1].players[i].point,
				   &botUniverse[1].players[j].point,
				   tractorRange ) )
		continue;

	    x = botUniverse[1].players[i].point.x -
		botUniverse[1].players[j].point.x;
	    y = botUniverse[1].players[i].point.y -
		botUniverse[1].players[j].point.y;

	    if ( !(distance = sqrt( (double) (x*x + y*y) )))
		distance = 1;
	    
	    if ( distance > tractorRange )
		continue;

	    cosTheta = (botUniverse[1].players[j].point.x -
			botUniverse[1].players[i].point.x) / distance;
	    sinTheta = (botUniverse[1].players[j].point.y -
			botUniverse[1].players[i].point.y) / distance;
	    
	    tmpPoint.x = myPoint[i].x;
	    tmpPoint.y = myPoint[i].y;
	    
	    tmpPoint.x += tractorStrength * cosTheta *
		(botUniverse[0].players[i].point.time -
		 botUniverse[1].players[i].point.time) /
		     players[i].p_ship.s_mass;
	    tmpPoint.y += tractorStrength * sinTheta *
		(botUniverse[0].players[i].point.time -
		 botUniverse[1].players[i].point.time) /
		     players[i].p_ship.s_mass;

	    x = tmpPoint.x - botUniverse[0].players[i].point.x;
	    y = tmpPoint.y - botUniverse[0].players[i].point.y;
	    if ( sqrt( (double) (x*x + y*y) ) < deltaDist[i] ) {
		myPoint[i].x = tmpPoint.x;
		myPoint[i].y = tmpPoint.y;
		tractorEnemy[i] = j;
	    }
	    else {
		tmpPoint.x = myPoint[i].x;
		tmpPoint.y = myPoint[i].y;

		tmpPoint.x -= tractorStrength * cosTheta *
		    (botUniverse[0].players[i].point.time -
		     botUniverse[1].players[i].point.time) /
			 players[i].p_ship.s_mass;
		tmpPoint.y -= tractorStrength * sinTheta *
		    (botUniverse[0].players[i].point.time -
		     botUniverse[1].players[i].point.time) /
			 players[i].p_ship.s_mass;

		x = tmpPoint.x - botUniverse[0].players[i].point.x;
		y = tmpPoint.y - botUniverse[0].players[i].point.y;
		if ( sqrt( (double) ( x*x + y*y ) ) < deltaDist[i]) {
		    myPoint[i].x = tmpPoint.x;
		    myPoint[i].y = tmpPoint.y;
		    pressorEnemy[i] = j;
		}
	    }

	    if (pressorEnemy[i] < 0 && tractorEnemy[i] < 0 )
		continue;
	    
	    if ( tractorEnemy[i] >= 0 ) {
		myPoint[j].x -= tractorStrength * cosTheta *
		    (botUniverse[0].players[j].point.time -
		     botUniverse[1].players[j].point.time) /
			 players[j].p_ship.s_mass;
		myPoint[j].y -= tractorStrength * sinTheta *
		    (botUniverse[0].players[j].point.time -
		     botUniverse[1].players[j].point.time) /
			 players[j].p_ship.s_mass;
	    }
	    else {
		myPoint[j].x += tractorStrength * cosTheta *
		    (botUniverse[0].players[j].point.time -
		     botUniverse[1].players[j].point.time) /
			 players[j].p_ship.s_mass;
		myPoint[j].y += tractorStrength * sinTheta *
		    (botUniverse[0].players[j].point.time -
		     botUniverse[1].players[j].point.time) /
			 players[j].p_ship.s_mass;
	    }
		
	    for (j=MAXPLAYER-1; j>=0; --j) {
		if ( !attemptCalculation[j] ) 
		    continue;
		if ( !beingTractored[j] )
		    continue;

		x = botUniverse[0].players[j].point.x - myPoint[j].x;
		y = botUniverse[0].players[j].point.y - myPoint[j].y;
		deltaDist[j] = sqrt( (double) (x*x + y*y) );
		
		if ( deltaDist[j] > 10 *
		    (botUniverse[0].players[j].point.time -
		     botUniverse[1].players[j].point.time) ) {
		    beingTractored[j] = 1;
		}
		else
		    beingTractored[j] = 0;
	    }
	    break;
	}
    }

    for (i=MAXPLAYER-1; i>=0; --i) {
	botUniverse[0].players[i].tractorEnemy = -1;
	botUniverse[0].players[i].pressorEnemy = -1;
	if ( !attemptCalculation[i] )
	    continue;
	
	if ( tractorEnemy[i] >= 0 ) {
	    botUniverse[0].players[i].tractorEnemy = tractorEnemy[i];
#if 0
	    printf("%d) %d is tractoring %d\n", me->p_no, i, tractorEnemy[i]);
#endif
	}
	if ( pressorEnemy[i] >= 0 ) {
	    botUniverse[0].players[i].pressorEnemy = pressorEnemy[i];
#if 0
	    printf("%d) %d is pressoring %d\n", me->p_no,i, pressorEnemy[i]);
#endif
	}
    }
}

int botRecordUniverse()
{
    extern int ping_av;
    int i, j, enemySB, mySB;
    struct planet *planet;
    struct player *player;
    int stationaryTorps = 0;
    static int aliveProblem = 0;

    if ( !botTimeCounter )
	botInitializeUniverse();
    
    botTimeCounter += numberOfPassedTicks();
    botPacketReceived++;
    
    if ( !me->p_speed )
	botDesiredSpeed = 0;
    
    if ( !isAlive( me ) && me->p_x >=0 && me->p_y >= 0 &&
	me->p_x < GWIDTH && me->p_y < GWIDTH ) {
	aliveProblem++;
	if (aliveProblem > 150) {
	    me->p_status = PALIVE;
	}
	if (aliveProblem > 600) {
	    sendQuitReq();
	}
    }
    else {
	aliveProblem = 0;
    }
    
    if (ping_av > 0)
	borgDelay = ping_av / 2;

    /* Check to make sure that this update has some information that has
       changed.  If it doesn't, just return */
    j = 0;
    stationaryTorps = 0;
    for (i=MAXPLAYER*MAXTORP-1; i>=0; --i) {
        if ( liveTorp( &torps[i] ) ) {
	    if (botUniverse[0].torps[i].point.x != torps[i].t_x ||
		botUniverse[0].torps[i].point.y != torps[i].t_y)
		j++;
	    else
		stationaryTorps++;
        }
    }
    for (i=MAXPLAYER-1; i>=0 && !j; --i) {
        if ( isAlive( &players[i] ) && !INVISIBLE( &players[i] ) &&
            players[i].p_x >=0 && players[i].p_y >= 0 &&
            players[i].p_x < GWIDTH && players[i].p_y < GWIDTH &&
            (botUniverse[0].players[i].point.x != players[i].p_x ||
             botUniverse[0].players[i].point.y != players[i].p_y ||
	     !players[i].p_speed) )
            j++;
    }
    if ( !j || stationaryTorps > 3 )
        return 0;

    stationaryTorps = 0;

    /* Record planets - mainly this means keeping track of the armies
       and planet type */
    MCOPY( botUniverse[0].planets, botUniverse[1].planets,
	   sizeof( botUniverse[0].planets ) );
    for (i=MAXPLANETS-1; i>=0; --i) {
	planet = &planets[i];
	if ( planet->pl_info & me->p_team) {
	    botUniverse[0].planets[i].planetType = planet->pl_flags;
	    if ( planet->pl_armies >= 100 ) {
		planet->pl_armies = botUniverse[1].planets[i].armies;
	    }
	    botUniverse[0].planets[i].armies = planet->pl_armies;
	    botUniverse[0].planets[i].team = planet->pl_owner;
	}
	else {
	    if ( botUniverse[0].planets[i].armies >= 0 )
		botUniverse[0].planets[i].armies = -1;
	    botUniverse[0].planets[i].team = -1;
	}
	    
	botUniverse[0].planets[i].point.x = planet->pl_x;
	botUniverse[0].planets[i].point.y = planet->pl_y;
	botUniverse[0].planets[i].point.distance = 0;
	botUniverse[0].planets[i].point.angle = 0;
	botUniverse[0].planets[i].point.time = botTimeCounter;
    }
    
    /* Record position of torps - record all torps except those that
       are free, exploded, or detted */
    MCOPY( botUniverse[0].torps, botUniverse[1].torps,
	   sizeof( botUniverse[0].torps ) );
    for (i=MAXPLAYER*MAXTORP-1; i>=0; --i) {
	if ( !liveTorp( &torps[i] ) ) {
	    botUniverse[0].torps[i].point.x = -1;
	    botUniverse[0].torps[i].point.y = -1;
	    botUniverse[0].torps[i].point.time = 0;
	}
	else {
	    botUniverse[0].torps[i].point.x = torps[i].t_x;
	    botUniverse[0].torps[i].point.y = torps[i].t_y;
	    botUniverse[0].torps[i].point.time = botTimeCounter;
	    botUniverse[0].torps[i].point.distance = 0;
	    botUniverse[0].torps[i].point.angle = 0;

	    if (botUniverse[0].torps[i].point.x ==
		botUniverse[1].torps[i].point.x &&
		botUniverse[0].torps[i].point.y ==
		botUniverse[1].torps[i].point.y) {
		stationaryTorps++;
	    }
	}
    }

    if ( stationaryTorps > 2 ) {
	sendUdpReq(COMM_UPDATE);
#if 0
	sendShortReq(SPK_SALL);
	sendShortReq(SPK_ALL);
#endif
    }
    
    /* Record position of plasmas - record all plasmsa except those that
       are free or exploded */
    MCOPY( botUniverse[0].plasmas, botUniverse[1].plasmas,
	   sizeof( botUniverse[0].plasmas ) );
    for (i=MAXPLAYER*MAXPLASMA-1; i>=0; --i) {
	if ( plasmatorps[i].pt_status != TMOVE ) {
	    botUniverse[0].plasmas[i].point.x = -1;
	    botUniverse[0].plasmas[i].point.y = -1;
	    botUniverse[0].plasmas[i].point.time = 0;
	}
	else {
	    botUniverse[0].plasmas[i].point.x = plasmatorps[i].pt_x;
	    botUniverse[0].plasmas[i].point.y = plasmatorps[i].pt_y;
	    botUniverse[0].plasmas[i].point.time = botTimeCounter;
	    botUniverse[0].plasmas[i].point.distance = 0;
	    botUniverse[0].plasmas[i].point.angle = 0;
	}
    }
    
    /* Record position of players - we have to play a trick here for
       cloakers - for dead players make sure that the armies info is
       erased */
    if ( !isAlive( me ) && !(botPacketReceived % 120) ) {
	sendUdpReq(COMM_UPDATE);
#if 0
	sendShortReq(SPK_SALL);
	sendShortReq(SPK_ALL);
#endif
    }

    for (i=MAXPLAYER-1; i>=0; --i) {
	player = &players[i];
	botUniverse[0].players[i].point.distance = 0;
	botUniverse[0].players[i].point.angle = 0;
	if ( !isAlive( player ) ) {
	    botUniverse[0].players[i].point.x = -1;
	    botUniverse[0].players[i].point.y = -1;
	    botUniverse[1].players[i].point.x = -1;
	    botUniverse[1].players[i].point.y = -1;
	    botUniverse[2].players[i].point.x = -1;
	    botUniverse[2].players[i].point.y = -1;
	    botUniverse[0].players[i].point.time = 0;
	    botUniverse[0].players[i].direction = 0;
	    botUniverse[0].players[i].armies_known = 0;
	    botUniverse[0].players[i].armies_suspected = 0;
	}
	else {
	    if ( player->p_x <= 0 || player->p_y <= 0 ||
		player->p_x >= GWIDTH || player->p_y >= GWIDTH ) {
		/* This handles the case where we can't see
		   the player */
		botInterpolatePosition( &botUniverse[0].players[i].point,
				       &botUniverse[1].players[i].point,
				       &botUniverse[2].players[i].point );

	    }
	    else if (INVISIBLE( player) ) {
		/*
		   cloak - 2 holds really old
		   1 holds last change
		   0 holds current (either real or guess)
		   */
		botUniverse[0].players[i].direction = 0;
		if ( player->p_x == botUniverse[0].players[i].point.x &&
		    player->p_y == botUniverse[0].players[i].point.y ) {
		    if ( !botUniverse[1].players[i].point.interpolated )
			botUniverse[2].players[i].point =
			    botUniverse[1].players[i].point;
		    if ( !botUniverse[0].players[i].point.interpolated )
			botUniverse[1].players[i].point =
			    botUniverse[0].players[i].point;
		    botInterpolatePosition( &botUniverse[0].players[i].point,
					   &botUniverse[1].players[i].point,
					   &botUniverse[2].players[i].point );
		}
		else if ( player->p_x == botUniverse[1].players[i].point.x &&
		    player->p_y == botUniverse[1].players[i].point.y ) {
		    if ( botUniverse[2].players[i].point.x <= 0 &&
			botUniverse[2].players[i].point.y <= 0 )
			botUniverse[2].players[i].point =
			    botUniverse[1].players[i].point;
		    botInterpolatePosition( &botUniverse[0].players[i].point,
					   &botUniverse[1].players[i].point,
					   &botUniverse[2].players[i].point );
		}
		else {
		    if ( !botUniverse[1].players[i].point.interpolated )
			botUniverse[2].players[i].point =
			    botUniverse[1].players[i].point;
		    if ( !botUniverse[0].players[i].point.interpolated )
			botUniverse[1].players[i].point =
			    botUniverse[0].players[i].point;
		    botUniverse[0].players[i].point.x = player->p_x;
		    botUniverse[0].players[i].point.y = player->p_y;
		    botUniverse[0].players[i].point.time = botTimeCounter;
		    botUniverse[0].players[i].point.interpolated = 0;
		}
	    }
	    else {
		botUniverse[2].players[i] = botUniverse[1].players[i];
		botUniverse[1].players[i] = botUniverse[0].players[i];
		botUniverse[0].players[i].point.x = player->p_x;
		botUniverse[0].players[i].point.y = player->p_y;
		botUniverse[0].players[i].point.time = botTimeCounter;
		botUniverse[0].players[i].direction = player->p_dir;
	    }

	    if ( shipCloaked( &players[i] ) && !myPlayer( &players[i] ) ) {
		botUniverse[0].players[i].speed = 
		    hypot((double)botUniverse[0].players[i].point.x-
			  botUniverse[1].players[i].point.x,
			  (double)botUniverse[0].players[i].point.y-
			  botUniverse[1].players[i].point.y)/WARP1/
			      (botUniverse[0].players[i].point.time -
			       botUniverse[1].players[i].point.time);
		if ( botUniverse[0].players[i].point.x ==
		    botUniverse[1].players[i].point.x &&
		    botUniverse[0].players[i].point.y ==
		    botUniverse[1].players[i].point.y )
		    botUniverse[0].players[i].dir = 0;
		else
		    botUniverse[0].players[i].dir =
			( (unsigned char)
			 (atan2((double) botUniverse[0].players[i].point.x -
				botUniverse[1].players[i].point.x,
				(double) botUniverse[1].players[i].point.y -
				botUniverse[0].players[i].point.y) /
			  PI * 128) );
	    }
	    else {
		botUniverse[0].players[i].speed = players[i].p_speed;
		botUniverse[0].players[i].dir = players[i].p_dir;
	    }
	}
    }
    
    /* Now try to figure out who beamed up and beamed down */
    for (i=MAXPLANETS-1; i>=0; --i) {
	if ( botUniverse[0].planets[i].armies <
	    botUniverse[1].planets[i].armies) {
	    if ( botUniverse[1].planets[i].armies < 5 ) {
		int numberOfBeamers = 0;
		/* This means that someone is beaming down armies - it must
		   be someone who does not own the planet */
		for (j=MAXPLAYER-1; j>=0; --j) {
		    if ( (botUniverse[1].planets[i].team !=
			  players[j].p_team) &&
			isAlive( &players[j] ) &&
			(!players[j].p_speed || shipCloaked( &players[j] )) &&
			pointWithinSquare( &botUniverse[0].players[j].point,
					  &botUniverse[0].planets[i].point,
					  2000 ) &&
			(botUniverse[0].players[j].armies_suspected > 0)) {
			numberOfBeamers++;
		    }
		}
		for (j=MAXPLAYER-1; j>=0; --j) {
		    if ( (botUniverse[1].planets[i].team !=
			  players[j].p_team) &&
			isAlive( &players[j] ) &&
			(!players[j].p_speed || shipCloaked( &players[j] )) &&
			pointWithinSquare( &botUniverse[0].players[j].point,
					  &botUniverse[0].planets[i].point,
					  2000 ) ) {
			botUniverse[0].players[j].armies_known--;
			if (numberOfBeamers == 1)
			    botUniverse[0].players[j].armies_suspected--;
		    }
		}
	    }
	    else {
		/* planet had 5 or more armies - either someone is bombing,
		   or someone is beaming them up - assume if no enemy to the
		   planet is near it, then someone is beaming up */
		int bomber = 0;
		for (j=MAXPLAYER-1; j>=0; --j) {
		    if ( (botUniverse[1].planets[i].team !=
			  players[j].p_team) &&
			isAlive( &players[j] ) &&
			(!players[j].p_speed || shipCloaked( &players[j] )) &&
			pointWithinSquare( &botUniverse[0].players[j].point,
					  &botUniverse[0].planets[i].point,
					  2000 ) ) {
			bomber = 1;
			break;
		    }
		}
		if ( !bomber ) {
		    /* No bomber - someone must be beaming up */
		    int numberOfBeamers = 0;

		    for (j=MAXPLAYER-1; j>=0; --j) {
			if ( (botUniverse[1].planets[i].team ==
			      players[j].p_team) &&
			    isAlive( &players[j] ) &&
			    ( (pointWithinSquare( &botUniverse[0].players[j].point,
						 &botUniverse[0].planets[i].point,
						 2000 )  &&
			       (!players[j].p_speed || shipCloaked( &players[j] ) ) ) ||
			     (INVISIBLE( &players[j] ) &&
			      (players[j].p_x < 0 || players[j].p_x > GWIDTH ||
			       players[j].p_y < 0 || players[j].p_y > GWIDTH))) &&
			    (botUniverse[0].players[j].armies_known < 
			     botMaxArmies( &players[j] ) )) {
			    numberOfBeamers++;
			}
		    }
		    for (j=MAXPLAYER-1; j>=0; --j) {
			if ( (botUniverse[1].planets[i].team ==
			      players[j].p_team) &&
			    isAlive( &players[j] ) &&
			    ( (pointWithinSquare( &botUniverse[0].players[j].point, &botUniverse[0].planets[i].point, 2000 ) &&
			       (!players[j].p_speed || shipCloaked( &players[j] ) ) ) ||
			     (INVISIBLE( &players[j] ) &&
			      (players[j].p_x < 0 || players[j].p_x > GWIDTH ||
			       players[j].p_y < 0 || players[j].p_y > GWIDTH))) &&
			    (botUniverse[0].players[j].armies_known < 
			     botMaxArmies( &players[j] ) )) {
			    botUniverse[0].players[j].armies_suspected++;
			    if (numberOfBeamers == 1)
				botUniverse[0].players[j].armies_known++;
			}
		    }
		}
	    }
	}
	else if ( botUniverse[0].planets[i].armies ==
		 botUniverse[1].planets[i].armies + 1) {
	    /* someone could be beaming armies back down */
	    for (j=MAXPLAYER-1; j>=0; --j) {
		if ( (botUniverse[0].planets[i].team ==
		      players[j].p_team) &&
		    isAlive( &players[j] ) &&
		    ( (pointWithinSquare( &botUniverse[0].players[j].point,
					&botUniverse[0].planets[i].point,
					2000 ) &&
		       (!players[j].p_speed || shipCloaked( &players[j] ))) ||
		     ( INVISIBLE( &players[j] ) &&
		      (players[j].p_x < 0 || players[j].p_x > GWIDTH ||
		       players[j].p_y < 0 || players[j].p_y > GWIDTH)))) {
		    --botUniverse[0].players[j].armies_known;
		}
	    }
	}
    }

    if ( !(botPacketReceived % 5) ) {
	mySB = -1;
	enemySB = -1;
	for (i=MAXPLAYER-1; i>=0; --i) {
	    if ( isAlive( &players[i] ) &&
		players[i].p_ship.s_type == STARBASE ) {
		if ( players[i].p_team == me->p_team )
		    mySB = i;
		else
		    enemySB = i;
	    }
	}

	if ( mySB >= 0 ) {
	    for (i=MAXPLAYER-1; i>=0; --i ) {
		if ( isAlive( &players[i] ) && i != mySB &&
		    (!players[i].p_speed || shipCloaked( &players[i] ) ) &&
		    players[i].p_team == me->p_team &&
		    pointWithinSquare( &botUniverse[0].players[i].point,
				      &botUniverse[0].players[mySB].point,
				      2000.0) )
		    botUniverse[0].players[i].armies_suspected++;
	    }
	}
	if ( enemySB >= 0 ) {
	    for (i=MAXPLAYER-1; i>=0; --i ) {
		if ( isAlive( &players[i] ) && i != enemySB &&
		    (!players[i].p_speed || shipCloaked( &players[i] ) ) &&
		    players[i].p_team == players[enemySB].p_team &&
		    pointWithinSquare( &botUniverse[0].players[i].point,
				      &botUniverse[0].players[enemySB].point,
				      2000.0) )
		    botUniverse[0].players[i].armies_suspected++;
	    }
	}
    }    
    
    /* Last step - make sure that suspected armies is non-negative,
       less than max armies and that known armies is less than suspected */
    for (i=MAXPLAYER-1; i>=0; --i) {
	if (botUniverse[0].players[i].armies_suspected < 0)
	    botUniverse[0].players[i].armies_suspected = 0;
	if (botUniverse[0].players[i].armies_known < 0)
	    botUniverse[0].players[i].armies_known = 0;
	if (botUniverse[0].players[i].armies_suspected > 
	    botMaxArmies( &players[i]) )
	    botUniverse[0].players[i].armies_suspected = 
		botMaxArmies( &players[i] );
	if (botUniverse[0].players[i].armies_known > 
	    botUniverse[0].players[i].armies_suspected )
	    botUniverse[0].players[i].armies_known =
		botUniverse[0].players[i].armies_suspected;
    }

    botUniverse[0].players[me->p_no].armies_known = me->p_armies;
    botUniverse[0].players[me->p_no].armies_suspected = me->p_armies;
    
#if 1
    if ( !(botPacketReceived % 300) && botDebug ) {
	botDumpUniverse( stdout );
	fflush(stdout);
    }
#else
    botDumpUniverse( stdout );
#endif

    /* compute if I'm being tractored or pressored */
    computeTractorPressors();
    
    if ( !me->p_speed )
	botSubSpeed = 0;
    else if ( me->p_speed == botUniverse[1].players[me->p_no].speed ) {
	if (botDesiredSpeed > me->p_speed)
	    botSubSpeed += me->p_ship.s_accint *
		(botTimeCounter - botUniverse[1].players[me->p_no].point.time);
	else if (botDesiredSpeed < me->p_speed)
	    botSubSpeed -= me->p_ship.s_decint *
		(botTimeCounter - botUniverse[1].players[me->p_no].point.time);
    }
    else if ( me->p_speed > botUniverse[1].players[me->p_no].speed ) {
	while ( botSubSpeed < me->p_speed * 1000 )
	    botSubSpeed += me->p_ship.s_accint;
    }
    else if ( me->p_speed < botUniverse[1].players[me->p_no].speed ) {
	while ( botSubSpeed >= me->p_speed * 1000 )
	    botSubSpeed -= me->p_ship.s_decint;
    }
    while ( me->p_speed > botSubSpeed / 1000 )
	botSubSpeed += me->p_ship.s_accint;
    while ( me->p_speed < botSubSpeed / 1000 )
	botSubSpeed -= me->p_ship.s_decint;

    i = MAX( botUniverse[0].players[me->p_no].speed,
	    botUniverse[1].players[me->p_no].speed );
    i = botMaxTurn( i ) * (botUniverse[0].players[me->p_no].point.time -
			   botUniverse[1].players[me->p_no].point.time);
    j = angdist( botUniverse[0].players[me->p_no].dir,
		botUniverse[1].players[me->p_no].dir );

    if ( j < i )
	botDesiredCourse = me->p_dir;

    return 1;
}

/*
   Print the universe
   */
void botDumpUniverse( FILE *fp )
{
    int i;
    char buf[100];
    
    if (!botDebug)
	return;
    
    fprintf(fp, "PLAYERS\n");
    for (i=0; i<MAXPLAYER; i++)
    {
	if ( isAlive( &players[i] ) ) {
	    if ( players[i].p_ship.s_type == STARBASE ) {
		if (players[i].p_flags & PFDOCKOK )
		    strcpy( buf, "CAN DOCK" );
		else
		    strcpy( buf, "CAN NOT DOCK" );
	    }
	    else if ( shipOrbitting( &players[i] ) )
		strcpy( buf, "IS ORBITTING" );
	    else if ( players[i].p_flags & PFDOCK )
		strcpy( buf, "IS DOCKED" );
	    else
		strcpy( buf, "");
		
	    fprintf(fp, "%c%c %s speed:%d  dir:%d (%d)  torps:%d  (%5d, %5d) %2d %2d   %s\n",
		    teamlet[players[i].p_team], shipnos[i],
		    classes[players[i].p_ship.s_type],
		    players[i].p_speed,
		    players[i].p_dir,
		    botUniverse[0].players[i].dir,
		    players[i].p_ntorp,
		    botUniverse[0].players[i].point.x,
		    botUniverse[0].players[i].point.y,
		    botUniverse[0].players[i].armies_known,
		    botUniverse[0].players[i].armies_suspected,
		    buf );
	}
    }

    fprintf(fp, "TORPS\n");
    for (i=0; i<MAXTORP * MAXPLAYER; i++)
    {
	if ( botUniverse[0].torps[i].point.x > 0 &&
	     botUniverse[0].torps[i].point.y > 0 ) {
	    fprintf(fp, "%3d %c%c (%5d,%5d) status=%d fuse=%d dir=%d\n",
		    i,
		    teamlet[players[i/MAXTORP].p_team],
		    shipnos[i/MAXTORP],
		    botUniverse[0].torps[i].point.x,
		    botUniverse[0].torps[i].point.y,
		    torps[i].t_status,
		    torps[i].t_fuse,
		    torps[i].t_dir);
	}
    }

    fprintf(fp, "PLASMAS\n");
    for (i=0; i<MAXPLASMA * MAXPLAYER; i++)
    {
	if ( botUniverse[0].plasmas[i].point.x > 0 &&
	     botUniverse[0].plasmas[i].point.y > 0 ) {
	    fprintf(fp, "%3d %1x %5d %5d\n",
		    i,
		    plasmatorps[i].pt_owner,
		    botUniverse[0].plasmas[i].point.x,
		    botUniverse[0].plasmas[i].point.y );
	}
    }

    fprintf(fp, "PLANETS\n");
    for (i=0; i<MAXPLANETS; i++)
    {
	fprintf(fp, "%3s %3d %d %s %s %s\n",
		planets[i].pl_name,
		botUniverse[0].planets[i].armies,
		botUniverse[0].planets[i].team,
		((botUniverse[0].planets[i].planetType >=0) &&
		 (botUniverse[0].planets[i].planetType & PLAGRI)) ?
		"AGRI" : "",
		((botUniverse[0].planets[i].planetType >=0) &&
		 (botUniverse[0].planets[i].planetType & PLFUEL)) ?
		"FUEL" : "",
		((botUniverse[0].planets[i].planetType >=0) &&
		 (botUniverse[0].planets[i].planetType & PLREPAIR)) ?
		"REPAIR" : "" );
    }
}
    
int botTorpOrbittingEnemy(struct player *enemy, int plasmaFlag, int torpTime)
{
    double dp;
    double mex, mey;
    int enemyAngle;
    int iterations = 0;
    int lastEnemyPos;
    int thisEnemyPos;
    int torpAngle;
    int temp2, temp3;
    struct planet *k;
    struct obtype *gettarget(), *target;
    int tmpx, tmpy;
    int ticksToHit;
    BOT_POINT mePoint;
    
    target = gettarget(mapw, enemy->p_x * WINSIDE/GWIDTH,
		       enemy->p_y * WINSIDE/GWIDTH,
		       TARG_PLANET);
    k = &planets[target->o_num];

    if ( !botCurrentPosition( &mePoint,
			     &botUniverse[0].players[me->p_no].point,
			     &botUniverse[1].players[me->p_no].point ) ) {
	mePoint.x = me->p_x;
	mePoint.y = me->p_y;
    }

    torpAngle = botGetAngle( k->pl_x, k->pl_y );
    
    enemyAngle =
	(unsigned char)
	    (atan2( (double) botUniverse[0].players[enemy->p_no].point.x -
		   k->pl_x,
		   (double) k->pl_y -
		   botUniverse[0].players[enemy->p_no].point.y ) *
				  128.0 / PI);

    enemyAngle = NORMALIZE( enemyAngle + borgDelay / 50.0 );

    if ( plasmaFlag )
	dp = 15;
    else
	dp = me->p_ship.s_torpspeed;

    if ( borgVectorTorpSpeed ) {
	mex = me->p_speed * Cos[me->p_dir];
	mey = me->p_speed * Sin[me->p_dir];
	
	dp += mex * Cos[torpAngle] + mey * Sin[torpAngle];
	if (dp > 20.0)
	    dp = 20.0;
    }
    dp *= WARP1;

    tmpx = mePoint.x - k->pl_x;
    tmpy = mePoint.y - k->pl_y;
    ticksToHit = sqrt( (double) (tmpx*tmpx + tmpy*tmpy) ) / dp;
    
    thisEnemyPos = NORMALIZE((enemyAngle + 2 * ticksToHit));
    
    do {
	lastEnemyPos = thisEnemyPos;
	temp2 = (int) (k->pl_x + 800 * Cos[lastEnemyPos]);
	temp3 = (int) (k->pl_y + 800 * Sin[lastEnemyPos]);

	if (borgVectorTorpSpeed) {
	    if ( plasmaFlag )
		dp = 15;
	    else
		dp = me->p_ship.s_torpspeed;
	    torpAngle = botGetAngle( temp2, temp3);
	    dp += mex * Cos[torpAngle] + mey * Sin[torpAngle];
	    if (dp > 20.0)
		dp = 20.0;
	    dp *= WARP1;
	}

	tmpx = mePoint.x - temp2;
	tmpy = mePoint.y - temp3;
	ticksToHit = sqrt( (double) (tmpx*tmpx + tmpy*tmpy) ) / dp;
	thisEnemyPos = NORMALIZE((enemyAngle + 2 * ticksToHit ));
	iterations++;
    } while ( thisEnemyPos != lastEnemyPos && iterations < 25 );

    if ( ticksToHit < torpTime ) {
	torpAngle = botGetAngle( temp2, temp3);

	if ( plasmaFlag ) {
	    sendPlasmaReq( torpAngle );
	}
	else {
	    if ( me->p_fuel > me->p_ship.s_torpcost && me->p_ntorp < MAXTORP) {
		sendTorpReq( torpAngle );
	    }
	}
    }
    else
	return 0;
    
    return 1;
}

int botTorpTurningEnemy(struct player *enemy, int plasmaFlag, int torpTime)
{
    double vxs, vys;
    double dp;
    double mex, mey;
    unsigned char thisAngle;
    int jpx, jpy, mepx, mepy;
    int x, y;
    int i,j;
    double enemyVelocity;
    double enemyDistance, torpDistance;
    unsigned char turnRate;
    unsigned char lastDirection;
    
    if ( !enemy || myPlayer( enemy ) || shipCloaked( me ) )
	return 0;
    
    vxs = 
	(botUniverse[0].players[enemy->p_no].point.x -
	 botUniverse[1].players[enemy->p_no].point.x) /
	     (double) (botUniverse[0].players[enemy->p_no].point.time -
		       botUniverse[1].players[enemy->p_no].point.time);
    vys = 
	(botUniverse[0].players[enemy->p_no].point.y -
	 botUniverse[1].players[enemy->p_no].point.y) /
	     (double) (botUniverse[0].players[enemy->p_no].point.time -
		       botUniverse[1].players[enemy->p_no].point.time);
    
    jpx = botUniverse[0].players[enemy->p_no].point.x +
	borgDelay * vxs / 100.0;
    jpy = botUniverse[0].players[enemy->p_no].point.y +
	borgDelay * vys / 100.0;
    
    mex = 
	(double) (botUniverse[0].players[me->p_no].point.x -
		  botUniverse[1].players[me->p_no].point.x);
    mey = 
	(double) (botUniverse[0].players[me->p_no].point.y -
		  botUniverse[1].players[me->p_no].point.y);
    mepx = me->p_x + borgDelay * mex / 100.0;
    mepy = me->p_y + borgDelay * mey / 100.0;

    if ( plasmaFlag )
	dp = 15.0 * WARP1;
    else
	dp = me->p_ship.s_torpspeed * WARP1;

    turnRate = NORMALIZE( (botUniverse[0].players[enemy->p_no].direction -
			   botUniverse[1].players[enemy->p_no].direction) /
			  (botUniverse[0].players[enemy->p_no].point.time -
			   botUniverse[1].players[enemy->p_no].point.time));

    if ( players[enemy->p_no].p_speed >= 0 &&
	players[enemy->p_no].p_speed <= 12)
	enemyVelocity = players[enemy->p_no].p_speed * WARP1;
    else
	enemyVelocity = (double) hypot( vxs, vys );

    lastDirection = botUniverse[0].players[enemy->p_no].direction;
    x = jpx - mepx;
    y = jpy - mepy;
    torpDistance = 0;
    for (i=0; i<=torpTime; i++) {
	enemyDistance = hypot( (double) x, (double) y );

	if ( ABS( torpDistance - enemyDistance ) < EXPDIST )
	    break;
	else {
	    for (j= ((int) ABS( torpDistance - enemyDistance ) ) / ((int) dp + enemyVelocity); j>0; --j,i++) {
		x += enemyVelocity * Cos[lastDirection];
		y += enemyVelocity * Sin[lastDirection];
		lastDirection = NORMALIZE( lastDirection + turnRate );
		torpDistance += dp;
	    }
	}
    }
    
    if ( i <= torpTime ) {
	thisAngle = (unsigned char) botGetAngle( x + mepx, y + mepy);
	if ( plasmaFlag ) {
	    sendPlasmaReq( thisAngle );
	}
	else {
	    if ( me->p_fuel > me->p_ship.s_torpcost && me->p_ntorp < MAXTORP) {
		sendTorpReq(thisAngle);
	    }
	}
    }
    else
	return 0;
	    
    return 1;
}

int botEnemyTorpMe(struct player *enemy, int speed, int angle)
{
    double vxa, vya;	/* Used for trap shooting */
    double vxs, vys;
    double dp;
    double mex, mey;
    unsigned char lastAngle;
    unsigned char thisAngle;
    unsigned char iterations = 0;
    double l, a, b, c, temp1, temp2, temp3;
    int jpx, jpy, mepx, mepy;
    
    if ( !enemy || myPlayer( enemy ) )
	return 10000;

    jpx = botUniverse[0].players[enemy->p_no].point.x;
    jpy = botUniverse[0].players[enemy->p_no].point.y;
    
    vxs = botUniverse[0].players[enemy->p_no].speed *
	Cos[botUniverse[0].players[enemy->p_no].dir] * WARP1;
    
    vys = botUniverse[0].players[enemy->p_no].speed *
	Sin[botUniverse[0].players[enemy->p_no].dir] * WARP1;

    mepx = me->p_x;
    mepy = me->p_y;
    
    mex = me->p_speed * Cos[me->p_dir] * WARP1;
    mey = me->p_speed * Sin[me->p_dir] * WARP1;

    jpx += vxs * 20;
    jpy += vys * 20;
    
    mepx += mex * 20;
    mepy += mey * 20;
    
    vxa = mepx - jpx;
    vya = mepy - jpy;
    
    mex = speed * Cos[angle];
    mey = speed * Sin[angle];
    
    c = vxa*vxa + vya*vya;
    b = 2*vxa*mex + 2*vya*mey;
    
    if (borgVectorTorpSpeed) {
	thisAngle = botUniverse[0].players[enemy->p_no].dir;
	do {
	    iterations++;
	    lastAngle = thisAngle;
	    dp = enemy->p_ship.s_torpspeed;
	    dp += vxs * Cos[lastAngle] +
		vys * Sin[lastAngle];
	    if (dp > 20.0)
		dp = 20.0;
	    dp *= (double) WARP1;
	    
	    a = mex*mex + mey*mey - dp*dp;
	    
	    l = b*b - 4*a*c;
	    if (l>0 && a != 0.0) {
		l=sqrt(l);
		temp1 = (-b - l) / (2*a);
		temp2 = (-b + l) / (2*a);
		if ((temp1 > 0) && (temp2 > 0) ) {
		    if (temp1 < temp2)
			temp3 = temp1;
		    else
			temp3 = temp2;
		}
		else if (temp1 > 0)
		    temp3 = temp1;
		else if (temp2 > 0)
		    temp3 = temp2;
		else
		    return 100000;
		temp1 = vxa + mex*temp3;
		temp2 = -vya - mey*temp3;
		if ( !temp1 && !temp2 )
		    thisAngle = 0;
		else
		    thisAngle = (unsigned char) (atan2( temp1, temp2) *
						 128.0/ PI );
	    }
	    else
		return 100000;
	    
	} while (thisAngle != lastAngle && iterations < 2 );
    }
    else {
	dp = enemy->p_ship.s_torpspeed * WARP1;

	/* This for formula works as follows:
	   x' = x + vt cos@    ( @ = direction of enemy )
	   y' = y + vt sin@
	   r'^2 = x'^2 + y'^2 =
	           x^2 + 2 xvt cos@ + v^2 t^2 cos^2 @ +
		   y^2 + 2 yvt sin@ + v^2 t^2 sin^2 @ =
		   (x^2 + y^2) + t(2vx cos@ + 2vy sin@) +
		   t^2 (v^2 cos^2 @ + v^2 sin^2 @)
           I know that this should be equal to photon^2 t^2.
	   I subtract that to get...
	   (x^2 + y^2) + t(2vx cos@ + 2vy sin@) +
	   t^2 (v^2 cos^2 @ + v^2 sin^2 @ - p^2) = 0

	   This is a quadratic equation whose roots I can solve for...
	   */
	
	a = mex*mex + mey*mey - dp*dp;

	l = b*b - 4*a*c;
	if (l>0 && a != 0.0) {
	    l=sqrt(l);
	    temp1 = (-b - l) / (2*a);
	    temp2 = (-b + l) / (2*a);
	    if ((temp1 > 0) && (temp2 > 0) ) {
		if (temp1 < temp2)
		    temp3 = temp1;
		else
		    temp3 = temp2;
	    }
	    else if (temp1 > 0)
		temp3 = temp1;
	    else if (temp2 > 0)
		temp3 = temp2;
	    else
		temp3 = 0;
	}
    }

    if ( temp3 > 0 && temp3 < enemy->p_ship.s_torpfuse + 20 )
	return temp3;
    else
	return 100000;
}

int botTorpEnemy(struct player *enemy, int plasmaFlag, int torpTime)
{
    double vxa, vya;	/* Used for trap shooting */
    double vxs, vys;
    double dp;
    double mex, mey;
    unsigned char lastAngle;
    unsigned char thisAngle;
    unsigned char iterations = 0;
    double l, a, b, c, temp1, temp2, temp3;
    int jpx, jpy, mepx, mepy;
    int i;
    
    if ( !enemy || myPlayer( enemy ) || shipCloaked( me ) )
	return 0;

    if ( !enemy->p_speed || INVISIBLE( enemy ) ) {
	for (i=MAXPLANETS-1; i>=0; --i) {
	    if (pointWithinSquare( &botUniverse[0].planets[i].point,
				  &botUniverse[0].players[enemy->p_no].point,
				  1000.0 ) ) {
		return botTorpOrbittingEnemy(enemy, plasmaFlag, 35);
	    }
	}
    }
    
    vxs = botUniverse[0].players[enemy->p_no].speed *
	Cos[botUniverse[0].players[enemy->p_no].dir] * WARP1;

    vys = botUniverse[0].players[enemy->p_no].speed *
	Sin[botUniverse[0].players[enemy->p_no].dir] * WARP1;
    
    mex = me->p_speed * Cos[me->p_dir] * WARP1;
    mey = me->p_speed * Sin[me->p_dir] * WARP1;
    
    jpx = botUniverse[0].players[enemy->p_no].point.x + borgDelay * vxs / 100.0;
    jpy = botUniverse[0].players[enemy->p_no].point.y + borgDelay * vys / 100.0;
    
    mepx = me->p_x + borgDelay * mex / 100.0;
    mepy = me->p_y + borgDelay * mey / 100.0;
    
    vxa = jpx - mepx;
    vya = jpy - mepy;
    
    mex /= (double) WARP1;
    mey /= (double) WARP1;
    
    c = vxa*vxa + vya*vya;
    b = 2*vxa*vxs + 2*vya*vys;
    
    if (borgVectorTorpSpeed) {
	thisAngle = me->p_dir;
	do {
	    iterations++;
	    lastAngle = thisAngle;
	    if (plasmaFlag)
		dp = 15;
	    else
		dp = me->p_ship.s_torpspeed;
	    dp += mex * Cos[lastAngle] +
		mey * Sin[lastAngle];
	    if (dp > 20.0)
		dp = 20.0;
	    dp *= (double) WARP1;
	    
	    a = vxs*vxs + vys*vys - dp*dp;
	    
	    l = b*b - 4*a*c;
	    if (l>0 && a != 0.0) {
		l=sqrt(l);
		temp1 = (-b - l) / (2*a);
		temp2 = (-b + l) / (2*a);
		if ((temp1 > 0) && (temp2 > 0) ) {
		    if (temp1 < temp2)
			temp3 = temp1;
		    else
			temp3 = temp2;
		}
		else if (temp1 > 0)
		    temp3 = temp1;
		else if (temp2 > 0)
		    temp3 = temp2;
		else
		    return 0;
		temp1 = vxa + vxs*temp3;
		temp2 = -vya - vys*temp3;
		if ( !temp1 && !temp2 )
		    thisAngle = 0;
		else
		    thisAngle = (unsigned char) (atan2( temp1, temp2) *
						 128.0/ PI );
	    }
	    else
		return 0;
	    
	} while ((thisAngle != lastAngle) && (iterations < 25) );

	if ( temp3 < torpTime ) {
	    if ( plasmaFlag ) {
		sendPlasmaReq( thisAngle );
	    }
	    else {
		if ( me->p_fuel > me->p_ship.s_torpcost &&
		    me->p_ntorp < MAXTORP ) {
		    sendTorpReq( thisAngle );
		}
	    }
	}
	else
	    return 0;
	
	return 1;
    }
    else {
	if ( plasmaFlag )
	    dp = 15.0 * WARP1;
	else
	    dp = me->p_ship.s_torpspeed * WARP1;

	/* This for formula works as follows:
	   x' = x + vt cos@    ( @ = direction of enemy )
	   y' = y + vt sin@
	   r'^2 = x'^2 + y'^2 =
	           x^2 + 2 xvt cos@ + v^2 t^2 cos^2 @ +
		   y^2 + 2 yvt sin@ + v^2 t^2 sin^2 @ =
		   (x^2 + y^2) + t(2vx cos@ + 2vy sin@) +
		   t^2 (v^2 cos^2 @ + v^2 sin^2 @)
           I know that this should be equal to photon^2 t^2.
	   I subtract that to get...
	   (x^2 + y^2) + t(2vx cos@ + 2vy sin@) +
	   t^2 (v^2 cos^2 @ + v^2 sin^2 @ - p^2) = 0

	   This is a quadratic equation whose roots I can solve for...
	   */
	
	a = vxs*vxs + vys*vys - dp*dp;

	l = b*b - 4*a*c;
	if (l>0 && a != 0.0) {
	    l=sqrt(l);
	    temp1 = (-b - l) / (2*a);
	    temp2 = (-b + l) / (2*a);
	    if ((temp1 > 0) && (temp2 > 0) ) {
		if (temp1 < temp2)
		    temp3 = temp1;
		else
		    temp3 = temp2;
	    }
	    else if (temp1 > 0)
		temp3 = temp1;
	    else if (temp2 > 0)
		temp3 = temp2;
	    else
		return 0;

	    temp1 = vxa + vxs*temp3;
	    temp2 = -vya - vys*temp3;
	    if ( !temp1 && !temp2 )
		thisAngle = 0;
	    else
		thisAngle = (unsigned char) (atan2( temp1, temp2) *
					     128.0 / PI );

	    if (temp3 <= torpTime) {
		if ( plasmaFlag ) {
		    sendPlasmaReq( thisAngle );
		}
		else {
		    if ( me->p_fuel > me->p_ship.s_torpcost &&
			me->p_ntorp < MAXTORP ) {
			sendTorpReq(thisAngle);
		    }
		}
	    }
	    else
		return 0;
	    
	    return 1;
	}
    }
    return 0;
}

/*
   This calculates the angle to fire a phaser to hit an enemy.  Notice
   that this routine tries to compensate for lag...
   */
int botPhaserEnemy( struct player *enemy )
{
    BOT_POINT enemyPoint;
    
    if (!enemy || myPlayer(enemy) || shipCloaked( me ) )
	return 0;

    if ( botCurrentPosition( &enemyPoint,
			    &botUniverse[0].players[enemy->p_no].point,
			    &botUniverse[1].players[enemy->p_no].point ) ){
	sendPhaserReq( botGetAngle( enemyPoint.x, enemyPoint.y) );
	return 1;
    }
    else {
	return 0;
    }
}

int botPhaserPlasma( struct plasmatorp *plasma )
{
    BOT_POINT plasmaPoint;

    if ( !plasma || shipCloaked( me ) )
	return 0;

    if ( botCurrentPosition( &plasmaPoint,
			    &botUniverse[0].plasmas[plasma->pt_owner].point,
			    &botUniverse[1].plasmas[plasma->pt_owner].point ) )
    {
	sendPhaserReq( botGetAngle( plasmaPoint.x, plasmaPoint.y) );
	return 1;
    }
    else {
	return 0;
    }
}			    

void botHandleShields()
{
    int i, j, idx;
    int shieldsUp = 0;
    
    /* PLASMA - if enemy plasma is within 1600 spaces of me, put up shields
                no matter what */

    if ( !isAlive( me ) )
	return;
    
    for (i=MAXPLAYER-1; i>=0; --i) {
	for (j=MAXPLASMA-1; j>=0; --j) {
	    idx = i*MAXPLASMA + j;
	    if ( plasmatorps[idx].pt_status == TMOVE &&
		( !friendlyPlayer( &players[i] ) ||
		 !friendlyPlasmaTorp( &plasmatorps[idx] ) ) &&
		pointWithinSquare( &botUniverse[0].plasmas[idx].point,
				  &botUniverse[0].players[me->p_no].point,
				  1600) ) {
		if ( !(me->p_flags & PFSHIELD) )
		    shield_up();
		return;
	    }
	}
    }
    
    if (me->p_flags & (PFBEAMDOWN|PFBOMB|PFBEAMUP)) {
	/* If I'm beaming down or bombing, do nothing.  My shields should
	   already be lowered if I'm beaming or bombing, and I don't want
	   them raised, so just return */
	return;
    }

    /* PLANETS - when going by enemy or unknown planets, raise shields
                 because the planet may fire at me */
    if ( !shipOrbitting( me ) ) {
	for (i=MAXPLANETS-1; i>=0; --i ) {
	    if ( (!friendlyPlanet( &planets[i] ) ||
		  !(me->p_team & planets[i].pl_info ) ) &&
		pointWithinSquare( &botUniverse[0].players[me->p_no].point,
				  &botUniverse[0].planets[i].point,
				  PFIREDIST + 150 ) ) {
		if ( !(me->p_flags & PFSHIELD) )
		    shield_up();
		return;
	    }
	}
    }

    /* Exploding SHIPS */
    for (i=MAXPLAYER-1; i>=0 && !shieldsUp; --i) {
	if ( (isAlive( &players[i] ) || players[i].p_status == PEXPLODE ) &&
	    !friendlyPlayer( &players[i] ) &&
	    pointWithinSquare( &botUniverse[0].players[me->p_no].point,
			      &botUniverse[0].players[i].point,
			      SHIPDAMDIST ) )
	    shieldsUp = 1;
    }

    /* SHIP's phasers */
    for (i=MAXPLAYER-1; i>=0 && !shieldsUp; --i) {
	if ( isAlive( &players[i] ) &&
	    !friendlyPlayer( &players[i] ) &&
	    players[i].p_ship.s_phaserdamage * PHASEDIST / 100 >
	    botDistanceFromMe( &botUniverse[0].players[i].point ) ) {
	    if (shipCloaked( me )) {
		if ( me->p_damage * 3 < me->p_ship.s_maxdamage )
		    shieldsUp = 1;
	    }
	    else
		shieldsUp = 1;
	}
    }

    /* TORPS */
    for (i=MAXPLAYER-1; i>=0 && !shieldsUp; --i) {
	for (j=MAXTORP-1; j>=0 && !shieldsUp; --j) {
	    idx = i*MAXTORP + j;
	    if ( liveTorp( &torps[idx] ) &&
		!myTorp( &torps[idx] ) &&
		pointWithinSquare( &botUniverse[0].torps[idx].point,
				  &botUniverse[0].players[me->p_no].point,
				  2100) ) {
		shieldsUp = 1;
	    }
	}
    }

    if ( shieldsUp ) {
	if ( me->p_ship.s_type == STARBASE ) {
	    if ( me->p_damage * 2 >= me->p_ship.s_maxshield-me->p_shield ) {
		if ( !(me->p_flags & PFSHIELD) )
		    shield_up();
	    }
	    else {
		if (me->p_flags & PFSHIELD)
		    shield_down();
	    }
	}
	else {
	    if ( !(me->p_flags & PFSHIELD) )
		shield_up();
	}
    }
    else {
	if ( me->p_flags & PFSHIELD )
	    shield_down();
    }
}

/* This handles firing as well as detting of my own torps */
void botHandleTorps( BOT_STRATEGY *strategy )
{
    int torpTime;
    int enemy = -1;
    int i;
    double enemyDistance = 100000.0;
    int missingTorps = 0;
    double missingTorpDistance;
    int numberTorps;
    int idx;
    int sentTorp;

    if ( shipCloaked( me ) || !isAlive( me ) ||
	me->p_fuel < me->p_ship.s_phasercost + 2 *
	me->p_ship.s_torpcost )
	return;
    
    torpTime = borgAutoTorpDist;
    
    for ( i=MAXPLAYER-1; i>=0; --i ) {
	if ( isAlive( &players[i]) && !friendlyPlayer( &players[i] ) &&
	    botDistanceFromMe( &botUniverse[0].players[i].point ) <
	    enemyDistance ) {
	    enemy = i;
	    enemyDistance =
		botDistanceFromMe( &botUniverse[0].players[i].point );
	}
    }

    /* Now - check if my strategy is to attack a player - if it is
       and that player is also in range, attack him instead of the
       closest enemy */
    if ( strategy->player >=0 && strategy->player < MAXPLAYER &&
	isAlive( &players[strategy->player] ) &&
	!friendlyPlayer( &players[strategy->player] ) &&
	botDistanceFromMe( &botUniverse[0].players[strategy->player].point ) <
	5000.0 ) {
	enemy = strategy->player;
	enemyDistance =
	    botDistanceFromMe( &botUniverse[0].players[strategy->player].point );
    }
    
    /* Det my own torps if all of them have missed -
       Idea for improvement - map out the next 20 phases of the
       torps - find out if any are near the enemy.  If not, det */
    if ( me->p_ntorp == MAXTORP ) {
	if ( enemyDistance < 8000 ) {
	    if ( INVISIBLE( &players[enemy] ))
		missingTorpDistance = enemyDistance + 2000;
	    else
		missingTorpDistance = enemyDistance + EXPDIST;
	    
	    numberTorps = 0;
	    for ( i=0; i<MAXTORP; i++) {
		idx = i + me->p_no * MAXTORP;
		if ( torps[idx].t_status == TMOVE ) {
		    numberTorps++;
		    if ( torps[idx].t_status == TMOVE &&
			botDistanceFromMe( &botUniverse[0].torps[idx].point ) >
			missingTorpDistance)
			missingTorps++;
		}
	    }
	    
	    if ( missingTorps >= numberTorps && numberTorps > 0) {
		detmine();
	    }
	}
	return;
    }

    /* Now see if I should fire torps - if I'm a starbase, I'm more willing
       to fire torps (less fear of running out of fuel) */
    if ( enemyDistance < 8000 ) {
	/* try to adjust torp time based on enemy's speed - if
	   the enemy is moving faster, he can't dodge as well,
	   therefore I'm more willing to fire a torp */

	torpTime -= 10 * (1 - me->p_fuel / (double) me->p_ship.s_maxfuel);
	if ( players[enemy].p_ship.s_type == STARBASE )
	    torpTime = borgAutoTorpDist * (1 + players[enemy].p_speed / 2.0);
	else if ( !INVISIBLE( &players[enemy] ) ) {
	    torpTime = borgAutoTorpDist * (players[enemy].p_speed + 1) /
		(1.5 * players[enemy].p_ship.s_maxspeed);
	    torpTime = MAX( torpTime, borgAutoTorpDist );
	}
	else
	    torpTime = borgAutoTorpDist;

	if ( !(botPacketReceived % 3) )
	    torpTime = torpTime / 2;

	if ( torpTime ) {
	    /* only fire 4 torps at a time to conserve fuel */
	    if ((players[enemy].p_x == botUniverse[0].players[enemy].point.x &&
		players[enemy].p_y == botUniverse[0].players[enemy].point.y ) ||
	    me->p_ship.s_type == STARBASE ) {
		if ( me->p_ntorp < MAXTORP )
		    sentTorp = botTorpEnemy( &players[enemy], 0, torpTime);
	    }
	    else {
		if ( me->p_ntorp < 2 )
		    sentTorp = botTorpEnemy( &players[enemy], 0, torpTime);
	    }
	}
	sentTorp = 0;
    }
    sentTorp = 0;

    for ( i=MAXPLAYER-1; i>=0 && !sentTorp; --i ) {
	if ( isAlive( &players[i]) &&
	    !friendlyPlayer( &players[i] ) &&
	    i != enemy &&
	    botDistanceFromMe( &botUniverse[0].players[i].point ) <
	    8000 ) {
	    if ( players[i].p_ship.s_type == STARBASE )
		torpTime = borgAutoTorpDist * (1 + players[enemy].p_speed / 2.0);
	    else if ( !INVISIBLE( &players[i] ) ) {
		torpTime = borgAutoTorpDist * (players[i].p_speed + 1) /
		    (1.5 * players[i].p_ship.s_maxspeed);
		torpTime = MAX( torpTime, borgAutoTorpDist );
	    }
	    else
		torpTime = borgAutoTorpDist;
	
	    if ( !(botPacketReceived % 3) )
		torpTime = torpTime / 2;

	    if ( torpTime ) {
		/* only fire 4 torps at a time to conserve fuel */
		if ((players[i].p_x == botUniverse[0].players[i].point.x &&
		     players[i].p_y == botUniverse[0].players[i].point.y ) ||
		    me->p_ship.s_type == STARBASE ) {
		    if ( me->p_ntorp < MAXTORP )
			sentTorp = botTorpEnemy( &players[i], 0, torpTime);
		}
		else {
		    if ( me->p_ntorp < 2 )
			sentTorp = botTorpEnemy( &players[i], 0, torpTime);
		}
	    }
	}
    }
}

void botHandlePlasmas()
{
    int enemy = -1;
    int i;
    double enemyDistance = 100000.0;

    if ( !isAlive( me ) )
	return;
    
    /* If I'm not a starbase, don't bother firing.  Also, don't fire if
       my wtemp is too high, I don't want to overheat the weapons! */
    if ( shipCloaked( me ) || me->p_ship.s_type != STARBASE ||
	me->p_wtemp > .40 * me->p_ship.s_maxwpntemp )
	return;

    /* Check to see if I have already fired the plasma */
    for (i=me->p_no * MAXPLASMA; i<me->p_no * MAXPLASMA + MAXPLASMA; i++)
	if ( plasmatorps[i].pt_status != TMOVE )
	    break;
    if ( i == me->p_no * MAXPLASMA + MAXPLASMA )
	return;
    
    for ( i=0; i<MAXPLAYER; i++ ) {
	if ( isAlive( &players[i]) && !friendlyPlayer( &players[i] ) &&
	    INVISIBLE( &players[i] ) &&
	    botDistanceFromMe( &botUniverse[0].players[i].point ) <
	    enemyDistance ) {
	    enemy = i;
	    enemyDistance =
		botDistanceFromMe( &botUniverse[0].players[i].point );
	}
    }

    if ( enemyDistance < 8000 ) {
	botTorpEnemy( &players[enemy], 1, 25);
    }    
}

void botHandlePhasers( BOT_STRATEGY *strategy )
{
    int enemy;
    int i,j;
    int idx;
    double enemyDistance = 100000.0;
    double distance;
    int maxPhaserDistance;
    int minPhaserDamage;
    int numberOfDets;
    BOT_POINT enemyPoint;
    struct torp *t;
    int wasPhasering = 0;
    static int phaserTime = 0;
    
    if ( shipCloaked( me ) || !isAlive( me ) ||
	me->p_fuel < me->p_ship.s_phasercost )
	return;

    if ( phasers[me->p_no].ph_status == PHFREE ) {
	wasPhasering = phaserTime;
    }

    if ( phasers[me->p_no].ph_status == PHHIT )
	phaserTime++;
    else
	phaserTime = 0;

    if ( phasers[me->p_no].ph_status != PHFREE )
	return;
    
    maxPhaserDistance = me->p_ship.s_phaserdamage * PHASEDIST / 100;

    /* First, destroy enemy plasmas! */
    for ( i=MAXPLAYER-1; i>=0; --i ) {
	for (j=MAXPLASMA-1; j>=0; --j) {
	    idx = i*MAXPLASMA + j;
	    if ( plasmatorps[idx].pt_status == TMOVE &&
		!friendlyPlayer( &players[i] ) &&
		botDistanceFromMe( &botUniverse[0].plasmas[idx].point) <
		maxPhaserDistance ) {
		enemyDistance =
		    botDistanceFromMe( &botUniverse[0].plasmas[idx].point);
		enemy = idx;
	    }
	}
    }
    
    if ( enemyDistance < maxPhaserDistance ) {
	botPhaserPlasma( &plasmatorps[ enemy ] );
	return;
    }

    /* Find the closest enemy */
    enemyDistance = 1000000.0;
    for (i=MAXPLAYER-1; i>=0; --i ) {
	if ( isAlive( &players[i]) &&
	    !friendlyPlayer( &players[i] ) &&
	    pointWithinSquare( &botUniverse[0].players[i].point,
			      &botUniverse[0].players[me->p_no].point,
			      maxPhaserDistance ) ) {
	    distance = botDistanceFromMe( &botUniverse[0].players[i].point);
	    if ( distance < enemyDistance ) {
		enemy = i;
		enemyDistance = distance;
	    }
	}
    }

    if ( enemyDistance < maxPhaserDistance ) {
	if (me->p_ship.s_type == STARBASE) {
	    minPhaserDamage = (75 * me->p_wtemp) / me->p_ship.s_maxwpntemp;
	    if (minPhaserDamage < 30)
		minPhaserDamage = 30;
	    if (minPhaserDamage > ( players[enemy].p_ship.s_maxshield +
				   players[enemy].p_ship.s_maxdamage ) / 4 )
		minPhaserDamage = ( players[enemy].p_ship.s_maxshield +
				   players[enemy].p_ship.s_maxdamage ) / 4;
	}
	else {
	    minPhaserDamage = borgAutoPhaserDist *
		players[enemy].p_ship.s_maxdamage / 100.0;
	    if (minPhaserDamage > borgAutoPhaserDist)
		minPhaserDamage = borgAutoPhaserDist;
	}

	maxPhaserDistance *= 1.0 - minPhaserDamage / 
	  (double) me->p_ship.s_phaserdamage;

	/* Now - check if my strategy is to attack a player - if it is
	   and that player is also in range, attack him instead of the
	   closest enemy */
	if ( strategy->player >=0 && strategy->player < MAXPLAYER &&
	    isAlive( &players[strategy->player] ) &&
	    !friendlyPlayer( &players[strategy->player] ) &&
	    botDistanceFromMe( &botUniverse[0].players[strategy->player].point ) <
	    maxPhaserDistance ) {
	    enemy = strategy->player;
	    enemyDistance =
		botDistanceFromMe( &botUniverse[0].players[strategy->player].point );
	}
	
	/* Fire phasers if ship is within range */
	if ( enemyDistance < maxPhaserDistance &&
	    players[enemy].p_x == botUniverse[0].players[enemy].point.x &&
	    players[enemy].p_y == botUniverse[0].players[enemy].point.y )
	{
	    if ( INVISIBLE( &players[enemy] ) ) {
		if ( wasPhasering ) {
		    botInterpolatePosition( &enemyPoint,
					   &botUniverse[1].players[enemy].point,
					   &botUniverse[2].players[enemy].point);
		    sendPhaserReq( botGetAngle( enemyPoint.x,
					       enemyPoint.y ) );
		}
		else
		    sendPhaserReq( botGetAngle( players[enemy].p_x,
					       players[enemy].p_y) );
	    }
	    else
		botPhaserEnemy( &players[enemy] );
	    return;
	}

	/* Finally, if we haven't fired phasers yet, and a cloaker detonates
	   my torps, try to fire phasers at the average of the detted torps
	   position */
	if (INVISIBLE( &players[enemy] ) ) {
	    MZERO( &enemyPoint, sizeof(enemyPoint) );
	    numberOfDets = 0;
	    for (i=MAXPLAYER-1; i>=0; --i) {
		for (j=MAXTORP-1; j>=0; --j) {
		    idx = i*MAXTORP+j;
		    t = &torps[idx];
		    if ( t->t_status == TEXPLODE &&
			( friendlyTorp( t ) || friendlyPlayer( &players[i])) &&
			ABS(t->t_x - botUniverse[0].players[enemy].point.x) <
			1000 &&
			ABS(t->t_y - botUniverse[0].players[enemy].point.y)
			< 1000 ) {
			enemyPoint.x += t->t_x;
			enemyPoint.y += t->t_y;
			numberOfDets++;
		    }
		}
	    }
	    if ( numberOfDets ) {
		enemyPoint.x /= numberOfDets;
		enemyPoint.y /= numberOfDets;
		if ( botDistanceFromMe( &enemyPoint ) < maxPhaserDistance ) {
		    sendPhaserReq( botGetAngle( enemyPoint.x, enemyPoint.y) );
		}
	    }
	}
    }
}

void botHandleBombBeamDown()
{
    struct planet *k;
    struct obtype *gettarget(), *target;
    int i;
    int teamAStaker;
    int enemyTeam;
    
    if ( !isAlive( me ) || !status->tourn || !shipOrbitting( me ))
	return;
    
    enemyTeam = botEnemyTeam();
    target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
		       me->p_y * WINSIDE/GWIDTH, TARG_PLANET);
    k = &planets[target->o_num];      

    if ( myPlanet( k ) && me->p_armies ) {
	if ( k->pl_armies < 4 ) {
	    if ( !(me->p_flags & PFBEAMDOWN) ) {
		beam_down();
	    }
	}
	else if ( !(me->p_flags & PFSHIELD ) &&
		 (me->p_flags & PFBEAMDOWN) )
	    shield_up();
    }
    
    if ( k->pl_armies && k->pl_owner != enemyTeam )
	return;
	
    teamAStaker=0;
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( players[i].p_team == me->p_team &&
	    players[i].p_ship.s_type == ASSAULT &&
	    botUniverse[0].players[i].armies_known > 0 ) {
	    teamAStaker++;
	    break;
	}
    }

    if ( (teamAStaker || myCorePlanet( k ))
	&& k->pl_armies == 5 &&
	!me->p_armies ) {
	if ( !(me->p_flags & PFSHIELD ) )
	    shield_up();
    }
    else if ( k->pl_armies > 4 ) {
	if (!(me->p_flags & PFBOMB) )
	    bomb_planet();
    }
    else if ( !(me->p_flags & PFBEAMDOWN) &&
	     !(k->pl_flags & PLAGRI) &&
	     me->p_armies && k->pl_armies <= 4 )
	beam_down();
    else if ( !(me->p_flags & PFBEAMDOWN) &&
	     (k->pl_flags & PLAGRI) &&
	     me->p_armies >= k->pl_armies )
	beam_down();
}

void botHandleRepairBeamUp( BOT_STRATEGY *strategy )
{
    struct planet *k;
    struct obtype *gettarget(), *target;
    int needRepair;
    int i;
    
    if ( (me->p_flags & PFRED) || !isAlive( me ) ) 
	return;

    if ( !me->p_damage && me->p_shield == me->p_ship.s_maxshield ) {
	needRepair = 0;
    }
    else
	needRepair = 1;
    
    if ( shipOrbitting( me ) ) {
	target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			   me->p_y * WINSIDE/GWIDTH, TARG_PLANET);
	k = &planets[target->o_num];      

	if ( !k->pl_armies && me->p_armies )
	    needRepair = 0;

	if ( k->pl_armies < 4 && me->p_armies && myPlanet( k ) )
	    needRepair = 0;
	
	if ( needRepair && friendlyPlanet( k ) && !(me->p_flags & PFREPAIR) ) 
	    sendRepairReq( 1 );
	else if ( botPlanetTaker ) {
	    if (!(me->p_flags & PFBEAMUP) &&
		me->p_armies < botMaxArmies( me ) &&
		k->pl_armies > 4 &&
		myPlanet( k ) && status->tourn &&
		strategy->plan == ST_GET )
		beam_up();
	}
    }
    else if ( me->p_flags & PFDOCK ) {
	if ( needRepair && !(me->p_flags & PFREPAIR) ) 
	    sendRepairReq( 1 );
	else if ( botPlanetTaker ) {
	    if (!(me->p_flags & PFBEAMUP) &&
		me->p_armies < botMaxArmies( me ) &&		
		status->tourn  ) {
		for (i=MAXPLAYER-1; i>=0; --i ) {
		    if ( isAlive( &players[i] ) &&
			players[i].p_team == me->p_team &&
			players[i].p_ship.s_type == STARBASE &&
			botUniverse[0].players[i].armies_suspected &&
			strategy->plan == ST_GET )
			beam_up();
		}
	    }
	}
    }
}

#define BOT_LOOKAHEAD 18
botProjectTorpPositions( BOT_POINT points[(MAXTORP+MAXPLASMA)*MAXPLAYER][BOT_LOOKAHEAD], int plasmas )
{
    int i,j,k;
    int idx;
    int deltaX, deltaY;
    int tmpx, tmpy;
    int tmpDistance;
    int numberOfTorps = 0;
    struct torp *t;
#ifdef TORPDEBUG
    char timebuf[100];
#endif
    
    MZERO( points, sizeof(points) );
    
#ifdef TORPDEBUG
    botTime(timebuf);
    printf("\n\n\n%s\n", timebuf);
    printf("TORPS\n");
#endif

    tmpDistance = 2 * EXPDIST;
    for (i=MAXPLAYER-1; i>=0; --i) {
	for (j=MAXTORP-1; j>=0; --j) {
	    idx = i*MAXTORP+j;
	    t = &torps[idx];
	    if ( (!friendlyPlayer( &players[i] ) ||
		  !friendlyTorp( &torps[idx] ) ) &&
		t->t_x > 0 &&
		t->t_y > 0 &&
		botUniverse[1].torps[idx].point.x > 0 &&
		botUniverse[1].torps[idx].point.y > 0 ) {
		/* Calculate how far torp moves per tick */
		deltaX = (t->t_x - botUniverse[1].torps[idx].point.x) /
		    (botUniverse[0].torps[idx].point.time - 
		     botUniverse[1].torps[idx].point.time);
		deltaY = (t->t_y - botUniverse[1].torps[idx].point.y) /
		    (botUniverse[0].torps[idx].point.time - 
		     botUniverse[1].torps[idx].point.time);

		tmpx = t->t_x - me->p_x;
		tmpy = t->t_y - me->p_y;

		if ( ((tmpx > tmpDistance && deltaX > 0) ||
		      (tmpx < -tmpDistance && deltaX < 0) )
		    && ((tmpy > tmpDistance && deltaY > 0) ||
			(tmpy < tmpDistance && deltaY < 0)) )
		{
		    continue;
		}

		numberOfTorps++;
		/* Now, predict future positions */
		points[idx][0].x = t->t_x + deltaX * borgDelay / 100.0;
		points[idx][0].y = t->t_y + deltaY * borgDelay / 100.0;

		if ( points[idx][0].x <= 0 ) {
		    points[idx][0].x = 0;
		    points[idx][0].angle = 1;
		}
		if ( points[idx][0].y <= 0 ) {
		    points[idx][0].y = 0;
		    points[idx][0].angle = 1;
		}
		if ( points[idx][0].x >= GWIDTH ) {
		    points[idx][0].x = GWIDTH;
		    points[idx][0].angle = 1;
		}
		if ( points[idx][0].y >= GWIDTH ) {
		    points[idx][0].y = GWIDTH;
		    points[idx][0].angle = 1;
		}
		if ( points[idx][0].angle )
		    continue;
#ifdef TORPDEBUG
		printf("%d 0:  (%d, %d)\n",
		       idx, points[idx][0].x, points[idx][0].y);
#endif
		for (k=1; k<BOT_LOOKAHEAD; k++) {
		    points[idx][k].x = points[idx][k-1].x + deltaX;
		    points[idx][k].y = points[idx][k-1].y + deltaY;

		    if ( points[idx][k].x <= 0 ) {
			points[idx][k].x = 0;
			points[idx][k].angle = 1;
		    }
		    if ( points[idx][k].y <= 0 ) {
			points[idx][k].y = 0;
			points[idx][k].angle = 1;
		    }
		    if ( points[idx][k].x >= GWIDTH ) {
			points[idx][k].x = GWIDTH;
			points[idx][k].angle = 1;
		    }
		    if ( points[idx][k].y >= GWIDTH ) {
			points[idx][k].y = GWIDTH;
			points[idx][k].angle = 1;
		    }
		    if ( points[idx][k].angle )
			break;
#ifdef TORPDEBUG
		    printf("%d %d:  (%d, %d)\n",
			   idx, k, points[idx][k].x, points[idx][k].y);
#endif
		}
	    }
	}
	for (j=MAXPLASMA-1; j>=0 && plasmas; --j) {
	    idx = i*MAXPLASMA+j;
	    if ( (!friendlyPlayer( &players[i] ) ||
		  !friendlyPlasmaTorp( &plasmatorps[idx] ) ) &&
		botUniverse[0].plasmas[idx].point.x > 0 &&
		botUniverse[0].plasmas[idx].point.y > 0 &&
		botUniverse[1].plasmas[idx].point.x > 0 &&
		botUniverse[1].plasmas[idx].point.y > 0 ) {
		/* Calculate how far torp moves per tick */
		deltaX = (botUniverse[0].plasmas[idx].point.x -
			  botUniverse[1].plasmas[idx].point.x) /
			      (botUniverse[0].plasmas[idx].point.time - 
			       botUniverse[1].plasmas[idx].point.time);
		deltaY = (botUniverse[0].plasmas[idx].point.y -
			  botUniverse[1].plasmas[idx].point.y) /
			      (botUniverse[0].plasmas[idx].point.time - 
			       botUniverse[1].plasmas[idx].point.time);

		tmpx = botUniverse[0].plasmas[idx].point.x - me->p_x;
		tmpy = botUniverse[0].plasmas[idx].point.y - me->p_y;

		if ( (tmpx > 0 && deltaX > 0) || (tmpx < 0 && deltaX < 0) )
		    tmpx = 1;
		else
		    tmpx = 0;
		if ( (tmpy > 0 && deltaY > 0) || (tmpy < 0 && deltaY < 0) )
		    tmpy = 0;
		else
		    tmpy = 0;
		if (tmpx && tmpy)
		    continue;

		numberOfTorps++;
		/* Now, predict future positions */
		idx += MAXPLAYER*MAXTORP;
		points[idx][0].x =
		    plasmatorps[idx-MAXPLAYER*MAXTORP].pt_x + 
		    deltaX * borgDelay / 100.0;
		points[idx][0].y =
		    plasmatorps[idx-MAXPLAYER*MAXTORP].pt_y +
		    deltaY * borgDelay / 100.0;
		for (k=1; k<BOT_LOOKAHEAD; k++) {
		    points[idx][k].x = points[idx][k-1].x + deltaX;
		    points[idx][k].y = points[idx][k-1].y + deltaY;
		}
	    }
	}
    }

    return numberOfTorps;
}

#define BOT_MAXDIRECTIONSPERSPEED 17
/* 17 angles to dodge * 3 different speeds * 3 states for pressors (on/off/tractor) 
 * 8 people to use tractors on */
#define BOT_MAXDODGEANGLES BOT_MAXDIRECTIONSPERSPEED*3*3*7
/* #define BOT_TP_LOOKAHEAD BOT_LOOKAHEAD */
#define BOT_TP_LOOKAHEAD 8

botProjectShipsWithTP( BOT_POINT mePoints[BOT_MAXDODGEANGLES][BOT_LOOKAHEAD],
			BOT_DIRECTION dodgeDirections[BOT_MAXDODGEANGLES],
		      int numberOfNoTPdirections )
{
    BOT_POINT enemyShips[MAXPLAYER];
    BOT_POINT tmpEnemyShips[MAXPLAYER];
    int deltaX[MAXPLAYER], deltaY[MAXPLAYER];
    int tractorStrength[MAXPLAYER], tractorRange[MAXPLAYER];
    int tractorRangeSquared[MAXPLAYER];
    int tractorOpponents[MAXPLAYER];
    int idx;
    int i,j,k,l,m;
    int myTractorRange;
    int myTractorRangeSquared;
    int myTractorStrength;
    int beingTractored;
    int canTractor;
    int tmpx, tmpy;
    int tmpDistance;
    int distance;
    int numberOfDirections;
    int myDeltaX, myDeltaY;
    
    numberOfDirections = numberOfNoTPdirections;
    
    /* Now - see how tractor/pressor beams affect my position.
       Start by initializing all of my opponents information */
    for (i=MAXPLAYER-1; i>=0; --i) {
	if (!isAlive( &players[i] ) ||
	    myPlayer( &players[i] ) ||
	    !pointWithinSquare( &botUniverse[0].players[i].point,
			       &botUniverse[0].players[me->p_no].point,
			       10000.0 ) )
	    continue;
	
	deltaX[i] = WARP1 * botUniverse[0].players[i].speed *
	    Cos[botUniverse[0].players[i].dir];
	deltaY[i] = WARP1 * botUniverse[0].players[i].speed *
	    Sin[botUniverse[0].players[i].dir];
	enemyShips[i].x = botUniverse[0].players[i].point.x +
	    deltaX[i] * borgDelay / 100.0;
	enemyShips[i].y = botUniverse[0].players[i].point.y +
	    deltaY[i] * borgDelay / 100.0;
	tractorRange[i] = players[i].p_ship.s_tractrng * TRACTDIST;
	tractorRangeSquared[i] = tractorRange[i] * tractorRange[i];
	tractorStrength[i] = WARP1 * players[i].p_ship.s_tractstr;
    }
    myTractorRange = me->p_ship.s_tractrng * TRACTDIST;
    myTractorStrength = WARP1 * me->p_ship.s_tractstr;
    myTractorRangeSquared = myTractorRange * myTractorRange;
    
    beingTractored = 0;
    for (i=MAXPLAYER-1; i>=0 && !beingTractored; --i)
	if (botUniverse[0].players[i].tractorEnemy == me->p_no ||
	    botUniverse[0].players[i].pressorEnemy == me->p_no )
	    beingTractored = 1;

    canTractor = 0;
    if ( !INVISIBLE( me ) ) {
	for (i=MAXPLAYER-1; i>=0; --i) {
	    tractorOpponents[i] = 0;
	    if ( !isAlive( &players[i] ) ||
		friendlyPlayer( &players[i] ) ||
		INVISIBLE( &players[i] ) ||
		!pointWithinSquare( &botUniverse[0].players[i].point,
				   &botUniverse[0].players[me->p_no].point,
				   myTractorRange ) )
		continue;
	    
	    tmpx = mePoints[0][0].x - enemyShips[i].x;
	    tmpy = mePoints[0][0].y - enemyShips[i].y;

	    if ( tmpx * tmpx + tmpy * tmpy > myTractorRangeSquared )
		continue;

	    canTractor++;
	    tractorOpponents[i] = 1;
	}
    }

    if ( canTractor ) {
	/* Now, generate positions if I use my pressor beams on an enemy */
	for (i=MAXPLAYER-1; i>=0; --i) {
	    if ( !tractorOpponents[i] )
		continue;

	    numberOfDirections += numberOfNoTPdirections;
	    for (j=numberOfNoTPdirections-1; j>=0; --j) {
		myDeltaX = 0;
		myDeltaY = 0;
		for (k=MAXPLAYER-1; k>=0; --k) {
		    tmpEnemyShips[k].x = enemyShips[k].x;
		    tmpEnemyShips[k].y = enemyShips[k].y;
		}

		idx = numberOfDirections - numberOfNoTPdirections + j;
		dodgeDirections[idx] = dodgeDirections[j];
		dodgeDirections[idx].index = idx;
		dodgeDirections[idx].pressorEnemy = i;
		for (k=BOT_LOOKAHEAD-1; k>=0; --k) {
		    mePoints[idx][k].x = mePoints[j][k].x;
		    mePoints[idx][k].y = mePoints[j][k].y;
		}
	    
		for (k=1; k<BOT_LOOKAHEAD; k++) {
		    /* first - apply my pressors */
		    tmpEnemyShips[i].x += deltaX[i];
		    tmpEnemyShips[i].y += deltaY[i];
		    tmpx = tmpEnemyShips[i].x-mePoints[idx][k].x-myDeltaX;
		    tmpy = tmpEnemyShips[i].y-mePoints[idx][k].y-myDeltaY;
		
		    if ( k < BOT_TP_LOOKAHEAD &&
			tmpx < myTractorRange &&
			tmpy < myTractorRange &&
			(tmpDistance = tmpx * tmpx + tmpy * tmpy) <
			myTractorRangeSquared ) {

			distance = sqrt( (double) tmpDistance );
			if ( distance == 0 )
			    distance = 1;
		
			tmpEnemyShips[i].x += myTractorStrength * tmpx /
			    (double) distance / players[i].p_ship.s_mass;
			tmpEnemyShips[i].y += myTractorStrength * tmpy /
			    (double) distance / players[i].p_ship.s_mass;
		
			myDeltaX -= myTractorStrength * tmpx /
			    (double) distance / me->p_ship.s_mass;
			myDeltaY -= myTractorStrength * tmpy /
			    (double) distance / me->p_ship.s_mass;
		    }

		    if ( beingTractored && k < BOT_TP_LOOKAHEAD ) {
			for (l=MAXPLAYER-1; l>=0; --l) {
			    if (!isAlive( &players[l] ) ||
				myPlayer( &players[l] ) ||
				(botUniverse[0].players[l].tractorEnemy != me->p_no &&
				 botUniverse[0].players[l].pressorEnemy != me->p_no ) )
				continue;
			    if ( l != i ) {
				tmpEnemyShips[l].x += deltaX[l];
				tmpEnemyShips[l].y += deltaY[l];
			    }
			    
			    tmpx = mePoints[idx][k].x+myDeltaX-tmpEnemyShips[l].x;
			    tmpy = mePoints[idx][k].y+myDeltaY-tmpEnemyShips[l].y;

			    if ( tmpx > tractorRange[l] || tmpy > tractorRange[l] )
				continue;

			    tmpDistance = tmpx * tmpx + tmpy * tmpy;
			    if (tmpDistance > tractorRangeSquared[l])
				continue;
			    distance = sqrt( (double) tmpDistance);
			    if ( distance == 0 )
				distance = 1;
			    if ( distance > tractorRange[l] )
				continue;
			    
			    if ( botUniverse[0].players[l].pressorEnemy == me->p_no )
				m = -1;
			    else
				m = 1;
			    
			    tmpEnemyShips[l].x += m * tractorStrength[l] * tmpx /
				(double) distance / players[l].p_ship.s_mass;
			    tmpEnemyShips[l].y += m * tractorStrength[l] * tmpy /
				(double) distance / players[l].p_ship.s_mass;
			    
			    myDeltaX -= m * tractorStrength[l] * tmpx /
				(double) distance / me->p_ship.s_mass;
			    myDeltaY -= m * tractorStrength[l] * tmpy /
				(double) distance / me->p_ship.s_mass;
			}
		    }
		    mePoints[idx][k].x += myDeltaX;
		    mePoints[idx][k].y += myDeltaY;
		}
	    }	    
	}
	
	/* Now, generate positions if I use my tractor beams on an enemy */
	for (i=MAXPLAYER-1; i>=0; --i) {
	    if ( !tractorOpponents[i] )
		continue;

	    numberOfDirections += numberOfNoTPdirections;
	    for (j=numberOfNoTPdirections-1; j>=0; --j) {
		myDeltaX = 0;
		myDeltaY = 0;
		for (k=MAXPLAYER-1; k>=0; --k) {
		    tmpEnemyShips[k].x = enemyShips[k].x;
		    tmpEnemyShips[k].y = enemyShips[k].y;
		}

		idx = numberOfDirections - numberOfNoTPdirections + j;
		dodgeDirections[idx] = dodgeDirections[j];
		dodgeDirections[idx].index = idx;
		dodgeDirections[idx].tractorEnemy = i;
		for (k=BOT_LOOKAHEAD-1; k>=0; --k) {
		    mePoints[idx][k].x = mePoints[j][k].x;
		    mePoints[idx][k].y = mePoints[j][k].y;
		}
	    
		for (k=1; k<BOT_LOOKAHEAD; k++) {
		    /* first - apply my tractors */
		    tmpEnemyShips[i].x += deltaX[i];
		    tmpEnemyShips[i].y += deltaY[i];
		    tmpx = tmpEnemyShips[i].x - mePoints[idx][k].x-myDeltaX;
		    tmpy = tmpEnemyShips[i].y - mePoints[idx][k].y-myDeltaY;
		
		    if ( k < BOT_TP_LOOKAHEAD &&
			tmpx < myTractorRange &&
			tmpy < myTractorRange &&
			(tmpDistance = tmpx*tmpx + tmpy*tmpy) <
			myTractorRangeSquared) {

			distance = sqrt( (double) tmpDistance);
			if ( distance == 0 )
			    distance = 1;
		
			tmpEnemyShips[i].x -= myTractorStrength * tmpx /
			    (double) distance / players[i].p_ship.s_mass;
			tmpEnemyShips[i].y -= myTractorStrength * tmpy /
			    (double) distance / players[i].p_ship.s_mass;
		
			myDeltaX += myTractorStrength * tmpx /
			    (double) distance / me->p_ship.s_mass;
			myDeltaY += myTractorStrength * tmpy /
			    (double) distance / me->p_ship.s_mass;
		    }

		    if (beingTractored && k < BOT_TP_LOOKAHEAD) {
			for (l=MAXPLAYER-1; l>=0; --l) {
			    if (!isAlive( &players[l] ) ||
				myPlayer( &players[l] ) ||
				(botUniverse[0].players[l].tractorEnemy != me->p_no &&
				 botUniverse[0].players[l].pressorEnemy != me->p_no ) )
				continue;
			    if (l != i) {
				tmpEnemyShips[l].x += deltaX[l];
				tmpEnemyShips[l].y += deltaY[l];
			    }
			    
			    tmpx = mePoints[idx][k].x+myDeltaX - tmpEnemyShips[l].x;
			    tmpy = mePoints[idx][k].y+myDeltaY - tmpEnemyShips[l].y;
			    
			    if ( tmpx > tractorRange[l] || tmpy > tractorRange[l] )
				continue;

			    tmpDistance = tmpx*tmpx + tmpy*tmpy;
			    if (tmpDistance > tractorRangeSquared[l])
				continue;
			    distance = sqrt( (double) tmpDistance );
			    if ( distance == 0 )
				distance = 1;
			    if ( distance > tractorRange[l] )
				continue;
			    
			    if ( botUniverse[0].players[l].pressorEnemy == me->p_no )
				m = -1;
			    else
				m = 1;
			    
			    tmpEnemyShips[l].x += m * tractorStrength[l] * tmpx /
				(double) distance / players[l].p_ship.s_mass;
			    tmpEnemyShips[l].y += m * tractorStrength[l] * tmpy /
				(double) distance / players[l].p_ship.s_mass;
			    
			    myDeltaX -= m * tractorStrength[l] * tmpx /
				(double) distance / me->p_ship.s_mass;
			    myDeltaY -= m * tractorStrength[l] * tmpy /
				(double) distance / me->p_ship.s_mass;
			}
		    }
		    mePoints[idx][k].x += myDeltaX;
		    mePoints[idx][k].y += myDeltaY;
		}
	    }	    
	}
    }
    
    /* Now, this code shows how the enemy's T/P beams affect my position
       when I'm not using T/P's */
    if ( beingTractored ) {
	for (i=numberOfNoTPdirections-1; i>=0; --i) {
	    myDeltaX = 0;
	    myDeltaY = 0;
	    
	    for (j=MAXPLAYER-1; j>=0; --j) {
		tmpEnemyShips[j].x = enemyShips[j].x;
		tmpEnemyShips[j].y = enemyShips[j].y;
	    }
	    
	    for (j=1; j<BOT_LOOKAHEAD; j++) {
		if (j < BOT_TP_LOOKAHEAD ) {
		    for (k=MAXPLAYER-1; k>=0; --k) {
			if (!isAlive( &players[k] ) ||
			    myPlayer( &players[k] ) ||
			    (botUniverse[0].players[k].tractorEnemy != me->p_no &&
			     botUniverse[0].players[k].pressorEnemy != me->p_no ) )
			    continue;
			tmpEnemyShips[k].x += deltaX[k];
			tmpEnemyShips[k].y += deltaY[k];
			
			tmpx = mePoints[i][j].x+myDeltaX - tmpEnemyShips[k].x;
			tmpy = mePoints[i][j].y+myDeltaY - tmpEnemyShips[k].y;
			
			if ( tmpx > tractorRange[k] || tmpy > tractorRange[k] )
			    continue;

			tmpDistance = tmpx*tmpx + tmpy*tmpy;
			if (tmpDistance > tractorRangeSquared[k] )
			    continue;
			
			distance = sqrt( (double) tmpDistance);
			if ( distance == 0 )
			    distance = 1;
			if ( distance > tractorRange[k] )
			    continue;
			
			if ( botUniverse[0].players[k].pressorEnemy == me->p_no )
			    l = -1;
			else
			    l = 1;
			
			tmpEnemyShips[k].x += l * tractorStrength[k] * tmpx /
			    (double) distance / players[k].p_ship.s_mass;
			tmpEnemyShips[k].y += l * tractorStrength[k] * tmpy /
			    (double) distance / players[k].p_ship.s_mass;
			
			myDeltaX -= l * tractorStrength[k] * tmpx /
			    (double) distance / me->p_ship.s_mass;
			myDeltaY -= l * tractorStrength[k] * tmpy /
			    (double) distance / me->p_ship.s_mass;
		    }
		}
		mePoints[i][j].x += myDeltaX;
		mePoints[i][j].y += myDeltaY;
	    }
	}
    }

    return numberOfDirections;
}


botProjectShipPositions( BOT_POINT mePoints[BOT_MAXDODGEANGLES][BOT_LOOKAHEAD],
			BOT_DIRECTION dodgeDirections[BOT_MAXDODGEANGLES] )
{
    BOT_POINT meCurrent;
    int i,j;
    int maxDirectionsPerSpeed;
    int speed, mySubSpeed, myCurrentDir;
    int ticksToSpeedChange;
    int numberOfDirections;
    int newDir, newMyDir;
    int factor;
    int distance;
    
    /* Now... calculate possible dodging angles.  For right now, I
       will calculate only 15 - straight ahead, 90 degree left turn,
       45 degree left turn, 45 degree right turn, and 90 degree
       right turn 
       Also, I will try these angles with going current speed, one
       higher, and one lower */
    maxDirectionsPerSpeed=0;
#if 1
#if 0
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -96;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -64;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -32;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -16;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 0.0;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 16;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 32;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 64;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 96;
#else
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -127;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -112;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -96;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -80;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -64;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -48;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -32;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -16;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 0.0;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 16;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 32;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 48;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 64;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 80;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 96;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 112;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 127;
#endif
#else
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -8 * botMaxTurn( me->p_speed );
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -4 * botMaxTurn( me->p_speed );
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -2 * botMaxTurn( me->p_speed );
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = -botMaxTurn( me->p_speed );
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 0.0;
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = botMaxTurn( me->p_speed );
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 2 * botMaxTurn( me->p_speed );
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 4 * botMaxTurn( me->p_speed );
    dodgeDirections[maxDirectionsPerSpeed++].deltaDir = 8 * botMaxTurn( me->p_speed );
#endif

#ifdef TORPDEBUG
    printf("\nDIRECTIONS\n");
#endif

    /* this will be code to handle the fact that I'm experiencing lag -
       basically, this means that if I have 200ms lag, I'm really 2 ticks
       behind what I'm seeing now - so... we do the following...
       a) I know what speed and direction I last requested to go in
          (botDesiredSpeed and botDesiredCourse)
       b) Using this, we project out the ticks required by my lag
       */
    meCurrent.x = botUniverse[0].players[me->p_no].point.x;
    meCurrent.y = botUniverse[0].players[me->p_no].point.y;
    if (botUniverse[0].players[me->p_no].point.time !=
	botUniverse[1].players[me->p_no].point.time )
    {
	meCurrent.x += (borgDelay % 100) / 100.0 *
	    (botUniverse[0].players[me->p_no].point.x -
	     botUniverse[1].players[me->p_no].point.x ) /
		 (botUniverse[0].players[me->p_no].point.time -
		  botUniverse[1].players[me->p_no].point.time );
	meCurrent.y += (borgDelay % 100) / 100.0 *
	    (botUniverse[0].players[me->p_no].point.y -
	     botUniverse[1].players[me->p_no].point.y ) /
		 (botUniverse[0].players[me->p_no].point.time -
		  botUniverse[1].players[me->p_no].point.time );
    }

    speed = me->p_speed;
    mySubSpeed = botSubSpeed;
    myCurrentDir = botUniverse[0].players[me->p_no].dir;
    for (i=borgDelay/100; i>0; --i) {
	factor = botMaxTurn( speed );

	j = angdist( myCurrentDir, botDesiredCourse );
	if ( j > factor ) {
	    if ( NORMALIZE( j + myCurrentDir ) == botDesiredCourse )
		myCurrentDir = NORMALIZE( myCurrentDir + factor );
	    else
		myCurrentDir = NORMALIZE( myCurrentDir - factor );
	}
	else
	    myCurrentDir = botDesiredCourse;

	if ( botDesiredSpeed > speed )
	    mySubSpeed += me->p_ship.s_accint;
	if ( botDesiredSpeed < speed )
	    mySubSpeed -= me->p_ship.s_decint;

	speed = mySubSpeed / 1000;
	
	meCurrent.x += WARP1 * speed * Cos[myCurrentDir];
	meCurrent.y += WARP1 * speed * Sin[myCurrentDir];
    }

    for (i=maxDirectionsPerSpeed-1; i>=0; --i)
	dodgeDirections[i].speed = speed;
    
    factor = botMaxTurn( speed );

    distance = speed * WARP1;
    for (i=maxDirectionsPerSpeed-1; i>=0; --i ) {
	dodgeDirections[i].index = i;
	mePoints[i][0].x = meCurrent.x;
	mePoints[i][0].y = meCurrent.y;
	mePoints[i][0].angle = myCurrentDir;
	newMyDir = myCurrentDir;
	newDir = 0;
	
#ifdef TORPDEBUG
	printf("%d 0 %d %d: (%d, %d)\n",
	       i, newDir, newMyDir, mePoints[i][0].x, mePoints[i][0].y );
#endif
	
	for (j=1; j<BOT_LOOKAHEAD; j++) {
	    if ( newDir != dodgeDirections[i].deltaDir ) {
		if ( dodgeDirections[i].deltaDir < 0.0 ) {
		    newDir -= factor;
		    if (newDir < dodgeDirections[i].deltaDir) {
			newMyDir =
			    NORMALIZE( mePoints[i][j-1].angle - factor -
				      newDir + dodgeDirections[i].deltaDir );
			newDir = -dodgeDirections[i].deltaDir;
		    }
		    else
			newMyDir =
			    NORMALIZE( mePoints[i][j-1].angle - factor );
		}
		else if ( dodgeDirections[i].deltaDir > 0.0 ) {
		    newDir += factor;
		    if (newDir > dodgeDirections[i].deltaDir) {
			newMyDir =
			    NORMALIZE( mePoints[i][j-1].angle + factor -
				      newDir + dodgeDirections[i].deltaDir );
			newDir = dodgeDirections[i].deltaDir;
		    }
		    else
			newMyDir =
			    NORMALIZE( mePoints[i][j-1].angle + factor );
		}
		else {
		    newDir = 0.0;
		    newMyDir = mePoints[i][j-1].angle;
		}
	    }
	    mePoints[i][j].x = mePoints[i][j-1].x + distance * Cos[ newMyDir ];
	    mePoints[i][j].y = mePoints[i][j-1].y + distance * Sin[ newMyDir ];

	    if ( mePoints[i][j].x < 0 ) {
		mePoints[i][j].x *= -1;
		newMyDir = NORMALIZE( -newMyDir );
	    }
	    else if (mePoints[i][j].x > GWIDTH ) {
		mePoints[i][j].x = GWIDTH - ( mePoints[i][j].x - GWIDTH );
		newMyDir = NORMALIZE( -newMyDir );
	    }
	    if ( mePoints[i][j].y < 0 ) {
		mePoints[i][j].y *= -1;
		newMyDir = NORMALIZE( 128 - newMyDir );
	    }
	    else if (mePoints[i][j].y > GWIDTH ) {
		mePoints[i][j].y = GWIDTH - ( mePoints[i][j].y - GWIDTH );
		newMyDir = NORMALIZE( 128 - newMyDir );
	    }
	    mePoints[i][j].angle = newMyDir;
	    
#ifdef TORPDEBUG
	printf("%d %d %d %d: (%d, %d)\n",
	       i, j, newDir, newMyDir, mePoints[i][j].x, mePoints[i][j].y );
#endif
	}
    }
    numberOfDirections = maxDirectionsPerSpeed;
    
    /* Now compute the positions if I slow down 1 speed */
    if ( speed > 0 ) {
	ticksToSpeedChange = 2 + (mySubSpeed % 1000) / me->p_ship.s_decint;
	distance = (speed - 1) * WARP1;

	for (i=numberOfDirections;
	     i<numberOfDirections+maxDirectionsPerSpeed;
	     i++) {
	    dodgeDirections[i].speed = speed-1;
	    dodgeDirections[i].deltaDir =
		dodgeDirections[i-numberOfDirections].deltaDir;
	}
	    
	/* Until the speed change, positions should be identical */
	for (i=0; i<BOT_LOOKAHEAD && i < ticksToSpeedChange; i++) {
	    for (j=numberOfDirections;
		 j<numberOfDirections+maxDirectionsPerSpeed;
		 j++) {
		mePoints[j][i] = mePoints[j-numberOfDirections][i];
	    }
	}

	for (i=numberOfDirections;
	     i<numberOfDirections+maxDirectionsPerSpeed; i++) {
	    dodgeDirections[i].index = i;
	    
	    /* on the tick of the speed change, we get the turn rate of
	       the old speed, but the speed of the new speed */
	    mePoints[i][ticksToSpeedChange-1].x =
		mePoints[i-numberOfDirections][ticksToSpeedChange-2].x +
		    distance * Cos[mePoints[i][ticksToSpeedChange-1].angle];
	    mePoints[i][ticksToSpeedChange-1].y =
		mePoints[i-numberOfDirections][ticksToSpeedChange-2].y +
		    distance * Cos[mePoints[i][ticksToSpeedChange-1].angle];
	    
	    factor = botMaxTurn( speed );
	    if ( dodgeDirections[i].deltaDir < 0.0 ) {
		newDir = -factor * (ticksToSpeedChange-1);
		if ( newDir < dodgeDirections[i].deltaDir )
		    newDir = dodgeDirections[i].deltaDir;
	    }
	    else if ( dodgeDirections[i].deltaDir > 0.0 ) {
		newDir = factor * (ticksToSpeedChange-1);
		if ( newDir > dodgeDirections[i].deltaDir )
		    newDir = dodgeDirections[i].deltaDir;
	    }
	    else
		newDir = 0.0;

	    factor = botMaxTurn( speed - 1 );	    
	    newMyDir = mePoints[i][ticksToSpeedChange-1].angle;
	    
	    for (j=ticksToSpeedChange; j<BOT_LOOKAHEAD; j++) {
		if ( newDir != dodgeDirections[i].deltaDir ) {
		    if ( dodgeDirections[i].deltaDir < 0.0 ) {
			newDir -= factor;
			if (newDir < dodgeDirections[i].deltaDir) {
			    newMyDir =
				NORMALIZE( mePoints[i][j-1].angle - factor -
					  newDir+dodgeDirections[i].deltaDir );
			    newDir = -dodgeDirections[i].deltaDir;
			}
			else
			    newMyDir =
				NORMALIZE( mePoints[i][j-1].angle - factor );
		    }
		    else if ( dodgeDirections[i].deltaDir > 0.0 ) {
			newDir += factor;
			if (newDir > dodgeDirections[i].deltaDir) {
			    newMyDir =
				NORMALIZE( mePoints[i][j-1].angle + factor -
					  newDir+dodgeDirections[i].deltaDir );
			    newDir = dodgeDirections[i].deltaDir;
			}
			else
			    newMyDir =
				NORMALIZE( mePoints[i][j-1].angle + factor );
		    }
		    else {
			newDir = 0.0;
			newMyDir = mePoints[i][j-1].angle;
		    }
		}
		mePoints[i][j].x = mePoints[i][j-1].x + distance *
		    Cos[ newMyDir ];
		mePoints[i][j].y = mePoints[i][j-1].y + distance *
		    Sin[ newMyDir ];

		if ( mePoints[i][j].x < 0 ) {
		    mePoints[i][j].x *= -1;
		    newMyDir = NORMALIZE( -newMyDir );
		}
		else if (mePoints[i][j].x > GWIDTH ) {
		    mePoints[i][j].x = GWIDTH - ( mePoints[i][j].x - GWIDTH );
		    newMyDir = NORMALIZE( -newMyDir );
		}
		if ( mePoints[i][j].y < 0 ) {
		    mePoints[i][j].y *= -1;
		    newMyDir = NORMALIZE( 128 - newMyDir );
		}
		else if (mePoints[i][j].y > GWIDTH ) {
		    mePoints[i][j].y = GWIDTH - ( mePoints[i][j].y - GWIDTH );
		    newMyDir = NORMALIZE( 128 - newMyDir );
		}
		mePoints[i][j].angle = newMyDir;
		
#ifdef TORPDEBUG
	    printf("%d %d %d %d: (%d, %d)\n",
		   i,j, newDir, newMyDir, mePoints[i][j].x, mePoints[i][j].y );
#endif
	
	    }
	}
	numberOfDirections += maxDirectionsPerSpeed;
    }

    /* Now compute the positions if I speed up 1 speed */
    if ( speed < botMaxSpeed() ) {
	ticksToSpeedChange = 2 + (1000 - (mySubSpeed % 1000)) /
	    me->p_ship.s_accint;
	distance = (speed + 1) * WARP1;

	for (i=numberOfDirections;
	     i<numberOfDirections+maxDirectionsPerSpeed; i++) {
	    dodgeDirections[i].speed = speed+1;
	    dodgeDirections[i].deltaDir = dodgeDirections[i-numberOfDirections].deltaDir;
	}
	
	/* Until the speed change, positions should be identical */
	for (i=0; i<BOT_LOOKAHEAD && i < ticksToSpeedChange; i++) {
	    for (j=numberOfDirections;
		 j<numberOfDirections+maxDirectionsPerSpeed;
		 j++) {
		mePoints[j][i] = mePoints[j-numberOfDirections][i];
	    }
	}

	for (i=numberOfDirections;
	     i<numberOfDirections+maxDirectionsPerSpeed; i++) {
	    dodgeDirections[i].index = i;
	    
	    /* on the tick of the speed change, we get the turn rate of
	       the old speed, but the speed of the new speed */
	    mePoints[i][ticksToSpeedChange-1].x =
		mePoints[i][ticksToSpeedChange-2].x +
		    distance * Cos[mePoints[i][ticksToSpeedChange-1].angle];
	    mePoints[i][ticksToSpeedChange-1].y =
		mePoints[i][ticksToSpeedChange-2].y +
		    distance * Cos[mePoints[i][ticksToSpeedChange-1].angle];

	    factor = botMaxTurn( speed );
	    if ( dodgeDirections[i].deltaDir < 0.0 ) {
		newDir = -factor * (ticksToSpeedChange-1);
		if ( newDir < dodgeDirections[i].deltaDir )
		    newDir = dodgeDirections[i].deltaDir;
	    }
	    else if ( dodgeDirections[i].deltaDir > 0.0 ) {
		newDir = factor * (ticksToSpeedChange-1);
		if ( newDir > dodgeDirections[i].deltaDir )
		    newDir = dodgeDirections[i].deltaDir;
	    }
	    else
		newDir = 0.0;
	    
	    factor = botMaxTurn( speed + 1 );
	    newMyDir = mePoints[i][ticksToSpeedChange-1].angle;
	    
	    for (j=ticksToSpeedChange; j<BOT_LOOKAHEAD; j++) {
		if ( newDir != dodgeDirections[i].deltaDir ) {
		    if ( dodgeDirections[i].deltaDir < 0.0 ) {
			newDir -= factor;
			if (newDir < dodgeDirections[i].deltaDir) {
			    newMyDir =
				NORMALIZE( mePoints[i][j-1].angle - factor -
					  newDir+dodgeDirections[i].deltaDir );
			    newDir = -dodgeDirections[i].deltaDir;
			}
			else
			    newMyDir =
				NORMALIZE( mePoints[i][j-1].angle - factor );
		    }
		    else if ( dodgeDirections[i].deltaDir > 0.0 ) {
			newDir += factor;
			if (newDir > dodgeDirections[i].deltaDir) {
			    newMyDir =
				NORMALIZE( mePoints[i][j-1].angle + factor -
					  newDir+dodgeDirections[i].deltaDir );
			    newDir = dodgeDirections[i].deltaDir;
			}
			else
			    newMyDir =
				NORMALIZE( mePoints[i][j-1].angle + factor );
		    }
		    else {
			newDir = 0.0;
			newMyDir = mePoints[i][j-1].angle;
		    }
		}
		mePoints[i][j].x = mePoints[i][j-1].x + distance *
		    Cos[newMyDir];
		mePoints[i][j].y = mePoints[i][j-1].y + distance *
		    Sin[newMyDir];

		if ( mePoints[i][j].x < 0 ) {
		    mePoints[i][j].x *= -1;
		    newMyDir = NORMALIZE( -newMyDir );
		}
		else if (mePoints[i][j].x > GWIDTH ) {
		    mePoints[i][j].x = GWIDTH - ( mePoints[i][j].x - GWIDTH );
		    newMyDir = NORMALIZE( -newMyDir );
		}
		if ( mePoints[i][j].y < 0 ) {
		    mePoints[i][j].y *= -1;
		    newMyDir = NORMALIZE( 128 - newMyDir );
		}
		else if (mePoints[i][j].y > GWIDTH ) {
		    mePoints[i][j].y = GWIDTH - ( mePoints[i][j].y - GWIDTH );
		    newMyDir = NORMALIZE( 128 - newMyDir );
		}
		mePoints[i][j].angle = newMyDir;
#ifdef TORPDEBUG
	    printf("%d %d %d %d: (%d, %d)\n",
		   i,j, newDir, newMyDir, mePoints[i][j].x, mePoints[i][j].y );
#endif
	
	    }
	}
	numberOfDirections += maxDirectionsPerSpeed;
    }

    for (i=numberOfDirections-1; i>=0; --i) {
	dodgeDirections[i].pressorEnemy = -1;
	dodgeDirections[i].tractorEnemy = -1;
    }
    
    numberOfDirections = botProjectShipsWithTP( mePoints,
					        dodgeDirections,
					       numberOfDirections );
    return numberOfDirections;
}

int calculateSafeDirections( BOT_DIRECTION *dodgeDirections,
			    int numberOfDirections,
			    int distance,
			    int maximumDamage,
			    BOT_POINT points[(MAXTORP+MAXPLASMA)*MAXPLAYER][BOT_LOOKAHEAD],
			    BOT_POINT mePoints[BOT_MAXDODGEANGLES][BOT_LOOKAHEAD],
			    int plasmas )
{
    int i,j,k,l,m;
    int idx;
    int damage;
    int bestDamage;
    int tmpDistance;
    int extraDistance = 6;
    static int torpDamDist = DAMDIST * DAMDIST;
    int torpDistance;
    int deltaX, deltaY;
    int tmpDistanceSquared[BOT_LOOKAHEAD];
    int tmpx, tmpy;

#ifdef TORPDEBUG
    printf("\nCHECKING FOR HITS\n");
#endif
    /* Now - calculate the damage from each path that I might attempt */
    tmpDistance = distance;
    for (i=1; i<BOT_LOOKAHEAD; i++) {
	tmpDistance += extraDistance;
	tmpDistanceSquared[i] = tmpDistance * tmpDistance;
    }

    bestDamage = maximumDamage;
    for (i=numberOfDirections-1; i>=0; --i) {
	m = dodgeDirections[i].index;
	if ( m<0 )
	    continue;

	dodgeDirections[i].damage = 0;
	dodgeDirections[i].dodgeDamage = 0;
	
	for (j=MAXPLAYER-1; j>=0 && dodgeDirections[i].damage <= bestDamage;
	     --j) {
	    if (players[j].p_team == me->p_team ||
		players[j].p_status == PFREE )
		continue;
	    
	    damage = MAX( players[j].p_ship.s_torpdamage, 25 );
	    for (k=MAXTORP-1; k>=0 && dodgeDirections[i].damage <= bestDamage;
		 --k) {
		idx = j*MAXTORP+k;
		if ( points[idx][0].x <= 0 || points[idx][0].y <= 0 )
		    continue;
		if (friendlyPlayer( &players[j] ) &&
		    friendlyTorp( &torps[idx] ))
		    continue;

		tmpDistance = distance;
		deltaX = points[idx][1].x - points[idx][0].x;
		deltaY = points[idx][1].y - points[idx][0].y;
		for (l=1; l<BOT_LOOKAHEAD; l++) {
		    tmpDistance += extraDistance;
#ifdef TORPDEBUG
		    printf("path %d time %d I'm at (%d, %d)  torp %d at (%d, %d) avoidDist = %d\n",
			   i, l, mePoints[i][l].x, mePoints[i][l].y,
			   idx, points[idx][l].x, points[idx][l].y,
			   tmpDistance );
#endif
		    tmpx = points[idx][l].x - mePoints[i][l].x;
		    tmpy = points[idx][l].y - mePoints[i][l].y;
		    
		    if ( pointWithinSquare( &mePoints[i][l],
					   &points[idx][l],
					   tmpDistance ) &&
			tmpDistanceSquared[l] > tmpx * tmpx + tmpy * tmpy ) {
#ifdef TORPDEBUG
			printf("  torp hit me\n");
#endif
			dodgeDirections[i].damage += damage - l;
			break;
		    }
		    if ( points[idx][l].angle ) {
			if ( pointWithinSquare( &mePoints[i][l],
					       &points[idx][l],
					       DAMDIST ) ) {
			    torpDistance = tmpx * tmpx + tmpy * tmpy;
			    if (torpDistance < torpDamDist ) {
				tmpDistance = sqrt((double) torpDistance );
				dodgeDirections[i].damage += (damage - l) *
				    (DAMDIST - tmpDistance) /
					(DAMDIST - EXPDIST);
			    }
			}
			break;
		    }

#if 1
		    if ( ((tmpx > tmpDistance && deltaX > 0) ||
			  (tmpx < -tmpDistance && deltaX < 0) )
			&& ((tmpy > tmpDistance && deltaY > 0) ||
			    (tmpy < tmpDistance && deltaY < 0)) )
		    {
			break;
		    }
#endif
		}
	    }
	    if (plasmas) {
		damage = MAX( players[j].p_ship.s_plasmadamage, 75 );
		for (k=MAXPLASMA-1; k>=0; --k) {
		    idx = MAXPLAYER*MAXTORP+j*MAXPLASMA+k;
		    if ( points[idx][0].x > 0 &&
			points[idx][0].y > 0 &&
			(!friendlyPlayer( &players[j] ) ||
			 !friendlyPlasmaTorp( &plasmatorps[j*MAXPLASMA+k] ))) {
			for (l=1; l<BOT_LOOKAHEAD; l++) {
			    tmpDistance = distance + 50 + 5 * l;
			    if ( pointWithinSquare( &mePoints[i][l],
						   &points[idx][l],
						   tmpDistance ) ) {
				dodgeDirections[i].dodgeDamage += damage - l;
				break;
			    }
			}
		    }
		}
	    }
	}
	dodgeDirections[i].dodgeDamage += dodgeDirections[i].damage;
	if ( dodgeDirections[i].dodgeDamage < bestDamage )
	    bestDamage = dodgeDirections[i].dodgeDamage;
    }

    /* Return back to the user all directions that are near in damage
       to the best one */
    for (i=numberOfDirections-1; i>=0; --i) {
	if (dodgeDirections[i].index < 0)
	    continue;
	if (dodgeDirections[i].dodgeDamage > bestDamage) {
	    dodgeDirections[i].index = -1;
	}
    }

#ifdef TORPDEBUG
    printf("best damage is %d\n", bestDamage);
    for (i=0; i<j; i++)
	printf("%02d: DodgeDir=%d\tSpeed=%d\tDamage=%d\n",
	       i, (int) validDirections[i].deltaDir,
	       validDirections[i].speed,
	       validDirections[i].damage );
    printf("\n");
#endif

    return bestDamage;
}

int botDodgeTorps( BOT_DIRECTION *dodgeDirections,
		  int *numberOfDirections )
{
    BOT_POINT points[(MAXTORP+MAXPLASMA)*MAXPLAYER][BOT_LOOKAHEAD];
    BOT_POINT mePoints[BOT_MAXDODGEANGLES][BOT_LOOKAHEAD];
    int i,j,idx;
    int distance;
    int plasmas;
    
    plasmas = 0;
    for (i=MAXPLAYER-1; i>=0 && !plasmas; --i) {
	for (j=MAXPLASMA-1; j>=0 && !plasmas; --j) {
	    idx = i*MAXPLASMA+j;
	    if ( (!friendlyPlayer( &players[i] ) ||
		  !friendlyPlasmaTorp( &plasmatorps[idx] ) ) &&
		botUniverse[0].plasmas[idx].point.x > 0 &&
		botUniverse[0].plasmas[idx].point.y > 0 &&
		botUniverse[1].plasmas[idx].point.x > 0 &&
		botUniverse[1].plasmas[idx].point.y > 0 ) {
		plasmas = 1;
	    }
	}
    }

    if (!botProjectTorpPositions( points, plasmas ))
	return 0;

    *numberOfDirections = botProjectShipPositions( mePoints, dodgeDirections );

#ifdef TORPDEBUG
    printf("\nCHECKING FOR HITS\n");
#endif
    /* Now - calculate the damage from each path that I might attempt */
    distance = EXPDIST + botAvoidTorpDistance + 6 * borgDelay / 100;

    calculateSafeDirections( dodgeDirections,
			    *numberOfDirections,
			    distance + (recv_short ? 40 : 0),
			    10000,
			    points,
			    mePoints,
			    plasmas );
    
    return 1;
}

void botMiscellaneous( BOT_STRATEGY *strategy )
{
    extern int ping_av;
    int i;
    struct obtype *target;
    struct stat stbuf;
    static int defaultsTime = 0;

    if ( !isAlive( me ) )
	return;

    /* if I'm a starbase, make sure others can dock */
    if (me->p_ship.s_type == STARBASE) {
	if (!(me->p_flags & PFDOCKOK))
	    sendDockingReq(1);
	if (strategy->plan == ST_REFIT && shipOrbitting( me ) ) {
	    target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			       me->p_y * WINSIDE/GWIDTH, TARG_PLANET);
	    if ( target->o_num == 10 * (remap[me->p_team] - 1) )
		sendRefitReq(CRUISER);
	}
    }
    
    if ( commMode == COMM_TCP && !(botPacketReceived % 60) )
	sendUdpReq(COMM_UDP);

    if ( !(botPacketReceived % 10) ) {
      stat( defaults_file, &stbuf );
      if ( !defaultsTime ) {
	defaultsTime = stbuf.st_mtime;
      }
      else if ( stbuf.st_mtime > defaultsTime ) {
	defaultsTime = stbuf.st_mtime;
	ReReadDefaults();
      }
    }

    /*    if ( !(botPacketReceived % 10) ) {
	  printf( "\n" );
	  }
    */

    /* Every 2 minutes
       - get stats on myself
       - reread the .xtrekrc file
       - check for enemy borgs...
       - see how many people are playing - if I'm the only one, quit out
       */
    if ( !(botPacketReceived % 600) ) {
	if (commMode == COMM_TCP)
	    sendUdpReq(COMM_UDP);
    
#if 1
	if ( status->tourn && me->p_ship.s_type != STARBASE ) {
	    pmessage("?", me->p_no, MINDIV);
	    pmessage("QUEUE", me->p_no, MINDIV);
	}
#endif
	
#ifdef SENDPIG
#if 0
	pmessage(PIGCALL, 0, MALL );
#endif
#endif
#ifdef PRINTMESSAGES
	printf("average ping time is %d\n", ping_av );
	printf("my ratings are %f, hours %f and DI is %f\n",
	       totalRating( me ),
	       me->p_stats.st_tticks / 36000.0,
	       totalRating( me ) * (me->p_stats.st_tticks / 36000.0));
#endif

	for (i=MAXPLAYER-1; i>=0; --i) {
	    if (isAlive( &players[i] ) && !myPlayer( &players[i] ))
		break;
	}
	if (i < 0 && botPacketReceived > 600)
	    sendQuitReq();
    }

    if ( botAutoQuit )
	sendQuitReq();

    /* Every 3 minutes, tell team how many armies I have if I'm a SB */
    if ( me->p_ship.s_type == STARBASE &&
	!(botPacketReceived % 900 ) ) {
	botEmergency( carrying, strategy );
    }
    
    if ( strstr( serverName, "bigbang" ) && botEjectable &&
	!(botPacketReceived % 4500) ) {
	pmessage("I am testing a robot for Alec.  However, if you do not want", me->p_team, MTEAM);
	pmessage("a robot on your team, send me an EJECT message", me->p_team, MTEAM);
    }
}

double botRepairRefuel( BOT_STRATEGY *strategy, BOT_STRATEGY *currentStrategy )
{
    double closestRepairDistance=1000000;
    double closestFuelDistance=1000000;
    double closestFuelRepairDistance=1000000;
    int closestRepair = -1;
    int closestFuel = -1;
    int closestFuelRepair = -1;
    double SBdist = 100000;
    int SBplayer = -1;
    double planetDistance;
    int i;
    int bestPlanet = -1;
    int needFuelTmp;
    int needRepairTmp;
    int needFuelRepairTmp;
    int enemyPresent = 0;
    struct planet *planet;
    int maxspeed;
    struct obtype *gettarget(), *target;
    int tmpDamage;
    int tmpShield;
    int flyingTime;
    int orbitTime;
    int repairInPlaceTime;
    int bestTime;
    BOT_POINT point;
    
    if (!isAlive( me )) {
	strategy->rating = 0.0;
	return 0.0;
    }
    
    for (i=0; i<MAXPLAYER; i++) {
	if ((players[i].p_ship.s_type == STARBASE) &&
	    (players[i].p_team == me->p_team) &&
	    !myPlayer( &players[i] )) {
		SBplayer=i;
	    }
	if ( !enemyPresent && !friendlyPlayer( &players[i] ) &&
	    isAlive( &players[i] ) &&
	    pointWithinSquare( &botUniverse[0].players[i].point,
			      &botUniverse[0].players[me->p_no].point,
			      10000.0) )
	    enemyPresent = 1;
    }

    if (SBplayer >= 0 && me->p_ship.s_type != STARBASE &&
	(players[SBplayer].p_flags & PFDOCKOK)) {
	for (i=MAXPLAYER-1; i>=0; --i) {
	    if ( isAlive( &players[i] ) &&
		!friendlyPlayer( &players[i] ) &&
		pointWithinSquare( &botUniverse[0].players[SBplayer].point,
				  &botUniverse[0].players[i].point,
				  10000.0 ) )
		break;
	}
	if ( i < 0 ) {
	    SBdist = botDistanceFromMe( &botUniverse[0].players[SBplayer].point );
	    closestFuelDistance = SBdist;
	    closestRepairDistance = SBdist;
	    closestFuelRepairDistance = SBdist;
	    closestFuel = MAXPLANETS+SBplayer;
	    closestRepair = MAXPLANETS+SBplayer;
	    closestFuelRepair = MAXPLANETS+SBplayer;
	}
    }

    for (i=0; i<MAXPLANETS; i++) {
	planet = &planets[i];
	if ( enemyPlayersNearPlanet( planet ) > 0 )
	    continue;
	
	if ( (friendlyPlanet( planet ) && me->p_ship.s_type != STARBASE ) ||
	      ( myPlanet( planet ) && me->p_ship.s_type == STARBASE ) ) {
	    if ( planet->pl_flags & (PLFUEL|PLREPAIR) ) {
		planetDistance =
		    botDistanceFromMe( &botUniverse[0].planets[i].point );

		if ( planet->pl_flags & PLFUEL ) {
		    if ( planetDistance < closestFuelDistance ) {
			closestFuelDistance = planetDistance;
			closestFuel = i;
		    }
		}
		if ( planet->pl_flags & PLREPAIR ) {
		    if ( planetDistance < closestRepairDistance ) {
			closestRepairDistance = planetDistance;
			closestRepair = i;
		    }
		}
		if ( (planet->pl_flags & PLREPAIR) &&
		    (planet->pl_flags & PLFUEL) ) {
		    if ( planetDistance < closestFuelRepairDistance ) {
			closestFuelRepairDistance = planetDistance;
			closestFuelRepair = i;
		    }
		}
	    }
	}
	/* Try repairing or refueling in third space */
	if ( me->p_ship.s_type != STARBASE &&
	    !(planet->pl_info & me->p_team) &&
	    !(me->p_hostile & (1 << (i / 10))) &&
	    !(me->p_swar & (1 << (i / 10))) ) {
	    planetDistance =
		botDistanceFromMe( &botUniverse[0].planets[i].point );
	    if ( planetDistance < closestFuelRepairDistance ) {
		closestFuelRepairDistance = planetDistance;
		closestFuelRepair = i;
	    }
	}
    }

    maxspeed = botMaxSpeed();

    /* compute time that it takes to get to closest fuel planet and refuel
       and repair all damage */
    if ( closestFuel >= 0 ) {
	tmpDamage = me->p_damage;
	tmpShield = me->p_shield;
	
	flyingTime = closestFuelDistance / (maxspeed * WARP1);
	tmpDamage -= (flyingTime * me->p_ship.s_repair) / 1000;
	tmpShield += (flyingTime * me->p_ship.s_repair * 2) / 1000;
	
	orbitTime = (me->p_ship.s_maxfuel - me->p_fuel) /
	    ( 8 * me->p_ship.s_recharge );
	tmpDamage -= (orbitTime * me->p_ship.s_repair * 2) / 1000;
	
	if ( tmpDamage > 0 )
	    orbitTime += tmpDamage * 1000 / ( me->p_ship.s_repair * 2 );
	
	tmpShield += (orbitTime * me->p_ship.s_repair * 4) / 1000;
	if ( tmpShield < me->p_ship.s_maxshield )
	    orbitTime += ( me->p_ship.s_maxshield - tmpShield ) * 1000 /
		( me->p_ship.s_repair * 4);
	needFuelTmp = flyingTime + orbitTime;
    }
    else
	needFuelTmp = 100000.0;
    
    /* compute time that it takes to get to closest repair planet and refuel
       and repair all damage */
    if ( closestRepair >= 0 ) {
	tmpDamage = me->p_damage;
	tmpShield = me->p_shield;
	
	flyingTime = closestRepairDistance / (maxspeed * WARP1);
	tmpDamage -= (flyingTime * me->p_ship.s_repair) / 1000;
	tmpShield += (flyingTime * me->p_ship.s_repair * 2) / 1000;
	
	orbitTime = (me->p_ship.s_maxfuel - me->p_fuel) /
	    ( 2 * me->p_ship.s_recharge );
	tmpDamage -= (orbitTime * me->p_ship.s_repair * 4) / 1000;
	
	if ( tmpDamage > 0 )
	    orbitTime += tmpDamage * 1000 / ( me->p_ship.s_repair * 4 );
	
	tmpShield += (orbitTime * me->p_ship.s_repair * 8) / 1000;
	if ( tmpShield < me->p_ship.s_maxshield )
	    orbitTime += ( me->p_ship.s_maxshield - tmpShield ) * 1000 /
		( me->p_ship.s_repair * 8);
	needRepairTmp = flyingTime + orbitTime;
    }
    else
	needRepairTmp = 100000;
	
    /* compute time that it takes to get to closest repair and refuel
       planet and refuel and repair all damage */
    if ( closestFuelRepair >= 0 ) {
	tmpDamage = me->p_damage;
	tmpShield = me->p_shield;
	
	flyingTime = closestFuelRepairDistance / (maxspeed * WARP1);
	tmpDamage -= (flyingTime * me->p_ship.s_repair) / 1000;
	tmpShield += (flyingTime * me->p_ship.s_repair * 2) / 1000;
	
	orbitTime = (me->p_ship.s_maxfuel - me->p_fuel) /
	    ( 8 * me->p_ship.s_recharge );
	tmpDamage -= (orbitTime * me->p_ship.s_repair * 4) / 1000;
	
	if ( tmpDamage > 0 )
	    orbitTime += tmpDamage * 1000 / ( me->p_ship.s_repair * 4 );
	
	tmpShield += (orbitTime * me->p_ship.s_repair * 8) / 1000;
	if ( tmpShield < me->p_ship.s_maxshield )
	    orbitTime += ( me->p_ship.s_maxshield - tmpShield ) * 1000 /
		( me->p_ship.s_repair * 8);
	needFuelRepairTmp = flyingTime + orbitTime;
    }
    else
	needFuelRepairTmp = 100000;
	
    /* compute time that it takes to repair and refuel if I don't move */
    tmpDamage = me->p_damage;
    tmpShield = me->p_shield;

    orbitTime = (me->p_ship.s_maxfuel - me->p_fuel) /
	( 2 * me->p_ship.s_recharge );
    tmpDamage -= (orbitTime * me->p_ship.s_repair * 2) / 1000;

    if ( tmpDamage > 0 )
	orbitTime += tmpDamage * 1000 / ( me->p_ship.s_repair * 2 );

    tmpShield += (orbitTime * me->p_ship.s_repair * 4) / 1000;
    if ( tmpShield < me->p_ship.s_maxshield )
	orbitTime += ( me->p_ship.s_maxshield - tmpShield ) * 1000 /
	    ( me->p_ship.s_repair * 4);
    repairInPlaceTime = orbitTime;
    for (i=MAXPLANETS-1; i>=0; --i ) {
	if ( (!friendlyPlanet( &planets[i] ) ||
	      !(me->p_team & planets[i].pl_info ) ) &&
	    pointWithinSquare( &botUniverse[0].players[me->p_no].point,
			      &botUniverse[0].planets[i].point,
			      PFIREDIST + 150 ) ) {
	    break;
	}
    }
    if ( i>=0 )
	repairInPlaceTime = 10000.0;
    
    MZERO( strategy, sizeof(BOT_STRATEGY) );
    bestTime = needFuelTmp;
    bestPlanet = closestFuel;
    if ( needRepairTmp < bestTime ) {
	bestTime = needRepairTmp;
	bestPlanet = closestRepair;
    }
    if ( needFuelRepairTmp < bestTime ) {
	bestTime = needFuelRepairTmp;
	bestPlanet = closestFuelRepair;
    }
    if ( repairInPlaceTime < bestTime ) {
	bestTime = repairInPlaceTime;
	bestPlanet = -1;
    }

    if ( me->p_flags & PFORBIT ) {
	target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			   me->p_y * WINSIDE/GWIDTH, TARG_PLANET);
	planet = &planets[target->o_num];      
	
	if ( friendlyPlanet( planet ) ) {
	    if ( (planet->pl_flags & PLFUEL) &&
		me->p_fuel < me->p_ship.s_maxfuel ) {
		strategy->rating = 10.0;
	    }
	    if ( (planet->pl_flags & PLREPAIR) &&
		(me->p_damage ||
		 me->p_shield < me->p_ship.s_maxshield ) ) {
		strategy->rating = 10.0;
	    }
	}
    } else if (me->p_flags & PFDOCK) {
	if ( me->p_fuel < me->p_ship.s_maxfuel ) {
	    strategy->rating = 10.0;
	}
	if ( me->p_damage || me->p_shield < me->p_ship.s_maxshield ) {
	    strategy->rating = 10.0;
	}
    } else {
	strategy->rating = me->p_damage / (double) me->p_ship.s_maxdamage;

	if ( me->p_fuel < .3 * me->p_ship.s_maxfuel &&
	    currentStrategy->plan != ST_BOMB )
	    strategy->rating +=	    
		1 - (me->p_fuel / (double) me->p_ship.s_maxfuel );

	/*	if ( me->p_shield < .3 * me->p_ship.s_maxshield )
		strategy->rating +=	    
		1 - (me->p_shield / (double) me->p_ship.s_maxshield );
	*/
    }

    if ( bestPlanet < 0 ) {
	strategy->player = -1;
	strategy->planet = -1;
	strategy->x = me->p_x;
	strategy->y = me->p_y;
    }
    else if ( bestPlanet < MAXPLANETS && bestPlanet >= 0) {
	strategy->planet = bestPlanet;
	strategy->player = -1;
	if (bestPlanet >= 0) {
	    strategy->x = planets[bestPlanet].pl_x;
	    strategy->y = planets[bestPlanet].pl_y;
	}
    }
    else {
	strategy->player = bestPlanet - MAXPLANETS;
	strategy->planet = -1;
	strategy->x = me->p_x;
	strategy->y = me->p_y;
    }

    if ( strategy->planet >= 0 ) {
	point.x = planets[strategy->planet].pl_x;
	point.y = planets[strategy->planet].pl_y;
    }
    else if ( strategy->player >= 0 ) {
	point.x = players[strategy->player].p_x;
	point.y = players[strategy->player].p_y;
    }
    else {
	point.x = me->p_x;
	point.y = me->p_y;
    }
	
    strategy->plan = ST_REPLENISH;
#if 0
    bestEnemy = -1;
    planetDistance = 7500.0;
    for (i=MAXPLAYER-1; i>=0; --i ) {
      if ( isAlive( &players[i] ) &&
	  !friendlyPlayer( &players[i] ) &&
	  pointWithinSquare( &point,
			    &botUniverse[0].players[i].point, 7500.0 ))
	{
	  distance = hypot( (double) botUniverse[0].players[i].point.x -
			   point.x,
			   (double) botUniverse[0].players[i].point.y -
			   point.y );
	  if ( distance < planetDistance ) {
	    bestEnemy = i;
	    planetDistance = distance;
	  }
	}
    }
    if (bestEnemy >= 0) {
	strategy->player = bestEnemy;
	strategy->plan = ST_OGG;
    }
#endif

    if ( me->p_armies && me->p_ship.s_type != STARBASE )
	strategy->engageEnemy = 0;
    else
	strategy->engageEnemy = 1;
    
    return strategy->rating;;
}

double botGuardPlanet( BOT_STRATEGY *strategy )
{
    int i,j,m;
    struct planet *k;
    int bestPlanet;
    double bestRating;
    double rating;
    double planetDistance;
    int armies;
    int totalArmies = 0;
    double distance;
    int bestEnemy;
    int maxSpeed;
    int timeToArrive;
    int angle;

    if ( !status->tourn ||
	(me->p_armies && me->p_ship.s_type != STARBASE ) ) {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_GUARD;
	return 0.0;
    }

    maxSpeed = botMaxSpeed();
    
    /* Find out how many enemies are carrying */
    for (i=MAXPLAYER-1; i>=0; --i) {
	if (players[i].p_ship.s_type == STARBASE &&
	    players[i].p_team == me->p_team &&
	    i != me->p_no )
	    totalArmies = botUniverse[0].players[i].armies_known;
    }
    
    /* now decide which planet to guard */
    bestRating = -100.0;
    bestPlanet = -1;
    for (i=0; i<MAXPLANETS; i++) {
	k = &planets[i];
	if ( !myPlanet( k ) && !(friendlyPlanet( k ) && !k->pl_armies) )
	    continue;

	if ( k->pl_armies > 4) {
	    armies = k->pl_armies - 4;
	}
	else
	    armies = 0;
	    
	if ( !armies )
	    continue;
	
	totalArmies += armies;
	planetDistance =  1 +
	    botDistanceFromMe( &botUniverse[0].planets[i].point );

	for (j=MAXPLAYER-1; j>=0; --j) {
	    if ( isAlive( &players[j] ) &&
		!friendlyPlayer( &players[j] ) &&
		pointWithinSquare( &botUniverse[0].planets[i].point,
				  &botUniverse[0].players[j].point,
				  10000.0 ) )
		break;
	}

	if ( j < 0 && me->p_ship.s_type != STARBASE ) {
	    for (j=MAXPLAYER-1; j>=0; --j) {
		if ( !isAlive( &players[j] ) ||
		    myPlayer( &players[j] ) ||
		    !friendlyPlayer( &players[j] ) ||
		    !pointWithinSquare( &botUniverse[0].planets[i].point,
				       &botUniverse[0].players[j].point,
				       10000.0 ) )
			continue;
		
		if ( !players[j].p_speed || shipCloaked( &players[j] ) ) {
		    for (m=MAXPLANETS-1; m>=0; --m) {
			if ( m != i &&
			    pointWithinSquare( &botUniverse[0].planets[m].point,
					      &botUniverse[0].players[j].point,
					      2000.0 ) )
			    break;
		    }
		    if ( m>=0 )
			continue;
		}
		
		if ( hypot( (double) botUniverse[0].players[j].point.x -
			   k->pl_x,
			   (double) botUniverse[0].players[j].point.y -
			   k->pl_y ) < planetDistance )
		    break;
	    }
	    if ( j>=0 )
		continue;
	}

	for (j=MAXPLAYER-1; j>=0; --j) {
	    if ( !isAlive( &players[j] ) ||
		myPlayer( &players[j] ) ||
		!friendlyPlayer( &players[j] ) ||
		!pointWithinSquare( &botUniverse[0].planets[i].point,
				   &botUniverse[0].players[j].point,
				   2000.0 ) )
		continue;
	    
	    if ( !players[j].p_speed || shipCloaked( &players[j] ) ) {
		break;
	    }
	}
	if ( j >= 0 && me->p_ship.s_type != STARBASE )
	    continue;
	
	timeToArrive = 1 + planetDistance / (maxSpeed * WARP1);

	angle = botGetAngle( k->pl_x, k->pl_y );
	timeToArrive += enemyTimeInDirection( angle, timeToArrive, -1 );
	
	rating = 10.0 * armies / timeToArrive;
    
	if ( rating > bestRating ) {
	    bestPlanet = i;
	    bestRating = rating;
	}
    }

    bestRating *= me->p_fuel / (double) me->p_ship.s_maxfuel;
    if ( totalArmies > 0 )
	bestRating /= totalArmies;
	
    strategy->engageEnemy = 1;
    strategy->plan = ST_GUARD;
    strategy->planet = bestPlanet;
    strategy->rating = bestRating;
    if ( bestPlanet >= 0 ) {
	bestEnemy = -1;
	planetDistance = 10000.0;
	for (i=MAXPLAYER-1; i>=0; --i ) {
	    if ( isAlive( &players[i] ) &&
		!friendlyPlayer( &players[i] ) &&
		pointWithinSquare( &botUniverse[0].planets[bestPlanet].point,
				   &botUniverse[0].players[i].point,
				  planetDistance ))
	    {
		if (teammateAttackingPlayer( &players[i] ) )
		    continue;
		
		distance = hypot( (double) botUniverse[0].players[i].point.x -
				 planets[bestPlanet].pl_x,
				 (double) botUniverse[0].players[i].point.y -
				 planets[bestPlanet].pl_y);
		if ( distance < planetDistance ) {
		    bestEnemy = i;
		    planetDistance = distance;
		}
	    }
	}
	if (bestEnemy >= 0) {
	    strategy->player = bestEnemy;
	}
	else {   
	    strategy->player = -1;
	}
    }
    else {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->x = 0;
	strategy->y = 0;
    }

    if (strategy->rating > 100.0)
	strategy->rating = 100.0;
    
    return strategy->rating;
}

double botSpaceControl( BOT_STRATEGY *strategy )
{
    int i,j;
    struct planet *k, *enemyHome, *myHome;
    int bestPlanet;
    double bestRating;
    double rating;
    double planetDistance;
    int armies;
    int enemyTeam;
    double distance;
    int bestEnemy;
    
    if ( !status->tourn ||
	(me->p_armies && me->p_ship.s_type != STARBASE) ||
	me->p_ship.s_type == SCOUT ||
	me->p_ship.s_type == ASSAULT ) {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_GUARD;
	return 0.0;
    }

    enemyTeam = botEnemyTeam();
    enemyHome = &planets[ (remap[enemyTeam]-1) * 10];
    myHome = &planets[ (remap[me->p_team]-1) * 10];

    strategy->x = 0;
    strategy->y = 0;
    
    /* now decide where to control */
    bestRating = -100.0;
    bestPlanet = -1;
    for (i=MAXPLANETS-1; i>=0; --i) {
	k = &planets[i];
	if ( !myPlanet( k ) && !(friendlyPlanet( k ) && !k->pl_armies) )
	    continue;

	if ( corePlanet( k ) && !myCorePlanet( k ) )
	    continue;

	if ( enemyPlayersNearPlanet( k ) < -2 &&
	    me->p_ship.s_type != STARBASE)
	    continue;
	
	if ( hypot( (double) k->pl_x - myHome->pl_x,
		    (double) k->pl_y - myHome->pl_y ) > 45000 )
	    continue;
	
	planetDistance =
	    hypot( (double) k->pl_x - enemyHome->pl_x,
		  (double) k->pl_y - enemyHome->pl_y );

	armies = k->pl_armies;
	if (armies > 4)
	    armies = 3;
	
	rating = 1.4 * (100000.0 - planetDistance) / 1000.0 +
	    10 - armies;
	
	if (k->pl_flags & PLAGRI) {
	    if ( me->p_ship.s_type == STARBASE )
		rating += 7;
	    else
		rating += 5;
	}
	if (k->pl_flags & PLFUEL) {
	    if ( me->p_ship.s_type != STARBASE )
		rating += 3;
	}
	if (k->pl_flags & PLREPAIR) {
	    if ( me->p_ship.s_type == STARBASE )
		rating += 10;
	    else
		rating += 2;
	}

	for (j=MAXPLAYER-1; j>=0; --j) {
	    if ( !isAlive( &players[j] ) || friendlyPlayer( &players[j] ) )
		continue;
	    
	    if (pointWithinSquare( &botUniverse[0].planets[i].point,
				  &botUniverse[0].players[j].point,
				  25000.0))
		break;
	}
	if (j >= 0)
	    rating += 10.0;

	if ( rating > bestRating ) {
	    bestPlanet = i;
	    bestRating = rating;
	}
    }
	
    strategy->engageEnemy = 1;
    strategy->plan = ST_GUARD;
    if ( bestPlanet >= 0 ) {
	if ( me->p_ship.s_type == STARBASE )
	    strategy->rating = 80;
	else
	    strategy->rating = 30;
	
	strategy->planet = bestPlanet;
	strategy->player = -1;
	
	bestEnemy = -1;
	planetDistance = 10000.0;
	for (i=MAXPLAYER-1; i>=0; --i ) {
	    if ( isAlive( &players[i] ) &&
		!friendlyPlayer( &players[i] ) &&
		pointWithinSquare( &botUniverse[0].planets[bestPlanet].point,
				   &botUniverse[0].players[i].point, 10000.0 ))
	    {
		distance = hypot( (double) botUniverse[0].players[i].point.x -
				 planets[bestPlanet].pl_x,
				 (double) botUniverse[0].players[i].point.y -
				 planets[bestPlanet].pl_y);
		if ( distance < planetDistance ) {
		    bestEnemy = i;
		    planetDistance = distance;
		}
	    }
	}
	if (bestEnemy >= 0) 
	    strategy->player = bestEnemy;
    }
    else {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->x = 0;
	strategy->y = 0;
    }
    
    return strategy->rating;
}

double botRefit( BOT_STRATEGY *strategy )
{
    int i;
    int totalArmies = 0;
    int totalPlanets = 0;
    int enemyTeam;
    
    if ( me->p_ship.s_type != STARBASE || me->p_armies )
    {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_REFIT;
	return 0.0;
    }

    enemyTeam = botEnemyTeam();
    
    for (i=MAXPLANETS-1; i>=0; --i) {
	if (myPlanet( &planets[i] ) ) {
	    totalPlanets++;

	    if ( planets[i].pl_armies < 15 &&
		i / 10 != remap[me->p_team]-1 &&
		i / 10 != remap[enemyTeam]-1 )
		continue;
	    
	    if (planets[i].pl_armies > 4)
		totalArmies += planets[i].pl_armies - 4;
	}
    }

    if ( (totalPlanets > 5 && totalArmies < 4) || !botPlaySB )
    {
	strategy->rating = 100.0;
	strategy->planet = 10 * (remap[me->p_team] - 1);
	strategy->player = -1;
	strategy->plan = ST_REFIT;
	return 100.0;
    }
    else
    {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_REFIT;
	return 0.0;
    }
}

double botGetArmies( BOT_STRATEGY *strategy )
{
    int i;
    struct planet *k;
    int bestPlanet;
    int enemyNearPlanet;
    double bestRating;
    double rating;
    double planetDistance;
    int armies;
    int maxArmies;
    int teamCarriers;
    int enemyTeam;
    struct obtype *gettarget(), *target;
    int SBplayer;
    int neededArmies;
    int maxSpeed;
    int angle, timeToArrive;
    
    if ( !status->tourn ) {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_GET;
	return 0.0;
    }

    if ( me->p_ship.s_type != STARBASE ) {
	bestPlanet = 0;
	for (i=MAXPLANETS-1; i>=0; --i) {
	    if ( myPlanet( &planets[i] ) )
		bestPlanet++;
	}
	if ( bestPlanet <= 5 ) {
	    strategy->rating = 0.0;
	    strategy->planet = -1;
	    strategy->player = -1;
	    strategy->plan = ST_GET;
	    return 0.0;
	}
    }

    if ( !me->p_armies ) {
	teamCarriers = 0;
	for (i=MAXPLAYER-1; i>=0; --i) {
	    if ( isAlive( &players[i] ) &&
		players[i].p_team == me->p_team &&
		botUniverse[0].players[i].armies_known )
		teamCarriers++;
	}
	if (teamCarriers >= 3) {
	    strategy->rating = 0.0;
	    strategy->planet = -1;
	    strategy->player = -1;
	    strategy->plan = ST_GET;
	    return 0.0;
	}
    }
    
    maxArmies = botMaxArmies( me );
    enemyTeam = botEnemyTeam();
    maxSpeed = botMaxSpeed();
    
    if ( me->p_ship.s_type != STARBASE && maxArmies > 5)
	maxArmies = 5;
    if ( me->p_armies >= maxArmies )
    {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_GET;
	return 0.0;
    }

    neededArmies = maxArmies - me->p_armies;
    
    if ( shipOrbitting( me ) ) {
	target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			   me->p_y * WINSIDE/GWIDTH, TARG_PLANET);
	k = &planets[target->o_num];      

	if ( myPlanet( k ) && k->pl_armies > 4 ) {
	    strategy->rating = 100.0;
	    strategy->planet = target->o_num;
	    strategy->player = -1;
	    strategy->plan = ST_GET;
	    return 100.0;
	}
    }
    
    /* now decide which planet to get armies from */
    bestRating = -100.0;
    bestPlanet = -1;
    for (i=0; i<MAXPLANETS; i++) {
 	k = &planets[i];
	if ( !myPlanet( k ) )
	    continue;

	if ( k->pl_armies > 4) {
	    armies = k->pl_armies - 4;
	}
	else
	    armies = 0;

	if ( !armies )
	    continue;

	if ( armies > neededArmies )
	    armies = neededArmies;

	if ( armies < 15 && me->p_ship.s_type == STARBASE &&
	    i / 10 != remap[me->p_team]-1 &&
	    i / 10 != remap[enemyTeam]-1 )
	    continue;
	
	planetDistance =
	    botDistanceFromMe( &botUniverse[0].planets[i].point );

	if ( planetDistance > 25000 &&
	    (me->p_ship.s_type == SCOUT || me->p_ship.s_type == ASSAULT))
	    continue;

	if ( planetDistance > 15000 &&
	    me->p_ship.s_type == STARBASE )
	    continue;
	
	enemyNearPlanet = -enemyPlayersNearPlanet( k );
	
	/* If there are more enemies near the planet than friendly's,
	   assume that they will bomb the planet */
	if ( enemyNearPlanet > 0 && planetDistance > 8000 )
	    continue;

	angle = botGetAngle( k->pl_x, k->pl_y );
	timeToArrive = 1 + planetDistance / (maxSpeed * WARP1);
	timeToArrive += enemyTimeInDirection( angle, timeToArrive, -1 );
	
	rating = 15.0 * armies / timeToArrive;
	
	if ( rating > bestRating ) {
	    bestPlanet = i;
	    bestRating = rating;
	}
    }

    /* Now, see if the SB is closer */
    SBplayer = -1;
    if ( me->p_ship.s_type != STARBASE )
    {
	for (i=MAXPLAYER-1; i>=0; --i ) {
	    if ( isAlive( &players[i] ) &&
		players[i].p_team == me->p_team &&
		players[i].p_ship.s_type == STARBASE &&
		(players[i].p_flags & PFDOCKOK) &&
		botUniverse[0].players[i].armies_suspected > 0 ) {
		SBplayer = i;
	    }
	}

	if ( SBplayer >= 0) {
	    for (i=MAXPLAYER-1; i>=0; --i) {
		if ( isAlive( &players[i] ) &&
		    !friendlyPlayer( &players[i] ) &&
		    pointWithinSquare( &botUniverse[0].players[SBplayer].point,
				      &botUniverse[0].players[i].point,
				      10000.0 ) )
		    break;
	    }

	    if ( i < 0 ) {
		armies = MIN( neededArmies, botUniverse[0].players[SBplayer].armies_known );
		planetDistance =
		    botDistanceFromMe( &botUniverse[0].players[SBplayer].point );
		rating = 15.0 * armies / (planetDistance / WARP1 / maxSpeed );
		if ( rating > bestRating ) {
		    bestPlanet = SBplayer + MAXPLANETS;
		    bestRating = rating;
		}
	    }
	}
    }

    strategy->plan = ST_GET;

    if ( me->p_flags & PFBEAMUP )
	strategy->rating = 100.0;

#if 0
    if (me->p_fuel > me->p_ship.s_maxfuel / 2 &&
	me->p_shield > me->p_ship.s_maxshield / 3 &&
	me->p_damage < 10)
	strategy->engageEnemy = 1;
    else
	strategy->engageEnemy = 0;
#else
    if ( me->p_armies && me->p_ship.s_type != STARBASE )
      strategy->engageEnemy = 0;
    else
      strategy->engageEnemy = 1;
#endif
	
    if ( bestPlanet >=0 )
    {
	strategy->rating = bestRating;
	if (bestPlanet < MAXPLANETS) {
	    strategy->planet = bestPlanet;
	    strategy->player = -1;
	    strategy->x = planets[bestPlanet].pl_x;
	    strategy->y = planets[bestPlanet].pl_y;
	}
	else {
	    strategy->planet = -1;
	    strategy->player = bestPlanet-MAXPLANETS;
	    strategy->x = players[strategy->player].p_x;
	    strategy->y = players[strategy->player].p_y;
	}
    }
    else
    {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
    }


    if (strategy->rating > 100.0)
	strategy->rating = 100.0;
    
    return strategy->rating;
}

double botBombPlanet( BOT_STRATEGY *strategy )
{
    int i,j,m;
    struct planet *k;
    struct obtype *gettarget(), *target;
    int enemyTeam;
    int bestPlanet;
    double bestRating;
    double rating;
    double planetDistance;
    int armies;
    int teamAStaker;
    int myTicksToArrive;
    int maxSpeed;
    int angle;
    int bestEnemy;
    double distance;
    int attackEnemy;
    
    if ( !status->tourn || me->p_ship.s_type == STARBASE || me->p_armies ) {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_BOMB;
	return 0.0;
    }

    teamAStaker=0;
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( players[i].p_team == me->p_team &&
	    players[i].p_ship.s_type == ASSAULT &&
	    botUniverse[0].players[i].armies_known > 0 ) {
	    teamAStaker++;
	    break;
	}
    }
    
    if ( shipOrbitting( me ) ) {
	target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			   me->p_y * WINSIDE/GWIDTH, TARG_PLANET);
	k = &planets[target->o_num];      
	
	if ( !friendlyPlanet( k ) && k->pl_armies > 4 ) {
	    if ( (myCorePlanet( k ) || teamAStaker)
		&& k->pl_armies == 5 &&
		me->p_armies < 5 - (me->p_ship.s_type == ASSAULT) )
	    {
		strategy->rating = 0.0;
		strategy->planet = -1;
		strategy->player = -1;
		strategy->plan = ST_BOMB;
	    }
	    else {
		strategy->plan = ST_BOMB;
		strategy->rating = 100.0;
		strategy->planet = target->o_num;
		strategy->player = -1;
		strategy->x = k->pl_x;
		strategy->y = k->pl_y;
		return 100.0;
	    }
	}
    }

    enemyTeam = botEnemyTeam();
    maxSpeed = botMaxSpeed();
    
    /* now decide which planet to bomb */
    bestRating = -100.0;
    bestPlanet = -1;
    for (i=0; i<MAXPLANETS; i++) {
	k = &planets[i];

	if ( friendlyPlanet( k ) )
	    continue;

	if ( k->pl_owner == enemyTeam && k->pl_armies > 4) {
	    armies = k->pl_armies - 4;
	}
	else if ( !(k->pl_info & me->p_team) &&
		 ( 1 + i / 10 == remap[enemyTeam] ||
		  1 + i / 10 == remap[me->p_team] ) ) {
	    armies = ABS( botUniverse[0].planets[i].armies );
	}
	else
	    armies = 0;

	if ( !armies )
	    continue;

	if ( (myCorePlanet( k ) || teamAStaker ) && armies == 1 &&
	    me->p_armies < 5 - (me->p_ship.s_type == ASSAULT) )
	    continue;

	planetDistance =
	    botDistanceFromMe( &botUniverse[0].planets[i].point );

	for (j=MAXPLAYER-1; j>=0; --j) {
	    if ( isAlive( &players[j] ) &&
		!friendlyPlayer( &players[j] ) &&
		pointWithinSquare( &botUniverse[0].planets[i].point,
				  &botUniverse[0].players[j].point,
				  10000.0 ) )
		break;
	}
	if (j < 0)
	    attackEnemy = 0;
	else
	    attackEnemy = 1;

	for (j=MAXPLAYER-1; j>=0; --j) {
	    if ( !isAlive( &players[j] ) ||
		myPlayer( &players[j] ) ||
		!friendlyPlayer( &players[j] ) ||
		!pointWithinSquare( &botUniverse[0].planets[i].point,
				   &botUniverse[0].players[j].point,
				   10000.0 ) )
		continue;
	    
	    if ( !players[j].p_speed || shipCloaked( &players[j] ) ) {
		for (m=MAXPLANETS-1; m>=0; --m) {
		    if ( m != i &&
			pointWithinSquare( &botUniverse[0].planets[m].point,
					  &botUniverse[0].players[j].point,
					  2000.0 ) )
			break;
		}
		if ( m>=0 )
		    continue;
	    }
		
	    if ( hypot( (double) botUniverse[0].players[j].point.x -
		       k->pl_x,
		       (double) botUniverse[0].players[j].point.y -
		       k->pl_y ) < planetDistance )
		break;
	}
	if ( j>=0 && !attackEnemy )
	    continue;
	if ( j<0 )
	    attackEnemy = 0;

	for (j=MAXPLAYER-1; j>=0; --j) {
	    if ( !isAlive( &players[j] ) ||
		myPlayer( &players[j] ) ||
		!friendlyPlayer( &players[j] ) ||
		!pointWithinSquare( &botUniverse[0].planets[i].point,
				   &botUniverse[0].players[j].point,
				   2000.0 ) )
		continue;
	    
	    if ( !players[j].p_speed || shipCloaked( &players[j] ) ) {
		break;
	    }
	}
	if (j >= 0)
	    continue;

	myTicksToArrive = 1 + planetDistance / (maxSpeed * WARP1);

	angle = botGetAngle( k->pl_x, k->pl_y );
	myTicksToArrive += enemyTimeInDirection( angle, myTicksToArrive, -1 );
	rating = 10 * armies / (double) myTicksToArrive;

#if 0
	if (me->p_ship.s_type != SCOUT &&
	    me->p_ship.s_type != ASSAULT &&
	    rating < 3.33 )
	    continue;
#endif
	
	if ( rating > bestRating ) {
	    bestPlanet = i;
	    bestRating = rating;
	}
    }
	
    if ( bestPlanet >= 0 ) {
	strategy->rating = bestRating;
	strategy->planet = bestPlanet;
	strategy->player = -1;
	strategy->x = planets[bestPlanet].pl_x;
	strategy->y = planets[bestPlanet].pl_y;
    }
    else {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->x = 0;
	strategy->y = 0;
    }

#if 0
    if (me->p_fuel > me->p_ship.s_maxfuel / 2 &&
	me->p_shield > me->p_ship.s_maxshield / 3 &&
	me->p_damage < 10)
	strategy->engageEnemy = 1;
    else
	strategy->engageEnemy = 0;
#endif
    strategy->engageEnemy = 1;
    
    strategy->plan = ST_BOMB;

#if 0
    if ( me->p_ship.s_type == SCOUT || me->p_ship.s_type == ASSAULT )
	strategy->rating *= 1.1;
#endif
        
    if (strategy->rating > 100.0)
	strategy->rating = 100.0;

    if ( bestPlanet >= 0 && attackEnemy ) {
	bestEnemy = -1;
	planetDistance = 10000.0;
	for (i=MAXPLAYER-1; i>=0; --i ) {
	    if ( isAlive( &players[i] ) &&
		!friendlyPlayer( &players[i] ) &&
		pointWithinSquare( &botUniverse[0].planets[bestPlanet].point,
				   &botUniverse[0].players[i].point,
				  planetDistance ))
	    {
		if (teammateAttackingPlayer( &players[i] ) )
		    continue;
		
		distance = hypot( (double) botUniverse[0].players[i].point.x -
				 planets[bestPlanet].pl_x,
				 (double) botUniverse[0].players[i].point.y -
				 planets[bestPlanet].pl_y);
		if ( distance < planetDistance ) {
		    bestEnemy = i;
		    planetDistance = distance;
		}
	    }
	}
	if (bestEnemy >= 0) {
	    strategy->player = bestEnemy;
	}
	else {   
	    strategy->player = -1;
	}
    }

#if 0
    if ( me->p_ship.s_type != SCOUT && me->p_ship.s_type != ASSAULT )
	strategy->rating *= 0.8;
#endif
    
    return strategy->rating;
}

#if 0
double botTakePlanet( BOT_STRATEGY *strategy )
{
    int i,j;
    struct planet *k, *myHome;
    struct obtype *gettarget(), *target;
    int enemyTeam;
    int bestPlanet;
    int enemyNearPlanet;
    double bestRating;
    double rating;
    double factor;
    double planetDistance;
    int armies;
    int bonusFactor = 0;
    int maxArmies;

    if (!status->tourn || me->p_ship.s_type == STARBASE ||
	me->p_armies <= 0) {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_TAKE;
	return 0.0;
    }

    if ( shipOrbitting( me ) ) {
	target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			   me->p_y * WINSIDE/GWIDTH, TARG_PLANET);
	k = &planets[target->o_num];      

	if ( myPlanet( k ) && k->pl_armies < 4 && me->p_armies ) {
	    strategy->plan = ST_TAKE;
	    strategy->rating = 100.0;
	    strategy->planet = target->o_num;
	    strategy->player = -1;
	    strategy->x = k->pl_x;
	    strategy->y = k->pl_y;
	    return 100.0;
	}
	else if ( !friendlyPlanet( k ) || !k->pl_armies ) {
	    if ( (k->pl_flags & PLAGRI) &&
		me->p_armies < k->pl_armies &&
		me->p_armies < 4 )
	    {
		strategy->rating = 0.0;
		strategy->planet = -1;
		strategy->player = -1;
		strategy->plan = ST_TAKE;
	    }
	    else {
		strategy->plan = ST_TAKE;
		strategy->rating = 100.0;
		strategy->planet = target->o_num;
		strategy->player = -1;
		strategy->x = k->pl_x;
		strategy->y = k->pl_y;
		return 100.0;
	    }
	}
    }

    maxArmies = botMaxArmies( me );
    enemyTeam = botEnemyTeam();
    myHome = &planets[ (remap[me->p_team]-1) * 10];
    
    /* now decide which planet to take */
    bestRating = -100.0;
    bestPlanet = -1;
    for (i=MAXPLANETS-1; i>=0; --i ) {
	k = &planets[i];
	if ( friendlyPlanet( k ) && k->pl_armies )
	    continue;

	if (k->pl_owner == enemyTeam ||
	    ( (k->pl_info & me->p_team) && !k->pl_armies)) 
	    armies = k->pl_armies;
	else if ( !(k->pl_info & me->p_team) &&
		 ( 1 + i / 10 == remap[enemyTeam] ||
		  1 + i / 10 == remap[me->p_team] ) ) {
	    armies = ABS( botUniverse[0].planets[i].armies );
	}
	else {
	    continue;
	}

	if (armies > 4)
	    armies = 3;

	if ( (botUniverse[0].planets[i].planetType & PLAGRI) &&
	    armies > me->p_armies )
	    continue;

	planetDistance = hypot( (double) k->pl_x - myHome->pl_x,
			       (double) k->pl_y - myHome->pl_y );
	
	enemyNearPlanet = enemyPlayersNearPlanet( k );

	rating = (100000.0 - planetDistance) / 1000.0 -
	    enemyNearPlanet * 3;

	bonusFactor = 0;
	if (botUniverse[0].planets[i].planetType & PLAGRI)
	    bonusFactor += 10;
	if (botUniverse[0].planets[i].planetType & PLFUEL)
	    bonusFactor += 6;
	if (botUniverse[0].planets[i].planetType & PLREPAIR)
	    bonusFactor += 4;
	if ( me->p_armies > armies )
	    bonusFactor += 10;
	else if ( me->p_armies == armies )
	    bonusFactor += 3;
	else
	    bonusFactor /= 2;

	rating += bonusFactor;
	if ( me->p_armies <= armies && me->p_armies < maxArmies )
	    rating *= .6;
	
	if ( rating > bestRating ) {
	    bestPlanet = i;
	    bestRating = rating;
	}
    }
	
    if ( bestPlanet >= 0 ) {
	strategy->rating = bestRating;
	strategy->planet = bestPlanet;
	strategy->player = -1;
	strategy->x = planets[bestPlanet].pl_x;
	strategy->y = planets[bestPlanet].pl_y;
    }
    else {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->x = 0;
	strategy->y = 0;
    }

#if 0
    if (me->p_fuel > me->p_ship.s_maxfuel / 2 &&
	me->p_shield > me->p_ship.s_maxshield / 2 &&
	me->p_damage < 10)
	strategy->engageEnemy = 1;
    else
	strategy->engageEnemy = 0;
#else
    strategy->engageEnemy = 1;
#endif
    
    strategy->plan = ST_TAKE;
    if (strategy->rating > 100.0)
	strategy->rating = 100.0;
    
    return strategy->rating;
}
#else
double botTakePlanet( BOT_STRATEGY *strategy )
{
    int i;
    struct planet *k;
    struct obtype *target;
    int enemyTeam;
    int bestPlanet;
    double bestRating;
    double rating;
    double planetDistance;
    int armies;
    int bonusFactor = 0;
    int maxArmies;
    int myTicksToArrive;
    int maxSpeed;
    int angle;
    
    if (!status->tourn || me->p_ship.s_type == STARBASE ||
	me->p_armies <= 0) {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_TAKE;
	return 0.0;
    }

    if ( shipOrbitting( me ) ) {
	target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			   me->p_y * WINSIDE/GWIDTH, TARG_PLANET);
	k = &planets[target->o_num];      

	if ( myPlanet( k ) && k->pl_armies < 4 && me->p_armies ) {
	    strategy->plan = ST_TAKE;
	    strategy->rating = 100.0;
	    strategy->planet = target->o_num;
	    strategy->player = -1;
	    strategy->x = k->pl_x;
	    strategy->y = k->pl_y;
	    return 100.0;
	}
	else if ( !friendlyPlanet( k ) || !k->pl_armies ) {
	    if ( (k->pl_flags & PLAGRI) &&
		me->p_armies < k->pl_armies &&
		me->p_armies < 4 )
	    {
		strategy->rating = 0.0;
		strategy->planet = -1;
		strategy->player = -1;
		strategy->plan = ST_TAKE;
	    }
	    else {
		strategy->plan = ST_TAKE;
		strategy->rating = 100.0;
		strategy->planet = target->o_num;
		strategy->player = -1;
		strategy->x = k->pl_x;
		strategy->y = k->pl_y;
		return 100.0;
	    }
	}
    }

    maxArmies = botMaxArmies( me );
    enemyTeam = botEnemyTeam();
    maxSpeed = botMaxSpeed();
    
    /* now decide which planet to take */
    bestRating = -100.0;
    bestPlanet = -1;
    for (i=MAXPLANETS-1; i>=0; --i ) {
	k = &planets[i];
	if ( friendlyPlanet( k ) && k->pl_armies )
	    continue;

	if (k->pl_owner == enemyTeam ||
	    ( (k->pl_info & me->p_team) && !k->pl_armies)) 
	    armies = k->pl_armies;
	else if ( !(k->pl_info & me->p_team) &&
		 ( 1 + i / 10 == remap[enemyTeam] ||
		  1 + i / 10 == remap[me->p_team] ) ) {
	    armies = ABS( botUniverse[0].planets[i].armies );
	}
	else {
	    continue;
	}

	if (armies > 4)
	    armies = 3;

	if ( (botUniverse[0].planets[i].planetType & PLAGRI) &&
	    armies > me->p_armies )
	    continue;

	planetDistance = botDistanceFromMe( &botUniverse[0].planets[i].point );

	myTicksToArrive = 1 + planetDistance / (maxSpeed * WARP1);

	angle = botGetAngle( k->pl_x, k->pl_y );
	myTicksToArrive += enemyTimeInDirection( angle, myTicksToArrive, -1 ) *
	    me->p_ship.s_maxfuel / (1 + me->p_fuel);

	bonusFactor = me->p_armies * 10;
	if ( !corePlanet( k ) || myCorePlanet( k ) )
	    bonusFactor += 3;
	if (botUniverse[0].planets[i].planetType & PLAGRI)
	    bonusFactor += 10;
	if (botUniverse[0].planets[i].planetType & PLFUEL)
	    bonusFactor += 5;
	if (botUniverse[0].planets[i].planetType & PLREPAIR)
	    bonusFactor += 2;
	if ( me->p_armies > armies )
	    bonusFactor *= 2;
	else if ( me->p_armies <= armies && me->p_armies < maxArmies )
	    bonusFactor /= 2;
	
	rating = bonusFactor / (double) myTicksToArrive;

#if 0
	fprintf(stderr, "%c%c: %s rating is %f\n",
		teamlet[me->p_team],
		shipnos[me->p_no],
		k->pl_name,
		rating );
#endif
	
	if ( rating > bestRating ) {
	    bestPlanet = i;
	    bestRating = rating;
	}
    }
	
    if ( bestPlanet >= 0 ) {
#if 0
	fprintf(stderr, "%c%c: best planet is %s with rating of %f\n\n",
		teamlet[me->p_team],
		shipnos[me->p_no],
		planets[bestPlanet].pl_name,
		bestRating );
#endif
	
	strategy->rating = bestRating;
	strategy->planet = bestPlanet;
	strategy->player = -1;
	strategy->x = planets[bestPlanet].pl_x;
	strategy->y = planets[bestPlanet].pl_y;
    }
    else {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->x = 0;
	strategy->y = 0;
    }

#if 0
    if (me->p_fuel > me->p_ship.s_maxfuel / 2 &&
	me->p_shield > me->p_ship.s_maxshield / 2 &&
	me->p_damage < 10)
	strategy->engageEnemy = 1;
    else
	strategy->engageEnemy = 0;
#else
    strategy->engageEnemy = 1;
#endif
    
    strategy->plan = ST_TAKE;
    if (strategy->rating > 100.0)
	strategy->rating = 100.0;
    
    return strategy->rating;
}
#endif

double botWaitForPop( BOT_STRATEGY *strategy )
{
    int i;
    struct planet *k, *thirdSpaceHome, *enemyHome;
    int enemyTeam;
    int enemyNearPlanet;
    BOT_POINT point1;
    BOT_POINT point2;
    int numberOfArmies1 = 0;
    int numberOfArmies2 = 0;
    int thirdSpace;
    int armies;
    unsigned char angle;
    
    if (!status->tourn) {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_WAIT;
	return 0.0;
    }

    switch ( me->p_ship.s_type ) {
    case SCOUT:
    case ASSAULT:
	strategy->rating = 0.15;
	break;
	
    case DESTROYER:
    case CRUISER:
    case STARBASE:
    case BATTLESHIP:
    default:
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_WAIT;
	return 0.0;
    }

    enemyTeam = botEnemyTeam();
    thirdSpace = botEnemyThirdSpace();
    enemyHome = &planets[ (remap[enemyTeam] - 1) * 10];
    thirdSpaceHome = &planets[ (remap[thirdSpace] - 1) * 10];
    point1.x = 0;
    point1.y = 0;
    point2.x = 0;
    point2.y = 0;

    /* ok - now count how many armies the enemy has on its planets.
       Planets where I have no info counts as 15 armies */
    strategy->x = 0;
    strategy->y = 0;
    for (i=MAXPLANETS-1; i>=0; --i) {
	k = &planets[i];

	if ( 1 + i / 10 != remap[enemyTeam] )
	    continue;

	if ( k->pl_owner == enemyTeam || !(k->pl_info & me->p_team) ) {
	    enemyNearPlanet = enemyPlayersNearPlanet( k );
	    if (enemyNearPlanet < 0)
		enemyNearPlanet = 0;
	}
	else
	    continue;

	if ( enemyNearPlanet > 0 )
	    continue;
	
	if ( !(k->pl_info & me->p_team) )
	    armies = 1;
	else 
	    armies = k->pl_armies;

	if ( botUniverse[0].planets[i].planetType & PLAGRI )
	    armies += 2;

	if ( hypot( (double) thirdSpaceHome->pl_x - k->pl_x,
		   (double) thirdSpaceHome->pl_y - k->pl_y ) <= 60000 ) {
	    numberOfArmies1 += armies;
	    point1.x += k->pl_x * armies;
	    point1.y += k->pl_y * armies;
	}
	else {
	    numberOfArmies2 += armies;
	    point2.x += k->pl_x * armies;
	    point2.y += k->pl_y * armies;
	}	    
    }

    strategy->engageEnemy = 0;
    
    if ( !numberOfArmies1 && !numberOfArmies2 ) {
	strategy->x = 0;
	strategy->y = 0;
	strategy->rating = 0.0;
	strategy->plan = ST_WAIT;
	strategy->player = -1;
	strategy->planet = -1;
    }
    else if ( numberOfArmies1 >= numberOfArmies2 ) {
	strategy->x = point1.x / numberOfArmies1;
	strategy->y = point1.y / numberOfArmies1;
	strategy->plan = ST_WAIT;
	strategy->player = -1;
	strategy->planet = -1;
    }
    else {
	strategy->x = point2.x / numberOfArmies2;
	strategy->y = point2.y / numberOfArmies2;
	strategy->plan = ST_WAIT;
	strategy->player = -1;
	strategy->planet = -1;
    }

    if ( strategy->x == enemyHome->pl_x &&
	strategy->y == enemyHome->pl_y )
	angle = 0;
    else
	angle = NORMALIZE(atan2((double) strategy->x - enemyHome->pl_x,
				(double) enemyHome->pl_y - strategy->y) /
			  PI * 128);

    strategy->x = 15000 * Cos[angle] + enemyHome->pl_x;
    strategy->y = 15000 * Sin[angle] + enemyHome->pl_y;
    
    return strategy->rating;
}

double botAttackPlayer( BOT_STRATEGY *strategy )
{
    int i,j;
    double enemyDistance, distance;
    double bestRating = -1.0;
    double enemyRating;
    int enemy = -1;
    int enemyDir;
    struct planet *k;
    int timeToArrive;
    int enemySpeed;
    BOT_POINT point;
    int teamNearSB;
    int enemyTeam;
    int maxSpeed;
    int angle;
    
    if ( me->p_armies || me->p_ship.s_type == STARBASE ) {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_OGG;
	return 0.0;
    }

    enemyTeam = botEnemyTeam();
    maxSpeed = botMaxSpeed();

    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !isAlive( &players[i] ) || friendlyPlayer( &players[i] ) )
	    continue;

	if (players[i].p_ship.s_type == STARBASE) {
	    teamNearSB = 0;
	    for (j=MAXPLAYER-1; j>=0; --j) {
		if ( isAlive( &players[j] ) &&
		    friendlyPlayer( &players[j] ) &&
		    pointWithinSquare( &botUniverse[0].players[i].point,
				      &botUniverse[0].players[j].point,
				      10000 ) )
		    teamNearSB++;
	    }
	    if (teamNearSB < 3)
		continue;
	}

	enemySpeed = botUniverse[0].players[i].speed;
	enemyDir = botUniverse[0].players[i].dir;

	if ( teammateAttackingPlayer( &players[i] ) )
	    continue;
	
	distance = 
	    botDistanceFromMe( &botUniverse[0].players[i].point );

	timeToArrive = 1 + distance / (1 + maxSpeed + enemySpeed) / WARP1;

	point.x = botUniverse[0].players[i].point.x +
	    timeToArrive * enemySpeed * WARP1 * Cos[enemyDir];
	point.y = botUniverse[0].players[i].point.y +
	    timeToArrive * enemySpeed * WARP1 * Sin[enemyDir];
	
	/* only worry about enemies that are not in 3rd space */
	if ( status->tourn ) {
	    for (j=MAXTEAM-1; j>=0; --j) {
		if ( 1 << j == me->p_team )
		    continue;
		if ( 1 << j == enemyTeam )
		    continue;
		k = &planets[j * 10];
		enemyDistance =
		    hypot( (double) k->pl_x - point.x,
			  (double) k->pl_y - point.y );
		if (enemyDistance < 25000.0)
		    break;
	    }
	    if ( j >= 0 )
		continue;
	}

	point.distance = 0.0;
	enemyDistance =
	    botDistanceFromMe( &point );

	angle = botGetAngle( point.x, point.y );
	timeToArrive += enemyTimeInDirection( angle, timeToArrive, i );

	enemyRating = 10.0 *
	    me->p_fuel / me->p_ship.s_maxfuel *
		me->p_ship.s_phaserdamage /
		    players[i].p_ship.s_phaserdamage / timeToArrive;

	if ( status->tourn )
	    enemyRating *= botUniverse[0].players[i].armies_suspected +
		botUniverse[0].players[i].armies_known * 2.0 +
		    players[i].p_kills / 5;
	else
	    enemyRating *= 4.0 + players[i].p_kills / 5;
	    
#if 0
	if ( (me->p_ship.s_type == SCOUT || me->p_ship.s_type == ASSAULT ) &&
	    ( !botUniverse[0].players[i].armies_suspected ||
	    enemyDistance > 10000.0 ) )
	    continue;
#endif

	if (enemyRating > bestRating) {
	    enemy = i;
	    bestRating = enemyRating;
	}
    }

    strategy->rating = bestRating;
    strategy->planet = -1;
    strategy->plan = ST_OGG;
    strategy->engageEnemy = 1;

    if (enemy >= 0) {
	strategy->x = players[enemy].p_x;
	strategy->y = players[enemy].p_y;
	strategy->player = enemy;
    }
    else {
	strategy->x = 0;
	strategy->y = 0;
	strategy->player = -1;
	strategy->rating = 0.0;
    }	

    if (strategy->rating > 100.0)
	strategy->rating = 100.0;

    return strategy->rating;
}

double botEscortPlayer( BOT_STRATEGY *strategy )
{
    int i,j;
    double distance;
    double bestDistance;
    double bestRating = -1.0;
    double rating;
    int bestEscort = -1;
    int escortWho = -1;
    int maxSpeed;
    
    if ( !status->tourn ||
	(me->p_armies && me->p_ship.s_type != STARBASE )) {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_ESCORT;
	return 0.0;
    }
    
    bestDistance = 100000.0;
    maxSpeed = botMaxSpeed();
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !isAlive( &players[i] ) )
	    continue;

	if ( myPlayer( &players[i] ) )
	    continue;

	if ( players[i].p_team != me->p_team )
	    continue;

	if ( !botUniverse[0].players[i].armies_known )
	    continue;

	for (j=MAXPLAYER-1; j>=0; --j) {
	    if ( !isAlive( &players[j] ) )
		continue;
	    
	    if ( friendlyPlayer( &players[j] ) )
		continue;
	    
	    if ( !pointWithinSquare( &botUniverse[0].players[i].point,
				    &botUniverse[0].players[j].point,
				    15000 ) )
		continue;

	    if ( !teammateAttackingPlayer( &players[j] ) )
		break;
	}
	if ( j < 0 )
	    continue;

	distance = botDistanceFromMe( &botUniverse[0].players[i].point );
	
	if ( distance < bestDistance ) {
	    bestDistance = distance;
	    escortWho = i;
	}
    }
    if ( escortWho < 0 ) {
	strategy->rating = 0.0;
	strategy->planet = -1;
	strategy->player = -1;
	strategy->plan = ST_ESCORT;
	return 0.0;
    }

    strategy->escortPlayer = escortWho;
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !isAlive( &players[i] ) )
	    continue;

	if ( friendlyPlayer( &players[i] ) )
	    continue;

	if ( !pointWithinSquare( &botUniverse[0].players[i].point,
				&botUniverse[0].players[escortWho].point,
				15000 ) )
	    continue;

	if ( teammateAttackingPlayer( &players[i] ) )
	    continue;

	distance = 1 + botDistanceFromMe( &botUniverse[0].players[i].point );

	rating = 25.0 * botUniverse[0].players[escortWho].armies_known *
	    me->p_fuel / me->p_ship.s_maxfuel /
	    (distance / WARP1 / maxSpeed );
	    
	if (rating > bestRating) {
	    bestEscort = i;
	    bestRating = rating;
	}
    }

    if ( me->p_ship.s_type == STARBASE )
	bestRating /= 3;
    
    strategy->rating = bestRating;
    strategy->planet = -1;

    if (bestEscort >= 0) {
	strategy->x = players[bestEscort].p_x;
	strategy->y = players[bestEscort].p_y;
	strategy->player = bestEscort;
    }
    else {
	strategy->x = 0;
	strategy->y = 0;
	strategy->player = -1;
	strategy->rating = 0.0;
    }	

    strategy->plan = ST_ESCORT;
    strategy->engageEnemy = 1;

    if (strategy->rating > 100.0)
	strategy->rating = 100.0;

    return strategy->rating;
}

void botDecideStrategy( BOT_STRATEGY *strategy )
{
    BOT_STRATEGY replenish;
    BOT_STRATEGY attack;
    BOT_STRATEGY bombplanet;
    BOT_STRATEGY takePlanet;
    BOT_STRATEGY waitForPop;
    BOT_STRATEGY guard;
    BOT_STRATEGY getArmies;
    BOT_STRATEGY refit;
    BOT_STRATEGY escort;
#if 0
    BOT_STRATEGY spaceControl;
#endif
    
    if ( !isAlive( me ) )
	return;

    botAttackPlayer( &attack );
    *strategy = attack;

#if 0
    botSpaceControl( &spaceControl );
    if ( spaceControl.rating > strategy->rating )
	*strategy = spaceControl;
#endif

    if ( botBomber ) {
	botBombPlanet( &bombplanet );
	if ( bombplanet.rating >= strategy->rating )
	    *strategy = bombplanet;
	
	botWaitForPop( &waitForPop );
	if ( waitForPop.rating > strategy->rating )
	    *strategy = waitForPop;
    }

    if ( me->p_armies && me->p_ship.s_type != STARBASE ) {
	botTakePlanet( &takePlanet );
	if ( takePlanet.rating > strategy->rating )
	    *strategy = takePlanet;
    }

    if ( botPlanetTaker ||
	(botPlaySB && me->p_ship.s_type == STARBASE )) {
	botEscortPlayer( &escort );
	if ( escort.rating > strategy->rating )
	    *strategy = escort;
	
	botGetArmies( &getArmies );
	if ( getArmies.rating >= strategy->rating )
	    *strategy = getArmies;

	botGuardPlanet( &guard );
	if ( guard.rating > strategy->rating )
	    *strategy = guard;
    }
    if ( me->p_ship.s_type == STARBASE ) {
	botRefit( &refit );
	if (refit.rating > strategy->rating )
	    *strategy = refit;
    }

#if 1
    botRepairRefuel( &replenish, strategy );
    if ( replenish.rating > strategy->rating )
	*strategy = replenish;
#endif
}

void OLDbotComputeSpeedAngle( BOT_STRATEGY *strategy, int *speed,
			  int *angle )
{
    BOT_POINT point, enemyPoint, mePoint;
    int endSpeed;
    double distance;
    int maxSpeed;
    int turns;
    int deltaY;
    int deltaX;
    int deltaEnemyX;
    int deltaEnemyY;
    int dogfightSpeed;
    int i,j;
    double enemyDistance, enemyDistance2;
    double tmpDistance, previousDistance;
    unsigned char angle1, angle2;
    int enemyNear;
    int engageEnemy;
    int enemySpeed;
    int enemyDir;
    int timeToArrive;
    int minPhaserDistance;
    int numberOfIntercepts = 0;
    int enemyTime;
    int wantToOrbit = 0;
    int enemyTorpTime;
    int newDogfightCode = 0;
    int dogfightPlayer = -1;
    
    MZERO( &point, sizeof( BOT_POINT ) );
    maxSpeed = botMaxSpeed();

    turns = me->p_ship.s_turns / 8500;
    dogfightSpeed = 0;

    while (turns > 1) {
	dogfightSpeed++;
	turns = turns >> 1;
    }
    
    if (dogfightSpeed > maxSpeed )
	dogfightSpeed = maxSpeed;

    if ( strategy->planet >= 0 &&
	 strategy->planet < MAXPLANETS &&
	strategy->player >= 0 &&
	strategy->player < MAXPLAYER ) {
	enemySpeed = botUniverse[0].players[strategy->player].speed;
	enemyDir = botUniverse[0].players[strategy->player].dir;

	distance = 
	  botDistanceFromMe( &botUniverse[0].players[strategy->player].point );

	timeToArrive = distance / (1 + me->p_speed + enemySpeed) / WARP1;
	timeToArrive -= 20;
	if ( timeToArrive < 5 )
	    timeToArrive = 5;

	enemyPoint.x = botUniverse[0].players[strategy->player].point.x +
	    timeToArrive * enemySpeed * WARP1 * Cos[enemyDir];
	enemyPoint.y = botUniverse[0].players[strategy->player].point.y +
	    timeToArrive * enemySpeed * WARP1 * Sin[enemyDir];

	enemyDir =
	    ( (unsigned char)
	     (atan2((double) botUniverse[0].planets[strategy->planet].point.x -
		    botUniverse[0].players[strategy->player].point.x,
		    (double) botUniverse[0].players[strategy->player].point.y -
		    botUniverse[0].planets[strategy->planet].point.y) /
	      PI * 128) );

	if ( me->p_ship.s_type == STARBASE ) {
	    if ( me->p_damage > .6 * me->p_ship.s_maxdamage ||
		me->p_wtemp > .75 * me->p_ship.s_maxwpntemp )
		minPhaserDistance = 6000.0;
	    else
		minPhaserDistance =
		    me->p_ship.s_phaserdamage * PHASEDIST / 100 *
			(1.0 - (borgAutoPhaserDist + 60.0) /
			 me->p_ship.s_phaserdamage);
	}
	else if ( INVISIBLE( &players[strategy->player] ) )
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 * 0.1;
	else if ( botUniverse[0].players[strategy->player].armies_suspected )
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 50.0) /
			me->p_ship.s_phaserdamage);
	else
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 20.0) /
			me->p_ship.s_phaserdamage);

	point.x = enemyPoint.x + minPhaserDistance * Cos[enemyDir];
	point.y = enemyPoint.y + minPhaserDistance * Sin[enemyDir];
	point.distance = 0;
	if ( hypot( (double) point.x - planets[strategy->planet].pl_x,
		   point.y - planets[strategy->planet].pl_y ) >
	    hypot( (double) enemyPoint.x - planets[strategy->planet].pl_x,
		   enemyPoint.y - planets[strategy->planet].pl_y ) ) {
	    point.x = planets[strategy->planet].pl_x;
	    point.y = planets[strategy->planet].pl_y;
	}
	    
	endSpeed = dogfightSpeed;
    }
    else if ( strategy->planet >= 0 && strategy->planet < MAXPLANETS) {
	point.x = planets[strategy->planet].pl_x;
	point.y = planets[strategy->planet].pl_y;
	endSpeed = 2;
	wantToOrbit = 1;
    }
    else if ( strategy->player >= 0 && strategy->player < MAXPLAYER &&
	     strategy->plan == ST_REPLENISH ) {
	point.x = players[strategy->player].p_x;
	point.y = players[strategy->player].p_y;
	endSpeed = 4;
    }
    else if ( strategy->player < 0 && strategy->planet < 0 &&
	     strategy->plan == ST_REPLENISH ) {
	point.x = players[me->p_no].p_x;
	point.y = players[me->p_no].p_y;
	endSpeed = 0;
    }
    else if ( strategy->player >= 0 && strategy->player < MAXPLAYER &&
	     strategy->plan == ST_OGG ) {
      /* Normal dogfighting calculations */
      newDogfightCode = 1;
      dogfightPlayer = strategy->player;
	enemySpeed = botUniverse[0].players[strategy->player].speed;
	enemyDir = botUniverse[0].players[strategy->player].dir;

	distance = 
	  botDistanceFromMe( &botUniverse[0].players[strategy->player].point );

	timeToArrive = distance / (1 + me->p_speed + enemySpeed) / WARP1;
	timeToArrive -= 20;
	if ( timeToArrive < 5 )
	    timeToArrive = 5;

	point.x = botUniverse[0].players[strategy->player].point.x +
	    timeToArrive * enemySpeed * WARP1 * Cos[enemyDir];
	point.y = botUniverse[0].players[strategy->player].point.y +
	    timeToArrive * enemySpeed * WARP1 * Sin[enemyDir];

	enemyDir =
	    botGetAngle( botUniverse[0].players[strategy->player].point.x,
			botUniverse[0].players[strategy->player].point.y );
	enemyDir = NORMALIZE( 128 + enemyDir );

	if ( me->p_ship.s_type == STARBASE ) {
	    if ( me->p_damage > .6 * me->p_ship.s_maxdamage ||
		me->p_wtemp > .75 * me->p_ship.s_maxwpntemp )
		minPhaserDistance = 6000.0;
	    else
		minPhaserDistance =
		    me->p_ship.s_phaserdamage * PHASEDIST / 100 *
			(1.0 - (borgAutoPhaserDist + 60.0) /
			 me->p_ship.s_phaserdamage);
	}
	else if ( INVISIBLE( &players[strategy->player] ) )
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 * 0.1;
	else if ( botUniverse[0].players[strategy->player].armies_suspected )
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 50.0) /
			me->p_ship.s_phaserdamage);
	else
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 20.0) /
			me->p_ship.s_phaserdamage);

	point.x = point.x + minPhaserDistance * Cos[enemyDir];
	point.y = point.y + minPhaserDistance * Sin[enemyDir];
	point.distance = 0;

	endSpeed = dogfightSpeed;
    }
    else if ( strategy->player >= 0 && strategy->player < MAXPLAYER &&
	     strategy->plan == ST_ESCORT ) {
	/* Try to position myself between my teammate and the enemy
	   homeworld */
	enemySpeed = botUniverse[0].players[strategy->player].speed;
	enemyDir = botUniverse[0].players[strategy->player].dir;

	distance = 
	  botDistanceFromMe( &botUniverse[0].players[strategy->player].point );

	timeToArrive = distance / (1 + me->p_speed + enemySpeed) / WARP1;
	timeToArrive -= 20;
	if ( timeToArrive < 5 )
	    timeToArrive = 5;

	point.x = botUniverse[0].players[strategy->player].point.x +
	    timeToArrive * enemySpeed * WARP1 * Cos[enemyDir];
	point.y = botUniverse[0].players[strategy->player].point.y +
	    timeToArrive * enemySpeed * WARP1 * Sin[enemyDir];

#if 0
	enemySpeed = botUniverse[0].players[strategy->escortPlayer].speed;
	enemyDir = botUniverse[0].players[strategy->escortPlayer].dir;

	escortPoint.x = botUniverse[0].players[strategy->escortPlayer].point.x+
	    timeToArrive * enemySpeed * WARP1 * Cos[enemyDir];
	escortPoint.y = botUniverse[0].players[strategy->escortPlayer].point.y+
	    timeToArrive * enemySpeed * WARP1 * Sin[enemyDir];
	
	enemyDir =
	    ( (unsigned char)
	     (atan2((double) escortPoint.x - point.x,
		    (double) point.y - escortPoint.y ) / PI * 128) );
#else
	enemyDir =
	    ( (unsigned char)
	     (atan2((double) botUniverse[0].players[strategy->escortPlayer].point.x - botUniverse[0].players[strategy->player].point.x,
		    (double) botUniverse[0].players[strategy->escortPlayer].point.y - botUniverse[0].players[strategy->escortPlayer].point.y) / PI * 128) );
#endif
	
	if ( me->p_ship.s_type == STARBASE ) {
	    if ( me->p_damage > .6 * me->p_ship.s_maxdamage ||
		me->p_wtemp > .75 * me->p_ship.s_maxwpntemp )
		minPhaserDistance = 6000.0;
	    else
		minPhaserDistance =
		    me->p_ship.s_phaserdamage * PHASEDIST / 100 *
			(1.0 - (borgAutoPhaserDist + 60.0) /
			 me->p_ship.s_phaserdamage);
	}
	else if ( botUniverse[0].players[strategy->player].armies_suspected )
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 60.0) /
			me->p_ship.s_phaserdamage);
	else
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 50.0) /
			me->p_ship.s_phaserdamage);

	point.x += minPhaserDistance * Cos[enemyDir];
	point.y += minPhaserDistance * Sin[enemyDir];
	point.distance = 0;
	
	endSpeed = dogfightSpeed;
    }
    else {
	endSpeed = dogfightSpeed;
	if ( ABS( strategy->x - me->p_x ) <
	    ABS( strategy->y - me->p_y ) ) {
	    point.x = strategy->x;
	    point.y = (strategy->y + me->p_y) / 2;
	}
	else {
	    point.x = (strategy->x + me->p_x) / 2;
	    point.y = strategy->y;
	}
    }
    
    /* now compute speed and angle */

    if ( !endSpeed && strategy->planet <= 0 && strategy->player <= 0 &&
	strategy->plan == ST_REPLENISH )
	*angle = me->p_dir;
    else
	*angle = botGetAngle( point.x, point.y );
    point.distance = 0.0;
    distance = botDistanceFromMe( &point );

    if (wantToOrbit)
	distance -= ENTORBDIST;
    distance = MAX( distance, 0 );
    tmpDistance = 2.0 * distance * me->p_ship.s_decint / (1000.0 * WARP1) +
	endSpeed * endSpeed + endSpeed;

    if (wantToOrbit)
	distance += ENTORBDIST;
    
    if ( tmpDistance > 0 )
	tmpDistance = sqrt( 1 + 4 * tmpDistance );
    else
	tmpDistance = 1;
    *speed = ( tmpDistance - 1.0 ) / 2.0;

    if ( *speed > maxSpeed )
	*speed = maxSpeed;
    if ( *speed < 0 )
      *speed = 0;
	
    /* now - try to see if any enemies are in my path - if so, try to
       avoid them, or at least slow down so I'm not an easy target -
       attempt 1 for seeing if people are in my path - calculate the
       next 10 seconds of positions, if I'm ever within 6000 (phaser
       range) units of the enemy, assume that we are on a collision
       course - if I ever get farther from him than the previous second,
       figure we are not on a collision course and go to the next enemy */
    
    timeToArrive = distance / (MAX(*speed,1) * WARP1) / 10;
    deltaX = WARP1 * *speed * Cos[*angle];
    deltaY = WARP1 * *speed * Sin[*angle];
    
    enemyNear = -1;
    enemyDistance = 100000.0;
    enemyTime = -10;
    
    engageEnemy = strategy->engageEnemy;
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !isAlive( &players[i] ) ||
	    friendlyPlayer(&players[i]) ||
	    strategy->player == i ||
	    !pointWithinSquare( &botUniverse[0].players[me->p_no].point,
			       &botUniverse[0].players[i].point,
			       15000.0 ) )
	    continue;
	
	enemySpeed = botUniverse[0].players[i].speed;
	enemyDir = botUniverse[0].players[i].dir;
	
	enemyPoint.x = botUniverse[0].players[i].point.x;
	enemyPoint.y = botUniverse[0].players[i].point.y;
	mePoint.x = me->p_x;
	mePoint.y = me->p_y;
	
	tmpDistance = previousDistance = enemyDistance2 = 
	    botDistanceFromMe( &botUniverse[0].players[i].point );
	
	if ( !timeToArrive && previousDistance > distance)
	    tmpDistance = 100000.0;
	
#if 0
	printf("%c%c distance is %f  (%d, %d)  (%d, %d)\n",
	       teamlet[players[i].p_team],
	       shipnos[i],
	       previousDistance,
	       enemyPoint.x,
	       enemyPoint.y,
	       mePoint.x,
	       mePoint.y );

	printf("enemySpeed = %d  enemyDir = %d\n",
	       enemySpeed, enemyDir );
#endif
	
	deltaEnemyX = WARP1 * enemySpeed * Cos[enemyDir];
	deltaEnemyY = WARP1 * enemySpeed * Sin[enemyDir];
	
	for (j=timeToArrive; j>0; --j) {
	    enemyPoint.x += deltaEnemyX;
	    enemyPoint.y += deltaEnemyY;
	    mePoint.x += deltaX;
	    mePoint.y += deltaY;
		
	    tmpDistance =
		hypot( (double) enemyPoint.x - mePoint.x,
		      (double) enemyPoint.y - mePoint.y );
	    
#if 0
	    printf("%c%c: %d distance is %f  (%d, %d)  (%d, %d)\n",
		   teamlet[players[i].p_team],
		   shipnos[i],
		   j,
		   tmpDistance,
		   enemyPoint.x,
		   enemyPoint.y,
		   mePoint.x,
		   mePoint.y );
#endif
	    
	    if ( tmpDistance > previousDistance || 
		tmpDistance < 8000 )
		break;
	    
	    previousDistance = tmpDistance;
	}

	if ( tmpDistance < 8000 ) {
	    numberOfIntercepts++;
#if 0
	    printf("%c%c: %c%c is close\n",
		   teamlet[me->p_team],
		   shipnos[me->p_no],
		   teamlet[players[i].p_team],
		   shipnos[i]);
#endif

	    if ( shipCloaked( &players[i] ) && me->p_armies )
		engageEnemy = 0;

	    if ( players[i].p_ship.s_type == STARBASE )
		engageEnemy = 0;

	    if ( j > enemyTime ||
		( j == enemyTime &&
		 enemyDistance2 < enemyDistance ) ) {
		enemyNear = i;
		enemyTime = j;
		enemyDistance = enemyDistance2;
	    }
	}
    }

    if ( enemyNear >= 0 && !shipCloaked( me ) ) {
#if 0
	printf("taking evasive action against %c%c\n\n",
	       teamlet[players[enemyNear].p_team],
	       shipnos[enemyNear]);
#endif

	wantToOrbit = 0;
	enemySpeed = botUniverse[0].players[enemyNear].speed;
	enemyDir = botUniverse[0].players[enemyNear].dir;
	
	tmpDistance = 
	    botDistanceFromMe( &botUniverse[0].players[enemyNear].point );
	
	timeToArrive = (tmpDistance / (1 + me->p_speed + enemySpeed)) / WARP1;
	timeToArrive -= 20;
	if ( timeToArrive < 5 )
	    timeToArrive = 5;
	
	point.x = botUniverse[0].players[enemyNear].point.x +
	    timeToArrive * enemySpeed * WARP1 * Cos[enemyDir];
	point.y = botUniverse[0].players[enemyNear].point.y +
	    timeToArrive * enemySpeed * WARP1 * Sin[enemyDir];
	
	if ( me->p_armies &&
	    (numberOfIntercepts > 1 ||
	     me->p_fuel < me->p_ship.s_maxfuel / 2 ||
	     me->p_damage) &&
	    me->p_ship.s_type != STARBASE ) {
#if 0
	    fprintf(stderr, "%c%c: number of intercepts = %d - avoiding %c%c\n",
		    teamlet[me->p_team],
		    shipnos[me->p_no],
		    numberOfIntercepts,
		    teamlet[players[enemyNear].p_team],
		    shipnos[enemyNear]);
#endif
	    engageEnemy = 0;
	}
    
	if ( shipCloaked( &players[enemyNear] ) && me->p_armies &&
	    me->p_ship.s_type != STARBASE )
	    engageEnemy = 0;
	
	if ( (me->p_armies || strategy->plan == ST_BOMB) &&
	    players[enemyNear].p_ship.s_phaserdamage >
	    me->p_ship.s_phaserdamage )
	    engageEnemy = 0;
	
	if (me->p_ship.s_type == STARBASE )
	    engageEnemy = 1;
	if ( me->p_ship.s_type == STARBASE ) {
	    if ( me->p_damage > .5 * me->p_ship.s_maxdamage ||
		me->p_wtemp > .75 * me->p_ship.s_maxwpntemp )
		minPhaserDistance = 8000.0;
	    else
		minPhaserDistance =
		    me->p_ship.s_phaserdamage * PHASEDIST / 100 *
			(1.0 - (borgAutoPhaserDist + 60.0) /
			 me->p_ship.s_phaserdamage);
	}
	else if ( me->p_armies ) {
	    if ( !engageEnemy )
		minPhaserDistance = 7000;
	    else
		minPhaserDistance =
		    me->p_ship.s_phaserdamage * PHASEDIST / 100 *
			(1.0 - ((double) borgAutoPhaserDist + 15.0) /
			 me->p_ship.s_phaserdamage);
	}
	else if ( botUniverse[0].players[enemyNear].armies_suspected )
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 50.0) /
		     me->p_ship.s_phaserdamage);
	else if ( strategy->plan == ST_ESCORT )
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 25.0) /
		     me->p_ship.s_phaserdamage);
	else if ( !engageEnemy )
	    minPhaserDistance = 7000;
	else
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 20.0) /
		     me->p_ship.s_phaserdamage);
	
	angle1 = botGetAngle( point.x, point.y );
	point.distance = 0;
	tmpDistance = botDistanceFromMe( &point );
	
	if ( tmpDistance <= minPhaserDistance ) {
	    *angle = NORMALIZE( 128 + angle1 );
	    point.x += minPhaserDistance * Cos[*angle];
	    point.y += minPhaserDistance * Sin[*angle];
	    point.distance = 0;
	    distance = botDistanceFromMe( &point );
	    if ( engageEnemy )
		endSpeed = dogfightSpeed;
	    else
		endSpeed = maxSpeed;
	}
	else {
	    angle2 = asin( minPhaserDistance / tmpDistance ) * 128/PI;
	    if ( angdist( *angle, angle1 ) < angle2 &&
		tmpDistance < distance ) {
		if ( angdist( *angle, NORMALIZE( angle1 + angle2 ) ) <
		    angdist( *angle, NORMALIZE( angle1 - angle2 ) ) ) {
		    *angle = NORMALIZE( angle1 + angle2 );
		    angle1 = NORMALIZE( 64 + angle1 + angle2 );
		}
		else {
		    *angle = NORMALIZE( angle1 - angle2 );
		    angle1 = NORMALIZE( 192 + angle1 - angle2 );
		}
		
		point.x += minPhaserDistance * Cos[ angle1 ];
		point.y += minPhaserDistance * Sin[ angle1 ];
		point.distance = 0;
		distance = botDistanceFromMe( &point );
		endSpeed = dogfightSpeed;
	    }
	}
    }

    if (wantToOrbit)
	distance -= ENTORBDIST;
    distance = MAX( distance, 0 );
    tmpDistance = 2.0 * distance * me->p_ship.s_decint / (1000.0 * WARP1) +
	endSpeed * endSpeed + endSpeed;

    if ( tmpDistance > 0 )
	tmpDistance = sqrt( 1 + 4 * tmpDistance );
    else
	tmpDistance = 1;
    *speed = ( tmpDistance - 1.0 ) / 2.0;
    
#if 1
    enemyTorpTime = 1000000;
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !isAlive( &players[i] ) ||
	    friendlyPlayer( &players[i] ) )
	    continue;

	if ( !pointWithinSquare( &botUniverse[0].players[i].point,
				&botUniverse[0].players[me->p_no].point,
				12000 ) )
	    continue;

	j = botEnemyTorpMe( &players[i], *speed, *angle );
	if ( j < enemyTorpTime )
	    enemyTorpTime = j;
    }

    enemyTorpTime -= 15; 
    if (enemyTorpTime < 0)
	enemyTorpTime = 0;
    j = dogfightSpeed + enemyTorpTime /
	( 1000.0 / me->p_ship.s_decint );
    *speed = MIN( *speed, j );

#else
    enemyIsTarget = 0;
    for (i=MAXPLAYER-1; i>=0 && !enemyIsTarget; --i) {
	if ( !isAlive( &players[i] ) || friendlyPlayer( &players[i] ) )
	    continue;

	if ( pointWithinSquare( &botUniverse[0].players[i].point,
			       &botUniverse[0].players[me->p_no].point,
			       12000 ) &&
	    angdist( me->p_dir,
		    botGetAngle( botUniverse[0].players[i].point.x,
				botUniverse[0].players[i].point.y ) ) < 64 ) {
	    enemyIsTarget = 1;
	    continue;
	}
	
	if ( pointWithinSquare( &botUniverse[0].players[i].point,
			       &botUniverse[0].players[me->p_no].point,
			       6000 ) &&
	    angdist( me->p_dir,
		    botGetAngle( botUniverse[0].players[i].point.x,
				botUniverse[0].players[i].point.y ) ) < 96 )
	    enemyIsTarget = 1;
    }

    if (enemyIsTarget && distance < 15000) {
	if ( distance < 5000 )
	    *speed = MIN( *speed, dogfightSpeed );
	else if ( distance < 10000 )
	    *speed = MIN( *speed, dogfightSpeed - 4 + distance / 1000);
	*speed = MAX( *speed, dogfightSpeed );
    }
#endif

#if 1
    /* My new dogfighting code */
    if ( newDogfightCode ) {
      int dp;
      int turnrate;
      int distance;
      int tmpAngle;
      int currentDistance;
      double desSpeed;
      int numberOfTicks;
      double tmpDistance;
      int tmpSpeed;
#if 0
      enemyTorpTime = 1000000;
      for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !isAlive( &players[i] ) ||
	     friendlyPlayer( &players[i] ) )
	  continue;
	
	j = botEnemyTorpMe( &players[i], me->p_speed, me->p_dir );
	if ( j < enemyTorpTime )
	  enemyTorpTime = j;
      }

      enemyTorpTime -= 15; 
      if (enemyTorpTime < 0)
	enemyTorpTime = 0;
      j = dogfightSpeed + enemyTorpTime /
	( 1000.0 / me->p_ship.s_decint );
      *speed = MIN( *speed, j );
      *angle = botGetAngle( point.x, point.y );
#endif
      currentDistance = 
	hypot( (double) players[strategy->player].p_x - me->p_x,
	       (double) players[strategy->player].p_y - me->p_y );

      for ( i=dogfightSpeed+1; i<maxSpeed; i++ ) {
	tmpDistance = botMinimumDistance( strategy->player, i, dogfightSpeed, botTempVariable );
	if ( tmpDistance > currentDistance ) {
	  --i;
	  break;
	}
      }
      dp = i;
      tmpSpeed = i;
      if ( me->p_speed < tmpSpeed )
	tmpSpeed = me->p_speed;
      if ( dogfightSpeed > tmpSpeed )
	tmpSpeed = dogfightSpeed;
      
      distance = botMinimumDistance( strategy->player, tmpSpeed, dogfightSpeed, botTempVariable );

      tmpAngle = NORMALIZE( 128 + botGetAngle( players[strategy->player].p_x,
					       players[strategy->player].p_y ) );
      /*
	point.x = players[strategy->player].p_x + distance * Cos[tmpAngle];
      point.y = players[strategy->player].p_y + distance * Sin[tmpAngle];
      */
      point.x = players[strategy->player].p_x + distance * Cos[players[strategy->player].p_dir];
      point.y = players[strategy->player].p_y + distance * Sin[players[strategy->player].p_dir];

      *speed = dp;
      *angle = botGetAngle( point.x, point.y );
    }
#endif


    /* make sure that I'm not going too fast for the direction I'd like to go in
       e.g. I can't turn too well at max speed */
    i = angdist( *angle, me->p_dir );
    if ( i >= 16 ) {
	turns = 16 * me->p_ship.s_turns / (1000 * i);
	i = 0;
	
	while (turns > 1) {
	    i++;
	    turns = turns >> 1;
	}
	if (i > maxSpeed )
	    i = maxSpeed;

	if (*speed > i)
	    *speed = i;
    }

    if ( me->p_etemp > me->p_ship.s_maxegntemp *.85 )
      *speed = dogfightSpeed;
    
    if ( *speed > maxSpeed )
	*speed = maxSpeed;
    if ( *speed < 0 )
      *speed = 0;
}

void botComputeSpeedAngle( BOT_STRATEGY *strategy, int *speed,
			  int *angle )
{
    BOT_POINT point, enemyPoint, mePoint;
    int endSpeed;
    double distance;
    int maxSpeed;
    int turns;
    int deltaY;
    int deltaX;
    int deltaEnemyX;
    int deltaEnemyY;
    int dogfightSpeed;
    int i,j;
    double enemyDistance, enemyDistance2;
    double tmpDistance, previousDistance;
    unsigned char angle1, angle2;
    int enemyNear;
    int engageEnemy = 1;
    int enemySpeed;
    int enemyDir;
    int timeToArrive;
    int minPhaserDistance;
    int numberOfIntercepts = 0;
    int enemyTime;
    int wantToOrbit = 0;
    int enemyTorpTime;
    int newDogfightCode = 0;
    int dogfightPlayer = -1;
    
    MZERO( &point, sizeof( BOT_POINT ) );
    maxSpeed = botMaxSpeed();

    turns = me->p_ship.s_turns / 8500;
    dogfightSpeed = 0;

    while (turns > 1) {
	dogfightSpeed++;
	turns = turns >> 1;
    }

    /* Turn rates: 128 85 42 21 10 5 2 1 0 0 */
    
    if (dogfightSpeed > maxSpeed )
	dogfightSpeed = maxSpeed;

    if ( strategy->planet >= 0 &&
	 strategy->planet < MAXPLANETS &&
	strategy->player >= 0 &&
	strategy->player < MAXPLAYER ) {
      /* I don't know what this is */
      point.x = planets[strategy->planet].pl_x;
      point.y = planets[strategy->planet].pl_y;
      endSpeed = dogfightSpeed;
    }
    else if ( strategy->planet >= 0 && strategy->planet < MAXPLANETS) {
	point.x = planets[strategy->planet].pl_x;
	point.y = planets[strategy->planet].pl_y;
	endSpeed = 2;
	wantToOrbit = 1;
	engageEnemy = !me->p_armies;
    }
    else if ( strategy->player >= 0 && strategy->player < MAXPLAYER &&
	     strategy->plan == ST_REPLENISH ) {
	point.x = players[strategy->player].p_x;
	point.y = players[strategy->player].p_y;
	endSpeed = 4;
	engageEnemy = 0;
    }
    else if ( strategy->player < 0 && strategy->planet < 0 &&
	     strategy->plan == ST_REPLENISH ) {
	point.x = players[me->p_no].p_x;
	point.y = players[me->p_no].p_y;
	endSpeed = 0;
	engageEnemy = 0;
    }
    else if ( strategy->player >= 0 && strategy->player < MAXPLAYER &&
	     strategy->plan == ST_OGG ) {
      /* Normal dogfighting calculations */
      newDogfightCode = 1;
      dogfightPlayer = strategy->player;
	enemySpeed = botUniverse[0].players[strategy->player].speed;
	enemyDir = botUniverse[0].players[strategy->player].dir;

	distance = 
	  botDistanceFromMe( &botUniverse[0].players[strategy->player].point );

	timeToArrive = distance / (1 + me->p_speed + enemySpeed) / WARP1;
	timeToArrive -= 20;
	if ( timeToArrive < 5 )
	    timeToArrive = 5;

	point.x = botUniverse[0].players[strategy->player].point.x +
	    timeToArrive * enemySpeed * WARP1 * Cos[enemyDir];
	point.y = botUniverse[0].players[strategy->player].point.y +
	    timeToArrive * enemySpeed * WARP1 * Sin[enemyDir];
	endSpeed = dogfightSpeed;
    }
    else if ( strategy->player >= 0 && strategy->player < MAXPLAYER &&
	     strategy->plan == ST_ESCORT ) {
	/* Try to position myself between my teammate and the enemy
	   homeworld */
	enemySpeed = botUniverse[0].players[strategy->player].speed;
	enemyDir = botUniverse[0].players[strategy->player].dir;

	distance = 
	  botDistanceFromMe( &botUniverse[0].players[strategy->player].point );

	timeToArrive = distance / (1 + me->p_speed + enemySpeed) / WARP1;
	timeToArrive -= 20;
	if ( timeToArrive < 5 )
	    timeToArrive = 5;

	point.x = botUniverse[0].players[strategy->player].point.x +
	    timeToArrive * enemySpeed * WARP1 * Cos[enemyDir];
	point.y = botUniverse[0].players[strategy->player].point.y +
	    timeToArrive * enemySpeed * WARP1 * Sin[enemyDir];

	enemyDir =
	    ( (unsigned char)
	     (atan2((double) botUniverse[0].players[strategy->escortPlayer].point.x - botUniverse[0].players[strategy->player].point.x,
		    (double) botUniverse[0].players[strategy->escortPlayer].point.y - botUniverse[0].players[strategy->escortPlayer].point.y) / PI * 128) );
	
	if ( me->p_ship.s_type == STARBASE ) {
	    if ( me->p_damage > .6 * me->p_ship.s_maxdamage ||
		me->p_wtemp > .75 * me->p_ship.s_maxwpntemp )
		minPhaserDistance = 6000.0;
	    else
		minPhaserDistance =
		    me->p_ship.s_phaserdamage * PHASEDIST / 100 *
			(1.0 - (borgAutoPhaserDist + 60.0) /
			 me->p_ship.s_phaserdamage);
	}
	else if ( botUniverse[0].players[strategy->player].armies_suspected )
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 60.0) /
			me->p_ship.s_phaserdamage);
	else
	    minPhaserDistance =
		me->p_ship.s_phaserdamage * PHASEDIST / 100 *
		    (1.0 - (borgAutoPhaserDist + 50.0) /
			me->p_ship.s_phaserdamage);

	point.x += minPhaserDistance * Cos[enemyDir];
	point.y += minPhaserDistance * Sin[enemyDir];
	point.distance = 0;
	
	endSpeed = dogfightSpeed;
    }
    else {
	endSpeed = dogfightSpeed;
	if ( ABS( strategy->x - me->p_x ) <
	    ABS( strategy->y - me->p_y ) ) {
	    point.x = strategy->x;
	    point.y = (strategy->y + me->p_y) / 2;
	}
	else {
	    point.x = (strategy->x + me->p_x) / 2;
	    point.y = strategy->y;
	}
    }
    
    /* now compute speed and angle */

    if ( !endSpeed && strategy->planet <= 0 && strategy->player <= 0 &&
	strategy->plan == ST_REPLENISH )
	*angle = me->p_dir;
    else
	*angle = botGetAngle( point.x, point.y );
    point.distance = 0.0;
    distance = botDistanceFromMe( &point );

    if (wantToOrbit)
	distance -= ENTORBDIST;
    distance = MAX( distance, 0 );
    tmpDistance = 2.0 * distance * me->p_ship.s_decint / (1000.0 * WARP1) +
	endSpeed * endSpeed + endSpeed;

    if (wantToOrbit)
	distance += ENTORBDIST;
    
    if ( tmpDistance > 0 )
	tmpDistance = sqrt( 1 + 4 * tmpDistance );
    else
	tmpDistance = 1;
    *speed = ( tmpDistance - 1.0 ) / 2.0;

    if ( *speed > maxSpeed )
	*speed = maxSpeed;
    if ( *speed < 0 )
      *speed = 0;
	
    /* now - try to see if any enemies can hit me with torps - if so,
       do the appropriate dogfighting procedures */

    distance = botDistanceFromMe( &point );
    timeToArrive = distance / MAX(1, *speed ) / WARP1;
    
    enemyTorpTime = timeToArrive;
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !isAlive( &players[i] ) ||
	    friendlyPlayer(&players[i]) ||
	    strategy->player == i )
	    continue;
	    
	j = botEnemyTorpMe( &players[i], *speed, *angle );
	if ( j < enemyTorpTime ) {
	  enemyTorpTime = j;
	  dogfightPlayer = i;
	}
    }

    if ( dogfightPlayer >= 0 ) {
      int dp;
      int turnrate;
      int distance;
      int tmpAngle;
      int currentDistance;
      double desSpeed;
      int numberOfTicks;
      double tmpDistance;
      int tmpSpeed;
      int turnRadius = botTempVariable;

      turnRadius += borgDelay / 10;
      
      if ( !engageEnemy ) {
	turnRadius += 100;
      }
      
      if ( botUniverse[0].players[dogfightPlayer].armies_suspected ) {
	turnRadius /= 2;
      }

      currentDistance = 
	hypot( (double) players[dogfightPlayer].p_x - me->p_x,
	       (double) players[dogfightPlayer].p_y - me->p_y );

      for ( i=dogfightSpeed+1; i<maxSpeed; i++ ) {
	tmpDistance = botMinimumDistance( dogfightPlayer, i, dogfightSpeed, turnRadius );
	if ( tmpDistance > currentDistance ) {
	  --i;
	  break;
	}
      }
      dp = i;
      tmpSpeed = i;
      if ( me->p_speed < tmpSpeed )
	tmpSpeed = me->p_speed;
      if ( dogfightSpeed > tmpSpeed )
	tmpSpeed = dogfightSpeed;
      
      distance = botMinimumDistance( dogfightPlayer, tmpSpeed, dogfightSpeed, turnRadius );

      tmpAngle = NORMALIZE( 128 + botGetAngle( players[dogfightPlayer].p_x,
					       players[dogfightPlayer].p_y ) );

      if ( engageEnemy ) {
	tmpAngle = players[dogfightPlayer].p_dir;
      }
      else {
	tmpAngle = NORMALIZE( ( tmpAngle + *angle ) / 2 );
      }

      point.x = players[dogfightPlayer].p_x + distance * Cos[tmpAngle];
      point.y = players[dogfightPlayer].p_y + distance * Sin[tmpAngle];

      *speed = dp;
      if (currentDistance < botMinimumDistance( dogfightPlayer, dogfightSpeed, dogfightSpeed, turnRadius ) ) {
	*angle = NORMALIZE( 128 + botGetAngle( players[dogfightPlayer].p_x,
					       players[dogfightPlayer].p_y ) );
      }
    }
      
    /* make sure that I'm not going too fast for the direction I'd like to go in
       e.g. I can't turn too well at max speed */
    i = angdist( *angle, me->p_dir );
    if ( i >= 16 ) {
	turns = 16 * me->p_ship.s_turns / (1000 * i);
	i = 0;
	
	while (turns > 1) {
	    i++;
	    turns = turns >> 1;
	}
	if (i > maxSpeed )
	    i = maxSpeed;

	if (*speed > i)
	    *speed = i;
    }

    if ( me->p_etemp > me->p_ship.s_maxegntemp *.85 )
      *speed = dogfightSpeed;
    
    if ( *speed > maxSpeed )
	*speed = maxSpeed;

    if ( *speed < 0 )
      *speed = 0;
}



int botDecideDirection( BOT_STRATEGY *strategy,
		       unsigned char *direction )
{
    BOT_DIRECTION dodgeDirections[BOT_MAXDODGEANGLES];
    int numberOfDirections;
    int bestCourse;
    int thisAngle;
    int bestSpeed;
    int bestDirection;
    int thisSpeed;
    int i;
    static int damage=0;
    int desiredAngle;
    int desiredSpeed;
    struct obtype *gettarget(), *target;
    int needToDodge=0;
    int deltaX, deltaY, tmpx, tmpy;
    int avoidDistance;
    int torpRange;
    int maxTurn;
    int oldDeltaDir;
    int newDeltaDir;
    int newCourse = 0;
    int wantToOrbit = 0;
    int wantToTractor = -1;
    int wantToPressor = -1;
    int usePressors;
    int desiredTractor;
    int desiredPressor;
    int numberOfExpectedUpdates;
    
    if ( !isAlive( me ) )
	return 0;
    
    avoidDistance = 2 * EXPDIST;
    torpRange = 7500;

    botHandleTractorPressor( &desiredTractor, &desiredPressor );
    
    for (i=MAXPLAYER*MAXTORP-1; i>=0 && !needToDodge; --i) {
	if ( liveTorp( &torps[i] ) &&
	    (!friendlyPlayer( &players[i/MAXTORP] ) ||
	     !friendlyTorp( &torps[i] )) &&
	    pointWithinSquare( &botUniverse[0].players[me->p_no].point,
			      &botUniverse[0].torps[i].point,
			      torpRange ) ) {

	    deltaX = botUniverse[0].torps[i].point.x -
		botUniverse[1].torps[i].point.x;
	    deltaY = botUniverse[0].torps[i].point.y -
		 botUniverse[1].torps[i].point.y;

	    tmpx = botUniverse[0].torps[i].point.x - me->p_x;
	    tmpy = botUniverse[0].torps[i].point.y - me->p_y;
	    
	    if ( ((tmpx > avoidDistance && deltaX > 0) ||
		  (tmpx < -avoidDistance && deltaX < 0) )
		&& ((tmpy > avoidDistance && deltaY > 0) ||
		    (tmpy < avoidDistance && deltaY < 0)) )
	    {
		continue;
	    }
	    else
		needToDodge++;
	}
    }
    for (i=MAXPLASMA*MAXPLAYER-1; i>=0 && !needToDodge; --i) {
	if ( plasmatorps[i].pt_status == TMOVE &&
	    (!friendlyPlayer( &players[i/MAXTORP] ) ||
	     !friendlyPlasmaTorp( &plasmatorps[i] ) ) &&
	    pointWithinSquare( &botUniverse[0].players[me->p_no].point,
			      &botUniverse[0].plasmas[i].point,
			      torpRange ) ) {
	    needToDodge++;
	}
    }

    if (needToDodge && shipOrbitting( me ) ) {
	target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			   me->p_y * WINSIDE/GWIDTH, TARG_PLANET);

	if ( !friendlyPlanet( &planets[target->o_num] ) ||
	    (me->p_armies && !planets[target->o_num].pl_armies) )
	    needToDodge = 0;

	if ( me->p_flags & PFBEAMDOWN )
	    needToDodge = 0;
    }

    if ( needToDodge ) {
#if 0
	if ( botPacketReceived % 2)
	    return damage;
#endif
	botComputeSpeedAngle( strategy, &desiredSpeed, &desiredAngle );
	if (!botDodgeTorps(dodgeDirections, &numberOfDirections)) {
	    damage = 0;
	    return damage;
	}

	usePressors = 0;
	for (i=numberOfDirections-1; i>=0 && !usePressors; --i) {
	    if ( dodgeDirections[i].index < 0 )
		continue;
	    
	    if ( desiredPressor >= 0 &&
		dodgeDirections[i].pressorEnemy == desiredPressor )
		usePressors = 1;
	    if ( desiredTractor >= 0 &&
		dodgeDirections[i].tractorEnemy == desiredTractor )
		usePressors = 1;
	}
	if (!usePressors && desiredPressor < 0 && desiredTractor < 0) {
	    for (i=numberOfDirections-1; i>=0 && !usePressors; --i) {
		if ( dodgeDirections[i].index < 0 )
		    continue;

		if ( dodgeDirections[i].pressorEnemy < 0 &&
		    dodgeDirections[i].tractorEnemy < 0 )
		    usePressors = 1;
	    }
	}

	bestDirection = -1;
	bestCourse = 10000;
	bestSpeed = 10000;

	for (i=numberOfDirections-1; i>=0; --i) {
	    if ( dodgeDirections[i].index < 0 )
		continue;

	    if ( usePressors &&
		 ( (desiredPressor >= 0 && desiredPressor !=
		    dodgeDirections[i].pressorEnemy ) ||
		  (desiredTractor >= 0 && desiredTractor !=
		   dodgeDirections[i].tractorEnemy ) ) )
		continue;

	    if ( usePressors && desiredPressor < 0 && desiredTractor < 0 &&
		(dodgeDirections[i].tractorEnemy >=0 ||
		 dodgeDirections[i].pressorEnemy >=0 ) )
		continue;
		
	    thisAngle = angdist( desiredAngle,
				NORMALIZE( me->p_dir +
					  dodgeDirections[i].deltaDir));
	    thisSpeed = ABS(dodgeDirections[i].speed - desiredSpeed);
	    
	    if ( thisAngle < bestCourse ||
		( thisAngle == bestCourse && thisSpeed <= bestSpeed ) ) {
	      if ( bestDirection < 0 ||
		   ( ABS(dodgeDirections[i].speed - botDesiredSpeed) <=
		     ABS(dodgeDirections[bestDirection].speed - botDesiredSpeed) &&
		     angdist( NORMALIZE( me->p_dir +
					 dodgeDirections[i].deltaDir),
			      botDesiredCourse ) <=
		     angdist( NORMALIZE( me->p_dir +
					 dodgeDirections[bestDirection].deltaDir),
			      botDesiredCourse ) ) ) {
		bestCourse = thisAngle;
		bestSpeed = thisSpeed;
		bestDirection = i;
	      }
	    }
	}

	damage = dodgeDirections[bestDirection].damage;
#ifdef TORPDEBUG
	printf("Dodging to %02d: DodgeDir=%d\tSpeed=%d\tDamage=%d\n",
	       bestDirection, (int)
	       dodgeDirections[bestDirection].deltaDir,
	       dodgeDirections[bestDirection].speed,
	       dodgeDirections[bestDirection].damage);
	printf("my dir is %d, my spd is %d, new crse is %d descrse is %d desspd is %d\n",
	       me->p_dir,
	       me->p_speed,
	       NORMALIZE( me->p_dir + dodgeDirections[bestDirection].deltaDir),
	       desiredAngle,
	       desiredSpeed );
#endif

	if ( strategy->planet >=0 && strategy->planet < MAXPLANETS &&
	    !damage && bestCourse < 24 &&
	    botDistanceFromMe( &botUniverse[0].planets[strategy->planet].point )
	    < ENTORBDIST ) {
	    wantToOrbit = 1;
	}
	else {
	    desiredAngle = NORMALIZE( me->p_dir +
				  dodgeDirections[bestDirection].deltaDir);
	    desiredSpeed = dodgeDirections[bestDirection].speed;

	    wantToPressor = dodgeDirections[bestDirection].pressorEnemy;
	    wantToTractor = dodgeDirections[bestDirection].tractorEnemy;
	    
	    *direction = desiredAngle;
	    newCourse = 1;
	}
    }
    else {
	wantToTractor = desiredTractor;
	wantToPressor = desiredPressor;
	damage = 0;
	botComputeSpeedAngle( strategy, &desiredSpeed, &desiredAngle );

	if ( strategy->planet >=0 && strategy->planet < MAXPLANETS &&
	    (strategy->player < 0 || strategy->player > MAXPLAYER)) {
	    if ( !shipOrbitting( me ) ) {
		if (botDistanceFromMe( &botUniverse[0].planets[strategy->planet].point ) < ENTORBDIST ) {
		    wantToOrbit = 2;
		}
		else {
		    newCourse = 2;
		}
	    }
	    else {
		target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
				   me->p_y * WINSIDE/GWIDTH, TARG_PLANET);
		if ( target->o_num != strategy->planet ) {
		    newCourse = 3;
		}
	    }
	}
	else if ( strategy->player >=0 && strategy->player < MAXPLAYER &&
	    players[strategy->player].p_ship.s_type == STARBASE &&
	    friendlyPlayer( &players[strategy->player] ) ) {
	    if ( !(me->p_flags & PFDOCK) ) {
		if (pointWithinSquare( &botUniverse[0].players[me->p_no].point,
			     &botUniverse[0].players[ strategy->player].point,
				      2000.0 ) ) {
		    if ( !(me->p_flags & PFPLOCK) )
			sendPlaylockReq( strategy->player );
		    if (me->p_speed <= 2) {
			set_bot_speed( 3 );
		    }
		}
		else {
		    newCourse = 4;
		}
	    }
	}	    
	else if ( desiredSpeed == 0 && !(me->p_flags & PFREPAIR) ) {
	    sendRepairReq(1);
	    botDesiredSpeed = 0;
	}
	else {
	    newCourse = 5;
	}
	*direction = desiredAngle;
    }

    if ( newCourse ) {
	if ( desiredAngle != botDesiredCourse ) {
	    numberOfExpectedUpdates = 2;
	    maxTurn = botMaxTurn( me->p_speed ) *
		(numberOfExpectedUpdates + borgDelay / 100);

	    newDeltaDir = angdist( desiredAngle, me->p_dir );
	    oldDeltaDir = angdist( botDesiredCourse, me->p_dir );
	    if ( NORMALIZE( me->p_dir - newDeltaDir ) == desiredAngle )
		newDeltaDir *= -1;
	    if ( NORMALIZE( me->p_dir - oldDeltaDir ) == botDesiredCourse)
		oldDeltaDir *= -1;

	    if ( newCourse == 1 || ABS( newDeltaDir ) >=8 ) {
		if ( ABS(newDeltaDir) <= maxTurn ||
		    ABS(oldDeltaDir) <= maxTurn ||
		    newDeltaDir * oldDeltaDir < 0 ) {
		  if ( angdist( botDesiredCourse, desiredAngle ) > 2 ) {
		    set_course( desiredAngle );
		    botDesiredCourse = desiredAngle;
		  }
		}
	    }
	}
	
	if ( desiredSpeed != botDesiredSpeed ) {
	  if ( ( botDesiredSpeed > me->p_speed && desiredSpeed <= me->p_speed ) ||
	       ( botDesiredSpeed < me->p_speed && desiredSpeed <= me->p_speed ) ||
	       botDesiredSpeed == me->p_speed ) {
	    set_bot_speed( desiredSpeed );
	  }
	}
    }

    if ( wantToOrbit &&
	strategy->planet >= 0 &&
	strategy->planet < MAXPLANETS) {

      if ( botDesiredSpeed != 2 || me->p_speed > 2) {
	set_bot_speed( 2 );
      }

	if ( me->p_ship.s_type != STARBASE ||
	    myPlanet( &planets[strategy->planet] ) ) {
	    sendOrbitReq( 1 );
	}
    }

    if ( wantToPressor >= 0) {
	if ( !(me->p_flags & PFPRESS) ||
	    me->p_tractor != wantToPressor ) {
	    me->p_tractor = wantToPressor;
	    sendRepressReq( 1, wantToPressor );
	}
    }
    else if (wantToTractor >= 0) {
	if ( !(me->p_flags & PFTRACT) ||
	    me->p_tractor != wantToTractor ) {
	    me->p_tractor = wantToTractor;
	    sendTractorReq( 1, wantToTractor );
	}
    }
    else if (me->p_flags & (PFPRESS|PFTRACT) ) {
	me->p_tractor = -1;
	sendRepressReq( 0, me->p_no );
    }

    return damage;
}

void botHandleDets( int damage )
{
    int i,j,k,l,m;
    double torpDistance;
    int torpDamage;
    int deltaX, deltaY;
    int idx;
    int maxDamage;
    int mustDet = 0;
    int teammateOrbitting = 0;
    int factor;
    int myCurrentDir;
    int mySubSpeed;
    int speed;
    int tmpx, tmpy;
    static int detDistance = BOTDETDIST * BOTDETDIST;
    BOT_POINT mePoint, torpPoint, meDetPoint;
    
    if ( !isAlive( me ) )
	return;

    if ( !me->p_armies || me->p_ship.s_type == STARBASE ) {
	for (i=MAXPLAYER-1; i>=0 && !teammateOrbitting; --i ) {
	    if ( !isAlive( &players[i] ) || myPlayer( &players[i] ) ||
		!friendlyPlayer( &players[i] ) )
		continue;
	    
	    if ( players[i].p_speed && !shipCloaked( &players[i] ) )
		continue;
	    
	    if ( !pointWithinSquare( &botUniverse[0].players[me->p_no].point,
				    &botUniverse[0].players[i].point,
				    8000.0 ) )
		continue;
	    
	    for (j=MAXPLANETS-1; j>=0 && !teammateOrbitting; --j)
		if (pointWithinSquare( &botUniverse[0].players[i].point,
				      &botUniverse[0].planets[j].point,
				      2000.0 ) )
		    teammateOrbitting = 1;
	}
    }

    if ( damage < 10 && !teammateOrbitting )
	return;

    /* this will be code to handle the fact that I'm experiencing lag -
       basically, this means that if I have 200ms lag, I'm really 2 ticks
       behind what I'm seeing now - so... we do the following...
       a) I know what speed and direction I last requested to go in
          (botDesiredSpeed and botDesiredCourse)
       b) Using this, we project out the ticks required by my lag
       */
    mePoint.x = botUniverse[0].players[me->p_no].point.x;
    mePoint.y = botUniverse[0].players[me->p_no].point.y;
    if (botUniverse[0].players[me->p_no].point.time !=
	botUniverse[1].players[me->p_no].point.time )
    {
	mePoint.x += (borgDelay % 100) / 100.0 *
	    (botUniverse[0].players[me->p_no].point.x -
	     botUniverse[1].players[me->p_no].point.x ) /
		 (botUniverse[0].players[me->p_no].point.time -
		  botUniverse[1].players[me->p_no].point.time );
	mePoint.y += (borgDelay % 100) / 100.0 *
	    (botUniverse[0].players[me->p_no].point.y -
	     botUniverse[1].players[me->p_no].point.y ) /
		 (botUniverse[0].players[me->p_no].point.time -
		  botUniverse[1].players[me->p_no].point.time );
    }

    myCurrentDir = me->p_dir;
    mySubSpeed = botSubSpeed;
    speed = me->p_speed;
    meDetPoint = mePoint;
    for (i=borgDelay/100; i>=0; --i) {
	factor = botMaxTurn( speed );

	j = angdist( myCurrentDir, botDesiredCourse );
	if ( j > factor ) {
	    if ( NORMALIZE( j + myCurrentDir ) == botDesiredCourse )
		myCurrentDir = NORMALIZE( myCurrentDir + factor );
	    else
		myCurrentDir = NORMALIZE( myCurrentDir - factor );
	}
	else
	    myCurrentDir = botDesiredCourse;

	if ( botDesiredSpeed > speed )
	    mySubSpeed += me->p_ship.s_accint;
	if ( botDesiredSpeed < speed )
	    mySubSpeed -= me->p_ship.s_decint;

	speed = mySubSpeed / 1000;

	mePoint.x += WARP1 * speed * Cos[myCurrentDir];
	mePoint.y += WARP1 * speed * Sin[myCurrentDir];
	if (i>0) {
	    meDetPoint.x = mePoint.x;
	    meDetPoint.y = mePoint.y;
	}
    }

    /* calculate how much a det will damage me */
    torpDamage = 0;
    for (i=MAXPLAYER-1; i>=0 && !mustDet && torpDamage < damage; --i) {
	for (j=MAXTORP-1; j>=0 && !mustDet && torpDamage < damage; --j) {
	    idx = i * MAXTORP + j;
	    if ( liveTorp( &torps[idx] ) &&
		( !friendlyPlayer( &players[i] ) ||
		 !friendlyTorp( &torps[idx] ) ) &&
		pointWithinSquare( &botUniverse[0].torps[idx].point,
				  &meDetPoint,
				  BOTDETDIST + 1000 + 10 * borgDelay ) )
	    {
		if ( !botCurrentPosition( &torpPoint,
					 &botUniverse[0].torps[idx].point,
					 &botUniverse[1].torps[idx].point)) {
		    torpPoint.x = botUniverse[0].torps[idx].point.x;
		    torpPoint.y = botUniverse[0].torps[idx].point.y;
		}

		tmpx = meDetPoint.x - torpPoint.x;
		tmpy = meDetPoint.y - torpPoint.y;
		if ( !pointWithinSquare( &torpPoint,
					&meDetPoint,
					BOTDETDIST ) ||
		    tmpx * tmpx + tmpy * tmpy > detDistance )
		    continue;

		tmpx = mePoint.x - torpPoint.x;
		tmpy = mePoint.y - torpPoint.y;
		torpDistance = sqrt( (double) (tmpx*tmpx + tmpy*tmpy) );

		if ( torpDistance < EXPDIST )
		    torpDamage += players[i].p_ship.s_torpdamage;
		else
		    torpDamage += players[i].p_ship.s_torpdamage *
			(DAMDIST - torpDistance) / (DAMDIST - EXPDIST);

		if (teammateOrbitting && !mustDet ) {
		    deltaX = 
			(botUniverse[0].torps[idx].point.x -
			 botUniverse[1].torps[idx].point.x) /
			     (botUniverse[0].torps[idx].point.time -
			      botUniverse[1].torps[idx].point.time);
		    deltaY = 
			(botUniverse[0].torps[idx].point.y -
			 botUniverse[1].torps[idx].point.y) /
			     (botUniverse[0].torps[idx].point.time -
			      botUniverse[1].torps[idx].point.time);

		    for (k=50; k>0 && !mustDet; --k) {
			for (l=MAXPLANETS-1; l>=0; --l) {
			    if (pointWithinSquare( &torpPoint,
						  &botUniverse[0].planets[l].point,
						  2000.0))
				break;
			}
			torpPoint.x += deltaX;
			torpPoint.y += deltaY;
			if (l < 0)
			     continue;

			for (m=MAXPLAYER-1; m>=0 && !mustDet; --m ) {
			    if ( !isAlive( &players[m] ) ||
				myPlayer( &players[m] ) ||
				!friendlyPlayer( &players[m] ) )
				continue;

			    if (pointWithinSquare( &botUniverse[0].players[m].point,
						  &botUniverse[0].planets[l].point,
						  3000.0 ) )
				mustDet = 1;
			}
			break;
		    }
		}
	    }
	}
    }

    if ( mustDet ) {
	sendDetonateReq();
	return;
    }
    
    if ( torpDamage + 10 < damage && torpDamage > 0 ) {
	maxDamage = 0;
	if ( me->p_flags & PFSHIELD )
	    maxDamage += me->p_shield;

	maxDamage += me->p_ship.s_maxdamage - me->p_damage - 15;

	if ( torpDamage <= maxDamage ) {
#if 0
	    fprintf(stderr, "\n%d detted torps for damage of %d  torp damage is %d\n",
		    numberOfDettedTorps, torpDamage, damage );
#endif
	    sendDetonateReq();
	}
    }
}

void botHandleWarStatus()
{
    int enemyTeam;
    int i;

    if ( !me->p_speed &&
	status->tourn &&
	!(me->p_flags & PFRED) ) {
	enemyTeam = botEnemyTeam();
	if (me->p_hostile != enemyTeam &&
	    me->p_swar != enemyTeam ) {
	    sendWarReq( enemyTeam );
	}
    }
    else if (!me->p_speed &&
	     !status->tourn &&
	     !(me->p_flags & PFRED) ) {
	enemyTeam = 0;
	for (i=0; i<MAXPLAYER; i++) {
	    if ( players[i].p_status != PFREE &&
		players[i].p_team != me->p_team )
		enemyTeam |= players[i].p_team;
	}
	enemyTeam &= ~(me->p_team);

	if ( (me->p_hostile|me->p_swar) != enemyTeam)
	    sendWarReq( enemyTeam );
    }
}	

#if 0
void botHandleTractorPressor( unsigned char direction, int damage )
{
    int maxturn;
    unsigned char deltaDir;
    unsigned char pressorDir;
    unsigned char tractorDir;
    int i,j;
    double tractorRange;
    unsigned char thisDir;
    unsigned char bestPressorDir;
    unsigned char bestTractorDir;
    int bestPressorEnemy;
    int bestTractorEnemy;
    double enemyDistance;
    double distance;
    struct obtype *gettarget(), *target;
    int angle;
    
    if ( INVISIBLE(me) || !isAlive(me)) {
	return;
    }

    if ( botPacketReceived % 3 )
	return;
    
    tractorRange = TRACTDIST * me->p_ship.s_tractrng - 100.0;

    /* Make sure that enemy player will not blow up on me */
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !friendlyPlayer( &players[i]) &&
	    isAlive( &players[i] ) &&
	    !INVISIBLE( &players[i] ) &&
	    pointWithinSquare( &botUniverse[0].players[i].point,
			      &botUniverse[0].players[me->p_no].point,
			      SHIPDAMDIST) &&
	    botDistanceFromMe(&botUniverse[0].players[i].point)<SHIPDAMDIST &&
	    botDistanceFromMe(&botUniverse[0].players[i].point)<tractorRange ){
	    if ( botUniverse[0].players[i].armies_suspected ) {
		if ( !(me->p_flags & PFTRACT) || me->p_tractor != i) {
		    sendTractorReq(1, i);
		}
	    }
	    else {
		if ( !(me->p_flags & PFPRESS) || me->p_tractor != i) {
		    sendRepressReq( 1, i );
		}
	    }
	    return;
	}
    }

    if ( shipOrbitting( me ) ) {
	if ( me->p_flags & (PFTRACT | PFPRESS)) {
	    sendRepressReq(0, me->p_no);
	  }
	return;
    }

    maxturn = botMaxTurn( me->p_speed );

    deltaDir = angdist( me->p_dir, direction );

    /* If any enemy is orbitting a planet, tractor him off */
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( isAlive( &players[i] ) && !players[i].p_speed &&
	    !INVISIBLE( &players[i] ) &&
	    !friendlyPlayer( &players[i]) &&
	    pointWithinSquare( &botUniverse[0].players[i].point,
			      &botUniverse[0].players[me->p_no].point,
			      tractorRange) && 
	    botDistanceFromMe( &botUniverse[0].players[i].point ) <
	    tractorRange ) {

	    for (j=MAXPLANETS-1; j>=0; --j ) {
		if (pointWithinSquare( &botUniverse[0].players[i].point,
				      &botUniverse[0].planets[j].point,
				      1000 ) )
		    break;
	    }
	    if ( j>=0 && !(me->p_flags & (PFTRACT | PFPRESS)) ||
		me->p_tractor != i) {
		sendTractorReq(1, i);
		return;
	    }
	}
    }

    if ( me->p_ship.s_type == STARBASE && 
	!(me->p_flags & (PFBEAMUP|PFRED|PFBEAMDOWN|PFORBIT|PFREPAIR) ) ) {
	for (i=MAXPLAYER-1; i>=0; --i) {
	    if ( !isAlive( &players[i] ) ||
		!friendlyPlayer( &players[i] ) ||
		myPlayer( &players[i] ) ||
		INVISIBLE( &players[i] ) ||
		!pointWithinSquare( &botUniverse[0].players[i].point,
				   &botUniverse[0].players[me->p_no].point,
				   tractorRange ) )
		continue;

	    distance = botDistanceFromMe( &botUniverse[0].players[i].point );
	    if ( distance > tractorRange || distance < 1000 )
		continue;

	    angle = botGetAngle( players[i].p_x, players[i].p_y );
	    /* check to see if I want to tractor him */
	    if (angdist( direction, angle ) < 32 && 
		angdist( angle, players[i].p_dir ) > 96 ) {
		sendTractorReq(1, i);
		return;
	    }
		
	    /* check to see if I want to pressor him */
	    if (angdist( direction, angle ) > 96 && 
		angdist( angle, players[i].p_dir ) < 32 ) {
		sendRepressReq(1, i);
		return;
	    }
	}
    }
    
    if ( damage < 30 ) {
	if (me->p_flags & (PFTRACT | PFPRESS))
	    sendTractorReq(0, me->p_no);
	return;
    }

    /* see if there are any enemies we can pressor off of */
    tractorDir = direction;
    pressorDir = NORMALIZE(128 + tractorDir);
	
    bestPressorDir = 128;
    bestTractorDir = 128;
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( isAlive( &players[i] ) && 
	    !INVISIBLE( &players[i] ) &&
	    !friendlyPlayer( &players[i]) &&
	    !myPlayer( &players[i] ) &&
	    pointWithinSquare( &botUniverse[0].players[i].point,
			      &botUniverse[0].players[me->p_no].point,
			      tractorRange) &&
	    botDistanceFromMe( &botUniverse[0].players[i].point ) <
	    tractorRange ) {
	    thisDir = botGetAngle( players[i].p_x, players[i].p_y );
	    
	    if (angdist(thisDir, pressorDir) < bestPressorDir) {
		bestPressorEnemy = i;
		bestPressorDir = angdist(thisDir, pressorDir);
	    }
	    if (angdist(thisDir, tractorDir) < bestTractorDir) {
		bestTractorEnemy = i;
		bestTractorDir = angdist(thisDir, tractorDir);
	    }
	}
    }

    if ( bestPressorDir < 48 ) {
	if ( me->p_tractor != bestPressorEnemy ||
	    !(me->p_flags & (PFTRACT | PFPRESS)) ) {
	    sendRepressReq(1, bestPressorEnemy);
	    return;
	}
    }
    else if ( bestTractorDir < 48 ) {
	if ( !(me->p_flags & (PFTRACT | PFPRESS)) ||
	    me->p_tractor != bestTractorEnemy) {
	    sendTractorReq(1, bestTractorEnemy);
	    return;
	}
    }
    else {
	if ( me->p_flags & (PFTRACT | PFPRESS))
	    sendRepressReq(0, me->p_no);
	return;
    }
}
#else
void botHandleTractorPressor( int *desiredTractor, int *desiredPressor )
{
    int i,j;
    int distance;
    int tractorRange;
    
    *desiredTractor = -1;
    *desiredPressor = -1;
    
    if ( INVISIBLE(me) || !isAlive(me) || shipOrbitting( me )) {
	return;
    }

    tractorRange = TRACTDIST * me->p_ship.s_tractrng - 100.0;

    /* try to tractor enemy with armies */
    if ( !me->p_armies ) {
	for (i=MAXPLAYER-1; i>=0; --i) {
	    if ( friendlyPlayer( &players[i]) ||
		!isAlive( &players[i] ) ||
		INVISIBLE( &players[i] ) ||
		!botUniverse[0].players[i].armies_suspected ||
		!pointWithinSquare( &botUniverse[0].players[i].point,
				   &botUniverse[0].players[me->p_no].point,
				   SHIPDAMDIST + 1000) )
		continue;
	    
	    distance = botDistanceFromMe(&botUniverse[0].players[i].point);
	    
	    if (distance > SHIPDAMDIST + 1000 || distance > tractorRange)
		continue;
	    
	    *desiredTractor = i;
	}
    }
    if ( *desiredPressor >= 0 || *desiredTractor >= 0 )
	return;

    /* Make sure that enemy player will not blow up on me */
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( friendlyPlayer( &players[i]) ||
	    !isAlive( &players[i] ) ||
	    INVISIBLE( &players[i] ) ||
	    botUniverse[0].players[i].armies_suspected ||
	    !pointWithinSquare( &botUniverse[0].players[i].point,
			       &botUniverse[0].players[me->p_no].point,
			       SHIPDAMDIST + 200) )
	    continue;

	distance = botDistanceFromMe(&botUniverse[0].players[i].point);

	if (distance > SHIPDAMDIST + 200 || distance > tractorRange)
	    continue;

	*desiredPressor = i;
    }

    if ( *desiredPressor >= 0 || *desiredTractor >= 0 )
	return;
    
    /* If any enemy is orbitting a planet, tractor him off */
    for (i=MAXPLAYER-1; i>=0; --i) {
	if ( !isAlive( &players[i] ) ||
	    players[i].p_speed ||
	    INVISIBLE( &players[i] ) ||
	    friendlyPlayer( &players[i]) ||
	    !pointWithinSquare( &botUniverse[0].players[i].point,
			       &botUniverse[0].players[me->p_no].point,
			       tractorRange) )
	    continue;

	distance = botDistanceFromMe( &botUniverse[0].players[i].point );

	if ( distance > tractorRange )
	    continue;

	for (j=MAXPLANETS-1; j>=0; --j ) {
	    if (pointWithinSquare( &botUniverse[0].players[i].point,
				  &botUniverse[0].planets[j].point,
				  1000 ) )
		break;
	}
	if (j >= 0 )
	    *desiredTractor = i;
    }
    
    return;
}
#endif

void botHandleCloaking( BOT_STRATEGY *strategy )
{
    int i;
    int cloakStatus = 0;
    double homeWorldDistance;
    double planetDistance;
    struct obtype *target;

    if ( !isAlive( me ) )
	return;
    
    /* only consider cloaking if I'm bombing or taking */
    if ( (strategy->plan != ST_BOMB && strategy->plan != ST_TAKE) ||
	strategy->player >= 0 ) {
	if (shipCloaked( me ))
	    cloak_off();
	return;
    }

    /* definitely cloak when I'm beaming down or bombing a planet */
    if (me->p_flags & (PFBOMB|PFBEAMDOWN)) {
	target = gettarget(mapw, me->p_x * WINSIDE/GWIDTH,
			   me->p_y * WINSIDE/GWIDTH, TARG_PLANET);

	if ( (me->p_flags & PFRED) ||
	    ( corePlanet( &planets[target->o_num] ) &&
	     !myCorePlanet( &planets[target->o_num] ) ) ) {
	    if ( !shipCloaked( me ) )
		cloak_on();
	}
	else
	    cloak_off();
	return;
    }

#if 0
    if ( me->p_flags & PFCLOAK )
	cloak_off();
    return;
#endif

    /*
       First of all, do not cloak when near my homeworld - that seems
       to piss off my clueless teammates */
    homeWorldDistance =
	botDistanceFromMe( &botUniverse[0].planets[(remap[me->p_team]-1)*10].point );

    if ( homeWorldDistance < 25000.0 )
	cloakStatus = 0;
    else {
	if (strategy->planet >= 0 && strategy->planet < MAXPLANETS &&
	    (strategy->plan == ST_TAKE || strategy->plan == ST_BOMB) &&
	    corePlanet( &planets[strategy->planet] ) &&
	    !myCorePlanet( &planets[strategy->planet] ) )
	{
	    planetDistance = 
		botDistanceFromMe( &botUniverse[0].planets[strategy->planet].point );
	    if (planetDistance < 15000.0)
		cloakStatus = 1;
	    else
		cloakStatus = 0;
	}
    }

    if ( cloakStatus ) {
	for (i=MAXPLAYER-1; i>=0 ; --i) {
	    if ( isAlive( &players[i] ) && !friendlyPlayer( &players[i] ) &&
		pointWithinSquare( &botUniverse[0].players[i].point,
				  &botUniverse[0].players[me->p_no].point,
				  7000.0 ) ) {
		return;
	    }
	}
    }
    
    if ( !cloakStatus && shipCloaked( me ) )
	cloak_off();

    if ( cloakStatus && !shipCloaked( me ) )
	cloak_on();

    return;
}

void botMakeDecision()
{
    static BOT_STRATEGY strategy;
    int damage;
    unsigned char direction;
    static int initialized = 0;
    
    if ( !botRecordUniverse() )
	return;

    if ( !initialized || !(botPacketReceived % 15)) {
	initialized = 1;
	botDecideStrategy( &strategy );
    }    

    botHandleWarStatus();
    botHandleShields();
    botHandleTorps( &strategy );
    botHandlePlasmas();
#if 1
    botHandlePhasers( &strategy );
#endif

    botHandleBombBeamDown();
    botHandleRepairBeamUp( &strategy );
    
    damage = botDecideDirection( &strategy, &direction );
    botHandleDets( damage );
#if 0
    botHandleTractorPressor( direction, damage );
#endif
    botHandleCloaking( &strategy );
    botMiscellaneous( &strategy );

    if ( isAlive(me) )
	botPrintStrategy( &strategy );
}
#endif
 
